/* DragDropAction.c generated by valac 0.56.17, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "gala.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>
#include <meta/util.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_DRAG_DROP_ACTION_0_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY,
	GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY,
	GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY,
	GALA_DRAG_DROP_ACTION_NUM_PROPERTIES
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_NUM_SIGNALS
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_NUM_SIGNALS] = {0};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* _hovered;
	gboolean clicked;
	gfloat last_x;
	gfloat last_y;
	ClutterGrab* grab;
	ClutterInputDevice* grabbed_device;
	gulong on_event_id;
};

static gint GalaDragDropAction_private_offset;
static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;
static GeeHashMap* gala_drag_drop_action_destinations;
static GeeHashMap* gala_drag_drop_action_destinations = NULL;
static ClutterActor* gala_drag_drop_action_grabbed_actor;
static ClutterActor* gala_drag_drop_action_grabbed_actor = NULL;

static void gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                           ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
static void _gala_drag_drop_action_release_actor_clutter_actor_destroy (ClutterActor* _sender,
                                                                 gpointer self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                         ClutterActor* destination,
                                         gboolean is_hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                                                ClutterActor* actor);
static gboolean gala_drag_drop_action_real_handle_event (ClutterAction* base,
                                                  ClutterEvent* event);
static gboolean gala_drag_drop_action_is_valid_touch_event (GalaDragDropAction* self,
                                                     ClutterEvent* event);
static void gala_drag_drop_action_grab_actor (GalaDragDropAction* self,
                                       ClutterActor* actor,
                                       ClutterInputDevice* device);
static gboolean gala_drag_drop_action_on_event (GalaDragDropAction* self,
                                         ClutterEvent* event);
static gboolean _gala_drag_drop_action_on_event_clutter_actor_event (ClutterActor* _sender,
                                                              ClutterEvent* event,
                                                              gpointer self);
static void gala_drag_drop_action_ungrab_actor (GalaDragDropAction* self);
static ClutterActor* gala_drag_drop_action_get_hovered (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                       ClutterActor* value);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                         gboolean value);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static GType gala_drag_drop_action_get_type_once (void);
static void _vala_gala_drag_drop_action_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
gala_drag_drop_action_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
	GType gala_drag_drop_action_type_type_id;
	gala_drag_drop_action_type_type_id = g_flags_register_static ("GalaDragDropActionType", values);
	return gala_drag_drop_action_type_type_id;
}

GType
gala_drag_drop_action_type_get_type (void)
{
	static gsize gala_drag_drop_action_type_type_id__once = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__once)) {
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = gala_drag_drop_action_type_get_type_once ();
		g_once_init_leave (&gala_drag_drop_action_type_type_id__once, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__once;
}

static inline gpointer
gala_drag_drop_action_get_instance_private (GalaDragDropAction* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDragDropAction_private_offset);
}

/**
         * Create a new DragDropAction
         *
         * @param type The type of this actor
         * @param id   An ID that marks which sources can be dragged on
         *             which destinations. It has to be the same for all actors that
         *             should be compatible with each other.
         */
GalaDragDropAction*
gala_drag_drop_action_construct (GType object_type,
                                 GalaDragDropActionType type,
                                 const gchar* id)
{
	GalaDragDropAction * self = NULL;
#line 125 "../lib/DragDropAction.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 126 "../lib/DragDropAction.vala"
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", type, "drag-id", id, NULL);
#line 125 "../lib/DragDropAction.vala"
	return self;
#line 193 "DragDropAction.c"
}

GalaDragDropAction*
gala_drag_drop_action_new (GalaDragDropActionType type,
                           const gchar* id)
{
#line 125 "../lib/DragDropAction.vala"
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
#line 202 "DragDropAction.c"
}

static void
gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                      ClutterActor* new_actor)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 135 "../lib/DragDropAction.vala"
	self = (GalaDragDropAction*) base;
#line 136 "../lib/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 136 "../lib/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 136 "../lib/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 220 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 137 "../lib/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 137 "../lib/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 137 "../lib/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 229 "DragDropAction.c"
	}
#line 140 "../lib/DragDropAction.vala"
	if (new_actor != NULL) {
#line 141 "../lib/DragDropAction.vala"
		gala_drag_drop_action_connect_actor (self, new_actor);
#line 235 "DragDropAction.c"
	}
#line 144 "../lib/DragDropAction.vala"
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), new_actor);
#line 239 "DragDropAction.c"
}

static void
_gala_drag_drop_action_release_actor_clutter_actor_destroy (ClutterActor* _sender,
                                                            gpointer self)
{
#line 159 "../lib/DragDropAction.vala"
	gala_drag_drop_action_release_actor ((GalaDragDropAction*) self, _sender);
#line 248 "DragDropAction.c"
}

static void
gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
	GalaDragDropActionType _tmp5_;
	guint _tmp10_;
#line 147 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 147 "../lib/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 148 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 148 "../lib/DragDropAction.vala"
	if ((_tmp0_ & GALA_DRAG_DROP_ACTION_TYPE_SOURCE) == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 266 "DragDropAction.c"
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		GeeLinkedList* _tmp4_;
#line 150 "../lib/DragDropAction.vala"
		_tmp1_ = gala_drag_drop_action_sources;
#line 150 "../lib/DragDropAction.vala"
		_tmp2_ = self->priv->_drag_id;
#line 150 "../lib/DragDropAction.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 150 "../lib/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp3_;
#line 151 "../lib/DragDropAction.vala"
		_tmp4_ = source_list;
#line 151 "../lib/DragDropAction.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, actor);
#line 148 "../lib/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 286 "DragDropAction.c"
	}
#line 154 "../lib/DragDropAction.vala"
	_tmp5_ = self->priv->_drag_type;
#line 154 "../lib/DragDropAction.vala"
	if ((_tmp5_ & GALA_DRAG_DROP_ACTION_TYPE_DESTINATION) == GALA_DRAG_DROP_ACTION_TYPE_DESTINATION) {
#line 292 "DragDropAction.c"
		GeeLinkedList* dest_list = NULL;
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		gpointer _tmp8_;
		GeeLinkedList* _tmp9_;
#line 155 "../lib/DragDropAction.vala"
		_tmp6_ = gala_drag_drop_action_destinations;
#line 155 "../lib/DragDropAction.vala"
		_tmp7_ = self->priv->_drag_id;
#line 155 "../lib/DragDropAction.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 155 "../lib/DragDropAction.vala"
		dest_list = (GeeLinkedList*) _tmp8_;
#line 156 "../lib/DragDropAction.vala"
		_tmp9_ = dest_list;
#line 156 "../lib/DragDropAction.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, actor);
#line 154 "../lib/DragDropAction.vala"
		_g_object_unref0 (dest_list);
#line 312 "DragDropAction.c"
	}
#line 159 "../lib/DragDropAction.vala"
	g_signal_parse_name ("destroy", clutter_actor_get_type (), &_tmp10_, NULL, FALSE);
#line 159 "../lib/DragDropAction.vala"
	g_signal_handlers_disconnect_matched (actor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_drag_drop_action_release_actor_clutter_actor_destroy, self);
#line 318 "DragDropAction.c"
}

static void
gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
	GalaDragDropActionType _tmp10_;
#line 162 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 162 "../lib/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 163 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 163 "../lib/DragDropAction.vala"
	if ((_tmp0_ & GALA_DRAG_DROP_ACTION_TYPE_SOURCE) == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 335 "DragDropAction.c"
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp9_;
#line 165 "../lib/DragDropAction.vala"
		_tmp1_ = gala_drag_drop_action_sources;
#line 165 "../lib/DragDropAction.vala"
		_tmp2_ = self->priv->_drag_id;
#line 165 "../lib/DragDropAction.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 165 "../lib/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp3_;
#line 166 "../lib/DragDropAction.vala"
		_tmp4_ = source_list;
#line 166 "../lib/DragDropAction.vala"
		if (_tmp4_ == NULL) {
#line 354 "DragDropAction.c"
			GeeLinkedList* _tmp5_;
			GeeHashMap* _tmp6_;
			const gchar* _tmp7_;
			GeeLinkedList* _tmp8_;
#line 167 "../lib/DragDropAction.vala"
			_tmp5_ = gee_linked_list_new (clutter_actor_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 167 "../lib/DragDropAction.vala"
			_g_object_unref0 (source_list);
#line 167 "../lib/DragDropAction.vala"
			source_list = _tmp5_;
#line 168 "../lib/DragDropAction.vala"
			_tmp6_ = gala_drag_drop_action_sources;
#line 168 "../lib/DragDropAction.vala"
			_tmp7_ = self->priv->_drag_id;
#line 168 "../lib/DragDropAction.vala"
			_tmp8_ = source_list;
#line 168 "../lib/DragDropAction.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp8_);
#line 373 "DragDropAction.c"
		}
#line 171 "../lib/DragDropAction.vala"
		_tmp9_ = source_list;
#line 171 "../lib/DragDropAction.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, actor);
#line 163 "../lib/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 381 "DragDropAction.c"
	}
#line 174 "../lib/DragDropAction.vala"
	_tmp10_ = self->priv->_drag_type;
#line 174 "../lib/DragDropAction.vala"
	if ((_tmp10_ & GALA_DRAG_DROP_ACTION_TYPE_DESTINATION) == GALA_DRAG_DROP_ACTION_TYPE_DESTINATION) {
#line 387 "DragDropAction.c"
		GeeLinkedList* dest_list = NULL;
		GeeHashMap* _tmp11_;
		const gchar* _tmp12_;
		gpointer _tmp13_;
		GeeLinkedList* _tmp14_;
		GeeLinkedList* _tmp19_;
#line 175 "../lib/DragDropAction.vala"
		_tmp11_ = gala_drag_drop_action_destinations;
#line 175 "../lib/DragDropAction.vala"
		_tmp12_ = self->priv->_drag_id;
#line 175 "../lib/DragDropAction.vala"
		_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
#line 175 "../lib/DragDropAction.vala"
		dest_list = (GeeLinkedList*) _tmp13_;
#line 176 "../lib/DragDropAction.vala"
		_tmp14_ = dest_list;
#line 176 "../lib/DragDropAction.vala"
		if (_tmp14_ == NULL) {
#line 406 "DragDropAction.c"
			GeeLinkedList* _tmp15_;
			GeeHashMap* _tmp16_;
			const gchar* _tmp17_;
			GeeLinkedList* _tmp18_;
#line 177 "../lib/DragDropAction.vala"
			_tmp15_ = gee_linked_list_new (clutter_actor_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 177 "../lib/DragDropAction.vala"
			_g_object_unref0 (dest_list);
#line 177 "../lib/DragDropAction.vala"
			dest_list = _tmp15_;
#line 178 "../lib/DragDropAction.vala"
			_tmp16_ = gala_drag_drop_action_destinations;
#line 178 "../lib/DragDropAction.vala"
			_tmp17_ = self->priv->_drag_id;
#line 178 "../lib/DragDropAction.vala"
			_tmp18_ = dest_list;
#line 178 "../lib/DragDropAction.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, _tmp17_, _tmp18_);
#line 425 "DragDropAction.c"
		}
#line 181 "../lib/DragDropAction.vala"
		_tmp19_ = dest_list;
#line 181 "../lib/DragDropAction.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, actor);
#line 174 "../lib/DragDropAction.vala"
		_g_object_unref0 (dest_list);
#line 433 "DragDropAction.c"
	}
#line 184 "../lib/DragDropAction.vala"
	g_signal_connect_object (actor, "destroy", (GCallback) _gala_drag_drop_action_release_actor_clutter_actor_destroy, self, 0);
#line 437 "DragDropAction.c"
}

static void
gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                    ClutterActor* destination,
                                    gboolean is_hovered)
{
	GalaDragDropAction* _tmp0_;
	GalaDragDropAction* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
#line 187 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 187 "../lib/DragDropAction.vala"
	g_return_if_fail (destination != NULL);
#line 188 "../lib/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_get_drag_drop_action (self, destination);
#line 188 "../lib/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 188 "../lib/DragDropAction.vala"
	_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 188 "../lib/DragDropAction.vala"
	_tmp3_ = _tmp2_;
#line 188 "../lib/DragDropAction.vala"
	g_signal_emit (_tmp1_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, _tmp3_, is_hovered);
#line 188 "../lib/DragDropAction.vala"
	_g_object_unref0 (_tmp1_);
#line 189 "../lib/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, destination, is_hovered);
#line 467 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_real_handle_event (ClutterAction* base,
                                         ClutterEvent* event)
{
	GalaDragDropAction * self;
	GalaDragDropActionType _tmp0_;
	gboolean result;
#line 192 "../lib/DragDropAction.vala"
	self = (GalaDragDropAction*) base;
#line 192 "../lib/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 193 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 193 "../lib/DragDropAction.vala"
	if (!((_tmp0_ & GALA_DRAG_DROP_ACTION_TYPE_SOURCE) == GALA_DRAG_DROP_ACTION_TYPE_SOURCE)) {
#line 194 "../lib/DragDropAction.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 194 "../lib/DragDropAction.vala"
		return result;
#line 489 "DragDropAction.c"
	}
#line 197 "../lib/DragDropAction.vala"
	switch (clutter_event_type (event)) {
#line 197 "../lib/DragDropAction.vala"
		case CLUTTER_BUTTON_PRESS:
#line 197 "../lib/DragDropAction.vala"
		case CLUTTER_TOUCH_BEGIN:
#line 497 "DragDropAction.c"
		{
			ClutterActor* _tmp1_;
			ClutterActor* _tmp2_;
			ClutterActor* _tmp3_;
			ClutterInputDevice* _tmp4_;
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat _tmp5_ = 0.0F;
			gfloat _tmp6_ = 0.0F;
#line 200 "../lib/DragDropAction.vala"
			if (!gala_drag_drop_action_is_valid_touch_event (self, event)) {
#line 201 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_PROPAGATE;
#line 201 "../lib/DragDropAction.vala"
				return result;
#line 513 "DragDropAction.c"
			}
#line 204 "../lib/DragDropAction.vala"
			_tmp1_ = gala_drag_drop_action_grabbed_actor;
#line 204 "../lib/DragDropAction.vala"
			if (_tmp1_ != NULL) {
#line 205 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_PROPAGATE;
#line 205 "../lib/DragDropAction.vala"
				return result;
#line 523 "DragDropAction.c"
			}
#line 208 "../lib/DragDropAction.vala"
			_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 208 "../lib/DragDropAction.vala"
			_tmp3_ = _tmp2_;
#line 208 "../lib/DragDropAction.vala"
			_tmp4_ = clutter_event_get_device (event);
#line 208 "../lib/DragDropAction.vala"
			gala_drag_drop_action_grab_actor (self, _tmp3_, _tmp4_);
#line 209 "../lib/DragDropAction.vala"
			self->priv->clicked = TRUE;
#line 212 "../lib/DragDropAction.vala"
			clutter_event_get_coords (event, &_tmp5_, &_tmp6_);
#line 212 "../lib/DragDropAction.vala"
			x = _tmp5_;
#line 212 "../lib/DragDropAction.vala"
			y = _tmp6_;
#line 214 "../lib/DragDropAction.vala"
			self->priv->last_x = x;
#line 215 "../lib/DragDropAction.vala"
			self->priv->last_y = y;
#line 217 "../lib/DragDropAction.vala"
			result = CLUTTER_EVENT_STOP;
#line 217 "../lib/DragDropAction.vala"
			return result;
#line 549 "DragDropAction.c"
		}
		default:
		{
#line 220 "../lib/DragDropAction.vala"
			break;
#line 555 "DragDropAction.c"
		}
	}
#line 223 "../lib/DragDropAction.vala"
	result = CLUTTER_ACTION_CLASS (gala_drag_drop_action_parent_class)->handle_event (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), event);
#line 223 "../lib/DragDropAction.vala"
	return result;
#line 562 "DragDropAction.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 233 "../lib/DragDropAction.vala"
	return self ? g_object_ref (self) : NULL;
#line 570 "DragDropAction.c"
}

static gboolean
_gala_drag_drop_action_on_event_clutter_actor_event (ClutterActor* _sender,
                                                     ClutterEvent* event,
                                                     gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_on_event ((GalaDragDropAction*) self, event);
#line 234 "../lib/DragDropAction.vala"
	return result;
#line 582 "DragDropAction.c"
}

static void
gala_drag_drop_action_grab_actor (GalaDragDropAction* self,
                                  ClutterActor* actor,
                                  ClutterInputDevice* device)
{
	ClutterActor* _tmp0_;
	ClutterStage* _tmp1_;
	ClutterGrab* _tmp2_;
	ClutterInputDevice* _tmp3_;
	gulong _tmp4_;
#line 226 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 226 "../lib/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 226 "../lib/DragDropAction.vala"
	g_return_if_fail (device != NULL);
#line 227 "../lib/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_grabbed_actor;
#line 227 "../lib/DragDropAction.vala"
	if (_tmp0_ != NULL) {
#line 228 "../lib/DragDropAction.vala"
		g_critical ("DragDropAction.vala:228: Tried to grab an actor with a grab already in" \
" progress");
#line 607 "DragDropAction.c"
	}
#line 231 "../lib/DragDropAction.vala"
	_tmp1_ = clutter_actor_get_stage (actor);
#line 231 "../lib/DragDropAction.vala"
	_tmp2_ = clutter_stage_grab (_tmp1_, actor);
#line 231 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->grab);
#line 231 "../lib/DragDropAction.vala"
	self->priv->grab = _tmp2_;
#line 232 "../lib/DragDropAction.vala"
	gala_drag_drop_action_grabbed_actor = actor;
#line 233 "../lib/DragDropAction.vala"
	_tmp3_ = _g_object_ref0 (device);
#line 233 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->grabbed_device);
#line 233 "../lib/DragDropAction.vala"
	self->priv->grabbed_device = _tmp3_;
#line 234 "../lib/DragDropAction.vala"
	_tmp4_ = g_signal_connect_object (actor, "event", (GCallback) _gala_drag_drop_action_on_event_clutter_actor_event, self, 0);
#line 234 "../lib/DragDropAction.vala"
	self->priv->on_event_id = _tmp4_;
#line 629 "DragDropAction.c"
}

static void
gala_drag_drop_action_ungrab_actor (GalaDragDropAction* self)
{
	gboolean _tmp0_ = FALSE;
	ClutterGrab* _tmp2_;
	ClutterActor* _tmp4_;
#line 237 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 238 "../lib/DragDropAction.vala"
	if (self->priv->on_event_id == ((gulong) 0)) {
#line 238 "../lib/DragDropAction.vala"
		_tmp0_ = TRUE;
#line 644 "DragDropAction.c"
	} else {
		ClutterActor* _tmp1_;
#line 238 "../lib/DragDropAction.vala"
		_tmp1_ = gala_drag_drop_action_grabbed_actor;
#line 238 "../lib/DragDropAction.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 651 "DragDropAction.c"
	}
#line 238 "../lib/DragDropAction.vala"
	if (_tmp0_) {
#line 239 "../lib/DragDropAction.vala"
		return;
#line 657 "DragDropAction.c"
	}
#line 242 "../lib/DragDropAction.vala"
	_tmp2_ = self->priv->grab;
#line 242 "../lib/DragDropAction.vala"
	if (_tmp2_ != NULL) {
#line 663 "DragDropAction.c"
		ClutterGrab* _tmp3_;
#line 243 "../lib/DragDropAction.vala"
		_tmp3_ = self->priv->grab;
#line 243 "../lib/DragDropAction.vala"
		clutter_grab_dismiss (_tmp3_);
#line 244 "../lib/DragDropAction.vala"
		_g_object_unref0 (self->priv->grab);
#line 244 "../lib/DragDropAction.vala"
		self->priv->grab = NULL;
#line 673 "DragDropAction.c"
	}
#line 247 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->grabbed_device);
#line 247 "../lib/DragDropAction.vala"
	self->priv->grabbed_device = NULL;
#line 248 "../lib/DragDropAction.vala"
	_tmp4_ = gala_drag_drop_action_grabbed_actor;
#line 248 "../lib/DragDropAction.vala"
	g_signal_handler_disconnect ((GObject*) _tmp4_, self->priv->on_event_id);
#line 249 "../lib/DragDropAction.vala"
	self->priv->on_event_id = (gulong) 0;
#line 250 "../lib/DragDropAction.vala"
	gala_drag_drop_action_grabbed_actor = NULL;
#line 687 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_on_event (GalaDragDropAction* self,
                                ClutterEvent* event)
{
	ClutterInputDevice* device = NULL;
	ClutterInputDevice* _tmp0_;
	ClutterInputDevice* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	ClutterInputDevice* _tmp4_;
	gboolean result;
#line 253 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "../lib/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 254 "../lib/DragDropAction.vala"
	_tmp0_ = clutter_event_get_device (event);
#line 254 "../lib/DragDropAction.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 254 "../lib/DragDropAction.vala"
	device = _tmp1_;
#line 256 "../lib/DragDropAction.vala"
	_tmp4_ = self->priv->grabbed_device;
#line 256 "../lib/DragDropAction.vala"
	if (_tmp4_ != NULL) {
#line 715 "DragDropAction.c"
		ClutterInputDevice* _tmp5_;
		ClutterInputDevice* _tmp6_;
#line 257 "../lib/DragDropAction.vala"
		_tmp5_ = device;
#line 257 "../lib/DragDropAction.vala"
		_tmp6_ = self->priv->grabbed_device;
#line 257 "../lib/DragDropAction.vala"
		_tmp3_ = _tmp5_ != _tmp6_;
#line 724 "DragDropAction.c"
	} else {
#line 256 "../lib/DragDropAction.vala"
		_tmp3_ = FALSE;
#line 728 "DragDropAction.c"
	}
#line 256 "../lib/DragDropAction.vala"
	if (_tmp3_) {
#line 732 "DragDropAction.c"
		ClutterInputDevice* _tmp7_;
#line 258 "../lib/DragDropAction.vala"
		_tmp7_ = device;
#line 258 "../lib/DragDropAction.vala"
		_tmp2_ = clutter_input_device_get_device_type (_tmp7_) != CLUTTER_KEYBOARD_DEVICE;
#line 738 "DragDropAction.c"
	} else {
#line 256 "../lib/DragDropAction.vala"
		_tmp2_ = FALSE;
#line 742 "DragDropAction.c"
	}
#line 256 "../lib/DragDropAction.vala"
	if (_tmp2_) {
#line 259 "../lib/DragDropAction.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 259 "../lib/DragDropAction.vala"
		_g_object_unref0 (device);
#line 259 "../lib/DragDropAction.vala"
		return result;
#line 752 "DragDropAction.c"
	}
#line 262 "../lib/DragDropAction.vala"
	switch (clutter_event_type (event)) {
#line 262 "../lib/DragDropAction.vala"
		case CLUTTER_KEY_PRESS:
#line 758 "DragDropAction.c"
		{
#line 264 "../lib/DragDropAction.vala"
			if (clutter_event_get_key_symbol (event) == CLUTTER_KEY_Escape) {
#line 265 "../lib/DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 764 "DragDropAction.c"
			}
#line 268 "../lib/DragDropAction.vala"
			result = CLUTTER_EVENT_STOP;
#line 268 "../lib/DragDropAction.vala"
			_g_object_unref0 (device);
#line 268 "../lib/DragDropAction.vala"
			return result;
#line 772 "DragDropAction.c"
		}
#line 262 "../lib/DragDropAction.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 262 "../lib/DragDropAction.vala"
		case CLUTTER_TOUCH_END:
#line 778 "DragDropAction.c"
		{
			gboolean _tmp8_;
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat ex = 0.0F;
			gfloat ey = 0.0F;
			gfloat _tmp10_ = 0.0F;
			gfloat _tmp11_ = 0.0F;
			ClutterActor* _tmp12_;
			ClutterActor* _tmp13_;
			gfloat _tmp14_ = 0.0F;
			gfloat _tmp15_ = 0.0F;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
#line 272 "../lib/DragDropAction.vala"
			if (!gala_drag_drop_action_is_valid_touch_event (self, event)) {
#line 273 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_PROPAGATE;
#line 273 "../lib/DragDropAction.vala"
				_g_object_unref0 (device);
#line 273 "../lib/DragDropAction.vala"
				return result;
#line 803 "DragDropAction.c"
			}
#line 276 "../lib/DragDropAction.vala"
			_tmp8_ = self->priv->_dragging;
#line 276 "../lib/DragDropAction.vala"
			if (_tmp8_) {
#line 809 "DragDropAction.c"
				ClutterActor* _tmp9_;
#line 277 "../lib/DragDropAction.vala"
				_tmp9_ = self->priv->_hovered;
#line 277 "../lib/DragDropAction.vala"
				if (_tmp9_ != NULL) {
#line 278 "../lib/DragDropAction.vala"
					gala_drag_drop_action_finish (self);
#line 279 "../lib/DragDropAction.vala"
					gala_drag_drop_action_set_hovered (self, NULL);
#line 819 "DragDropAction.c"
				} else {
#line 281 "../lib/DragDropAction.vala"
					gala_drag_drop_action_cancel (self);
#line 823 "DragDropAction.c"
				}
#line 284 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_STOP;
#line 284 "../lib/DragDropAction.vala"
				_g_object_unref0 (device);
#line 284 "../lib/DragDropAction.vala"
				return result;
#line 831 "DragDropAction.c"
			}
#line 288 "../lib/DragDropAction.vala"
			clutter_event_get_coords (event, &_tmp10_, &_tmp11_);
#line 288 "../lib/DragDropAction.vala"
			ex = _tmp10_;
#line 288 "../lib/DragDropAction.vala"
			ey = _tmp11_;
#line 289 "../lib/DragDropAction.vala"
			_tmp12_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 289 "../lib/DragDropAction.vala"
			_tmp13_ = _tmp12_;
#line 289 "../lib/DragDropAction.vala"
			clutter_actor_get_transformed_position (_tmp13_, &_tmp14_, &_tmp15_);
#line 289 "../lib/DragDropAction.vala"
			x = _tmp14_;
#line 289 "../lib/DragDropAction.vala"
			y = _tmp15_;
#line 292 "../lib/DragDropAction.vala"
			if (self->priv->clicked) {
#line 292 "../lib/DragDropAction.vala"
				_tmp19_ = x < ex;
#line 853 "DragDropAction.c"
			} else {
#line 292 "../lib/DragDropAction.vala"
				_tmp19_ = FALSE;
#line 857 "DragDropAction.c"
			}
#line 292 "../lib/DragDropAction.vala"
			if (_tmp19_) {
#line 861 "DragDropAction.c"
				ClutterActor* _tmp20_;
				ClutterActor* _tmp21_;
				gfloat _tmp22_;
				gfloat _tmp23_;
#line 292 "../lib/DragDropAction.vala"
				_tmp20_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 292 "../lib/DragDropAction.vala"
				_tmp21_ = _tmp20_;
#line 292 "../lib/DragDropAction.vala"
				_tmp22_ = clutter_actor_get_width (_tmp21_);
#line 292 "../lib/DragDropAction.vala"
				_tmp23_ = _tmp22_;
#line 292 "../lib/DragDropAction.vala"
				_tmp18_ = (x + _tmp23_) > ex;
#line 876 "DragDropAction.c"
			} else {
#line 292 "../lib/DragDropAction.vala"
				_tmp18_ = FALSE;
#line 880 "DragDropAction.c"
			}
#line 292 "../lib/DragDropAction.vala"
			if (_tmp18_) {
#line 292 "../lib/DragDropAction.vala"
				_tmp17_ = y < ey;
#line 886 "DragDropAction.c"
			} else {
#line 292 "../lib/DragDropAction.vala"
				_tmp17_ = FALSE;
#line 890 "DragDropAction.c"
			}
#line 292 "../lib/DragDropAction.vala"
			if (_tmp17_) {
#line 894 "DragDropAction.c"
				ClutterActor* _tmp24_;
				ClutterActor* _tmp25_;
				gfloat _tmp26_;
				gfloat _tmp27_;
#line 292 "../lib/DragDropAction.vala"
				_tmp24_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 292 "../lib/DragDropAction.vala"
				_tmp25_ = _tmp24_;
#line 292 "../lib/DragDropAction.vala"
				_tmp26_ = clutter_actor_get_height (_tmp25_);
#line 292 "../lib/DragDropAction.vala"
				_tmp27_ = _tmp26_;
#line 292 "../lib/DragDropAction.vala"
				_tmp16_ = (y + _tmp27_) > ey;
#line 909 "DragDropAction.c"
			} else {
#line 292 "../lib/DragDropAction.vala"
				_tmp16_ = FALSE;
#line 913 "DragDropAction.c"
			}
#line 292 "../lib/DragDropAction.vala"
			if (_tmp16_) {
#line 917 "DragDropAction.c"
				guint32 _tmp28_ = 0U;
#line 293 "../lib/DragDropAction.vala"
				if (clutter_event_type (event) == CLUTTER_BUTTON_RELEASE) {
#line 293 "../lib/DragDropAction.vala"
					_tmp28_ = clutter_event_get_button (event);
#line 923 "DragDropAction.c"
				} else {
#line 293 "../lib/DragDropAction.vala"
					_tmp28_ = CLUTTER_BUTTON_PRIMARY;
#line 927 "DragDropAction.c"
				}
#line 293 "../lib/DragDropAction.vala"
				g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp28_);
#line 931 "DragDropAction.c"
			}
#line 296 "../lib/DragDropAction.vala"
			if (self->priv->clicked) {
#line 297 "../lib/DragDropAction.vala"
				gala_drag_drop_action_ungrab_actor (self);
#line 298 "../lib/DragDropAction.vala"
				self->priv->clicked = FALSE;
#line 939 "DragDropAction.c"
			}
#line 301 "../lib/DragDropAction.vala"
			result = CLUTTER_EVENT_STOP;
#line 301 "../lib/DragDropAction.vala"
			_g_object_unref0 (device);
#line 301 "../lib/DragDropAction.vala"
			return result;
#line 947 "DragDropAction.c"
		}
#line 262 "../lib/DragDropAction.vala"
		case CLUTTER_MOTION:
#line 262 "../lib/DragDropAction.vala"
		case CLUTTER_TOUCH_UPDATE:
#line 953 "DragDropAction.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat _tmp29_ = 0.0F;
			gfloat _tmp30_ = 0.0F;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_;
#line 305 "../lib/DragDropAction.vala"
			if (!gala_drag_drop_action_is_valid_touch_event (self, event)) {
#line 306 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_PROPAGATE;
#line 306 "../lib/DragDropAction.vala"
				_g_object_unref0 (device);
#line 306 "../lib/DragDropAction.vala"
				return result;
#line 969 "DragDropAction.c"
			}
#line 310 "../lib/DragDropAction.vala"
			clutter_event_get_coords (event, &_tmp29_, &_tmp30_);
#line 310 "../lib/DragDropAction.vala"
			x = _tmp29_;
#line 310 "../lib/DragDropAction.vala"
			y = _tmp30_;
#line 312 "../lib/DragDropAction.vala"
			_tmp32_ = self->priv->_dragging;
#line 312 "../lib/DragDropAction.vala"
			if (!_tmp32_) {
#line 312 "../lib/DragDropAction.vala"
				_tmp31_ = self->priv->clicked;
#line 983 "DragDropAction.c"
			} else {
#line 312 "../lib/DragDropAction.vala"
				_tmp31_ = FALSE;
#line 987 "DragDropAction.c"
			}
#line 312 "../lib/DragDropAction.vala"
			if (_tmp31_) {
#line 991 "DragDropAction.c"
				gint drag_threshold = 0;
				ClutterSettings* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gboolean _tmp36_ = FALSE;
#line 313 "../lib/DragDropAction.vala"
				_tmp33_ = clutter_settings_get_default ();
#line 313 "../lib/DragDropAction.vala"
				g_object_get (_tmp33_, "dnd-drag-threshold", &_tmp34_, NULL);
#line 313 "../lib/DragDropAction.vala"
				_tmp35_ = _tmp34_;
#line 313 "../lib/DragDropAction.vala"
				drag_threshold = _tmp35_;
#line 314 "../lib/DragDropAction.vala"
				if (fabsf (self->priv->last_x - x) > ((gfloat) drag_threshold)) {
#line 314 "../lib/DragDropAction.vala"
					_tmp36_ = TRUE;
#line 1009 "DragDropAction.c"
				} else {
#line 314 "../lib/DragDropAction.vala"
					_tmp36_ = fabsf (self->priv->last_y - y) > ((gfloat) drag_threshold);
#line 1013 "DragDropAction.c"
				}
#line 314 "../lib/DragDropAction.vala"
				if (_tmp36_) {
#line 1017 "DragDropAction.c"
					ClutterActor* _tmp37_ = NULL;
					ClutterActor* _tmp38_;
					ClutterActor* _tmp39_;
					ClutterActor* _tmp40_;
					ClutterInputDevice* _tmp41_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp42_;
					const gchar* _tmp43_;
					gpointer _tmp44_;
					GeeLinkedList* _tmp45_;
#line 315 "../lib/DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, self->priv->last_x, self->priv->last_y, &_tmp37_);
#line 315 "../lib/DragDropAction.vala"
					_tmp38_ = _tmp37_;
#line 315 "../lib/DragDropAction.vala"
					gala_drag_drop_action_set_handle (self, _tmp38_);
#line 315 "../lib/DragDropAction.vala"
					_g_object_unref0 (_tmp38_);
#line 316 "../lib/DragDropAction.vala"
					_tmp39_ = self->priv->_handle;
#line 316 "../lib/DragDropAction.vala"
					if (_tmp39_ == NULL) {
#line 317 "../lib/DragDropAction.vala"
						gala_drag_drop_action_ungrab_actor (self);
#line 318 "../lib/DragDropAction.vala"
						g_critical ("DragDropAction.vala:318: No handle has been returned by the started si" \
"gnal, aborting drag.");
#line 319 "../lib/DragDropAction.vala"
						result = CLUTTER_EVENT_PROPAGATE;
#line 319 "../lib/DragDropAction.vala"
						_g_object_unref0 (device);
#line 319 "../lib/DragDropAction.vala"
						return result;
#line 1050 "DragDropAction.c"
					}
#line 322 "../lib/DragDropAction.vala"
					self->priv->clicked = FALSE;
#line 323 "../lib/DragDropAction.vala"
					gala_drag_drop_action_set_dragging (self, TRUE);
#line 325 "../lib/DragDropAction.vala"
					gala_drag_drop_action_ungrab_actor (self);
#line 326 "../lib/DragDropAction.vala"
					_tmp40_ = self->priv->_handle;
#line 326 "../lib/DragDropAction.vala"
					_tmp41_ = clutter_event_get_device (event);
#line 326 "../lib/DragDropAction.vala"
					gala_drag_drop_action_grab_actor (self, _tmp40_, _tmp41_);
#line 328 "../lib/DragDropAction.vala"
					_tmp42_ = gala_drag_drop_action_sources;
#line 328 "../lib/DragDropAction.vala"
					_tmp43_ = self->priv->_drag_id;
#line 328 "../lib/DragDropAction.vala"
					_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, _tmp43_);
#line 328 "../lib/DragDropAction.vala"
					source_list = (GeeLinkedList*) _tmp44_;
#line 329 "../lib/DragDropAction.vala"
					_tmp45_ = source_list;
#line 329 "../lib/DragDropAction.vala"
					if (_tmp45_ != NULL) {
#line 1076 "DragDropAction.c"
						GeeLinkedList* dest_list = NULL;
						GeeHashMap* _tmp46_;
						const gchar* _tmp47_;
						gpointer _tmp48_;
#line 330 "../lib/DragDropAction.vala"
						_tmp46_ = gala_drag_drop_action_destinations;
#line 330 "../lib/DragDropAction.vala"
						_tmp47_ = self->priv->_drag_id;
#line 330 "../lib/DragDropAction.vala"
						_tmp48_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, _tmp47_);
#line 330 "../lib/DragDropAction.vala"
						dest_list = (GeeLinkedList*) _tmp48_;
#line 1089 "DragDropAction.c"
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp49_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp50_;
							gint _tmp51_;
							gint _tmp52_;
							gint _actor_index = 0;
#line 331 "../lib/DragDropAction.vala"
							_tmp49_ = source_list;
#line 331 "../lib/DragDropAction.vala"
							_actor_list = _tmp49_;
#line 331 "../lib/DragDropAction.vala"
							_tmp50_ = _actor_list;
#line 331 "../lib/DragDropAction.vala"
							_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
#line 331 "../lib/DragDropAction.vala"
							_tmp52_ = _tmp51_;
#line 331 "../lib/DragDropAction.vala"
							_actor_size = _tmp52_;
#line 331 "../lib/DragDropAction.vala"
							_actor_index = -1;
#line 331 "../lib/DragDropAction.vala"
							while (TRUE) {
#line 1114 "DragDropAction.c"
								gint _tmp53_;
								gint _tmp54_;
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp55_;
								gpointer _tmp56_;
								ClutterActor* _tmp57_;
								gboolean _tmp58_ = FALSE;
								GeeLinkedList* _tmp59_;
								ClutterActor* _tmp62_;
#line 331 "../lib/DragDropAction.vala"
								_actor_index = _actor_index + 1;
#line 331 "../lib/DragDropAction.vala"
								_tmp53_ = _actor_index;
#line 331 "../lib/DragDropAction.vala"
								_tmp54_ = _actor_size;
#line 331 "../lib/DragDropAction.vala"
								if (!(_tmp53_ < _tmp54_)) {
#line 331 "../lib/DragDropAction.vala"
									break;
#line 1134 "DragDropAction.c"
								}
#line 331 "../lib/DragDropAction.vala"
								_tmp55_ = _actor_list;
#line 331 "../lib/DragDropAction.vala"
								_tmp56_ = gee_abstract_list_get ((GeeAbstractList*) _tmp55_, _actor_index);
#line 331 "../lib/DragDropAction.vala"
								_tmp57_ = _g_object_ref0 ((ClutterActor*) _tmp56_);
#line 331 "../lib/DragDropAction.vala"
								actor = _tmp57_;
#line 333 "../lib/DragDropAction.vala"
								_tmp59_ = dest_list;
#line 333 "../lib/DragDropAction.vala"
								if (_tmp59_ == NULL) {
#line 333 "../lib/DragDropAction.vala"
									_tmp58_ = TRUE;
#line 1150 "DragDropAction.c"
								} else {
									GeeLinkedList* _tmp60_;
									ClutterActor* _tmp61_;
#line 333 "../lib/DragDropAction.vala"
									_tmp60_ = dest_list;
#line 333 "../lib/DragDropAction.vala"
									_tmp61_ = actor;
#line 333 "../lib/DragDropAction.vala"
									_tmp58_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp60_, _tmp61_);
#line 1160 "DragDropAction.c"
								}
#line 333 "../lib/DragDropAction.vala"
								if (_tmp58_) {
#line 334 "../lib/DragDropAction.vala"
									_g_object_unref0 (actor);
#line 334 "../lib/DragDropAction.vala"
									continue;
#line 1168 "DragDropAction.c"
								}
#line 337 "../lib/DragDropAction.vala"
								_tmp62_ = actor;
#line 337 "../lib/DragDropAction.vala"
								clutter_actor_set_reactive (_tmp62_, FALSE);
#line 331 "../lib/DragDropAction.vala"
								_g_object_unref0 (actor);
#line 1176 "DragDropAction.c"
							}
						}
#line 329 "../lib/DragDropAction.vala"
						_g_object_unref0 (dest_list);
#line 1181 "DragDropAction.c"
					}
#line 314 "../lib/DragDropAction.vala"
					_g_object_unref0 (source_list);
#line 1185 "DragDropAction.c"
				}
#line 341 "../lib/DragDropAction.vala"
				result = CLUTTER_EVENT_STOP;
#line 341 "../lib/DragDropAction.vala"
				_g_object_unref0 (device);
#line 341 "../lib/DragDropAction.vala"
				return result;
#line 1193 "DragDropAction.c"
			} else {
				gboolean _tmp63_;
#line 343 "../lib/DragDropAction.vala"
				_tmp63_ = self->priv->_dragging;
#line 343 "../lib/DragDropAction.vala"
				if (_tmp63_) {
#line 1200 "DragDropAction.c"
					ClutterActor* _tmp64_;
					ClutterActor* _tmp65_;
					gfloat _tmp66_;
					gfloat _tmp67_;
					ClutterActor* _tmp68_;
					ClutterActor* _tmp69_;
					gfloat _tmp70_;
					gfloat _tmp71_;
					ClutterStage* stage = NULL;
					ClutterActor* _tmp72_;
					ClutterActor* _tmp73_;
					ClutterStage* _tmp74_;
					ClutterStage* _tmp75_;
					ClutterActor* actor = NULL;
					ClutterStage* _tmp76_;
					ClutterActor* _tmp77_;
					ClutterActor* _tmp78_;
					GalaDragDropAction* action = NULL;
					gboolean _tmp79_ = FALSE;
					gboolean _tmp80_ = FALSE;
					ClutterActor* _tmp81_;
					ClutterActor* _tmp94_;
					ClutterActor* _tmp95_;
					GalaDragDropAction* _tmp96_;
					ClutterActor* _tmp99_;
					ClutterActor* _tmp101_;
					ClutterActor* _tmp102_;
#line 344 "../lib/DragDropAction.vala"
					_tmp64_ = self->priv->_handle;
#line 344 "../lib/DragDropAction.vala"
					_tmp65_ = self->priv->_handle;
#line 344 "../lib/DragDropAction.vala"
					_tmp66_ = clutter_actor_get_x (_tmp65_);
#line 344 "../lib/DragDropAction.vala"
					_tmp67_ = _tmp66_;
#line 344 "../lib/DragDropAction.vala"
					clutter_actor_set_x (_tmp65_, _tmp67_ - (self->priv->last_x - x));
#line 345 "../lib/DragDropAction.vala"
					_tmp68_ = self->priv->_handle;
#line 345 "../lib/DragDropAction.vala"
					_tmp69_ = self->priv->_handle;
#line 345 "../lib/DragDropAction.vala"
					_tmp70_ = clutter_actor_get_y (_tmp69_);
#line 345 "../lib/DragDropAction.vala"
					_tmp71_ = _tmp70_;
#line 345 "../lib/DragDropAction.vala"
					clutter_actor_set_y (_tmp69_, _tmp71_ - (self->priv->last_y - y));
#line 346 "../lib/DragDropAction.vala"
					self->priv->last_x = x;
#line 347 "../lib/DragDropAction.vala"
					self->priv->last_y = y;
#line 349 "../lib/DragDropAction.vala"
					_tmp72_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 349 "../lib/DragDropAction.vala"
					_tmp73_ = _tmp72_;
#line 349 "../lib/DragDropAction.vala"
					_tmp74_ = clutter_actor_get_stage (_tmp73_);
#line 349 "../lib/DragDropAction.vala"
					_tmp75_ = _g_object_ref0 (_tmp74_);
#line 349 "../lib/DragDropAction.vala"
					stage = _tmp75_;
#line 350 "../lib/DragDropAction.vala"
					_tmp76_ = stage;
#line 350 "../lib/DragDropAction.vala"
					_tmp77_ = clutter_stage_get_actor_at_pos (_tmp76_, CLUTTER_PICK_REACTIVE, (gfloat) ((gint) x), (gfloat) ((gint) y));
#line 350 "../lib/DragDropAction.vala"
					_tmp78_ = _g_object_ref0 (_tmp77_);
#line 350 "../lib/DragDropAction.vala"
					actor = _tmp78_;
#line 351 "../lib/DragDropAction.vala"
					action = NULL;
#line 353 "../lib/DragDropAction.vala"
					_tmp81_ = actor;
#line 353 "../lib/DragDropAction.vala"
					if (_tmp81_ != NULL) {
#line 1276 "DragDropAction.c"
						ClutterActor* _tmp82_;
						GalaDragDropAction* _tmp83_;
						GalaDragDropAction* _tmp84_;
#line 353 "../lib/DragDropAction.vala"
						_tmp82_ = actor;
#line 353 "../lib/DragDropAction.vala"
						_tmp83_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp82_);
#line 353 "../lib/DragDropAction.vala"
						_g_object_unref0 (action);
#line 353 "../lib/DragDropAction.vala"
						action = _tmp83_;
#line 353 "../lib/DragDropAction.vala"
						_tmp84_ = action;
#line 353 "../lib/DragDropAction.vala"
						_tmp80_ = _tmp84_ == NULL;
#line 1292 "DragDropAction.c"
					} else {
#line 353 "../lib/DragDropAction.vala"
						_tmp80_ = FALSE;
#line 1296 "DragDropAction.c"
					}
#line 353 "../lib/DragDropAction.vala"
					if (_tmp80_) {
#line 1300 "DragDropAction.c"
						gboolean _tmp85_;
#line 353 "../lib/DragDropAction.vala"
						_tmp85_ = self->priv->_allow_bubbling;
#line 353 "../lib/DragDropAction.vala"
						_tmp79_ = _tmp85_;
#line 1306 "DragDropAction.c"
					} else {
#line 353 "../lib/DragDropAction.vala"
						_tmp79_ = FALSE;
#line 1310 "DragDropAction.c"
					}
#line 353 "../lib/DragDropAction.vala"
					if (_tmp79_) {
#line 354 "../lib/DragDropAction.vala"
						while (TRUE) {
#line 1316 "DragDropAction.c"
							ClutterActor* _tmp86_;
							ClutterActor* _tmp87_;
							ClutterActor* _tmp88_;
							ClutterActor* _tmp89_;
							ClutterStage* _tmp90_;
							ClutterActor* _tmp91_;
							GalaDragDropAction* _tmp92_;
							GalaDragDropAction* _tmp93_;
#line 354 "../lib/DragDropAction.vala"
							_tmp86_ = actor;
#line 354 "../lib/DragDropAction.vala"
							_tmp87_ = clutter_actor_get_parent (_tmp86_);
#line 354 "../lib/DragDropAction.vala"
							_tmp88_ = _g_object_ref0 (_tmp87_);
#line 354 "../lib/DragDropAction.vala"
							_g_object_unref0 (actor);
#line 354 "../lib/DragDropAction.vala"
							actor = _tmp88_;
#line 354 "../lib/DragDropAction.vala"
							_tmp89_ = actor;
#line 354 "../lib/DragDropAction.vala"
							_tmp90_ = stage;
#line 354 "../lib/DragDropAction.vala"
							if (!(_tmp89_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp90_, clutter_actor_get_type (), ClutterActor))) {
#line 354 "../lib/DragDropAction.vala"
								break;
#line 1343 "DragDropAction.c"
							}
#line 355 "../lib/DragDropAction.vala"
							_tmp91_ = actor;
#line 355 "../lib/DragDropAction.vala"
							_tmp92_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp91_);
#line 355 "../lib/DragDropAction.vala"
							_g_object_unref0 (action);
#line 355 "../lib/DragDropAction.vala"
							action = _tmp92_;
#line 355 "../lib/DragDropAction.vala"
							_tmp93_ = action;
#line 355 "../lib/DragDropAction.vala"
							if (_tmp93_ != NULL) {
#line 356 "../lib/DragDropAction.vala"
								break;
#line 1359 "DragDropAction.c"
							}
						}
					}
#line 361 "../lib/DragDropAction.vala"
					_tmp94_ = actor;
#line 361 "../lib/DragDropAction.vala"
					_tmp95_ = self->priv->_hovered;
#line 361 "../lib/DragDropAction.vala"
					if (_tmp94_ == _tmp95_) {
#line 362 "../lib/DragDropAction.vala"
						result = CLUTTER_EVENT_STOP;
#line 362 "../lib/DragDropAction.vala"
						_g_object_unref0 (action);
#line 362 "../lib/DragDropAction.vala"
						_g_object_unref0 (actor);
#line 362 "../lib/DragDropAction.vala"
						_g_object_unref0 (stage);
#line 362 "../lib/DragDropAction.vala"
						_g_object_unref0 (device);
#line 362 "../lib/DragDropAction.vala"
						return result;
#line 1381 "DragDropAction.c"
					}
#line 364 "../lib/DragDropAction.vala"
					_tmp96_ = action;
#line 364 "../lib/DragDropAction.vala"
					if (_tmp96_ == NULL) {
#line 1387 "DragDropAction.c"
						ClutterActor* _tmp97_;
#line 366 "../lib/DragDropAction.vala"
						_tmp97_ = self->priv->_hovered;
#line 366 "../lib/DragDropAction.vala"
						if (_tmp97_ != NULL) {
#line 1393 "DragDropAction.c"
							ClutterActor* _tmp98_;
#line 367 "../lib/DragDropAction.vala"
							_tmp98_ = self->priv->_hovered;
#line 367 "../lib/DragDropAction.vala"
							gala_drag_drop_action_emit_crossed (self, _tmp98_, FALSE);
#line 368 "../lib/DragDropAction.vala"
							gala_drag_drop_action_set_hovered (self, NULL);
#line 1401 "DragDropAction.c"
						}
#line 371 "../lib/DragDropAction.vala"
						result = CLUTTER_EVENT_STOP;
#line 371 "../lib/DragDropAction.vala"
						_g_object_unref0 (action);
#line 371 "../lib/DragDropAction.vala"
						_g_object_unref0 (actor);
#line 371 "../lib/DragDropAction.vala"
						_g_object_unref0 (stage);
#line 371 "../lib/DragDropAction.vala"
						_g_object_unref0 (device);
#line 371 "../lib/DragDropAction.vala"
						return result;
#line 1415 "DragDropAction.c"
					}
#line 375 "../lib/DragDropAction.vala"
					_tmp99_ = self->priv->_hovered;
#line 375 "../lib/DragDropAction.vala"
					if (_tmp99_ != NULL) {
#line 1421 "DragDropAction.c"
						ClutterActor* _tmp100_;
#line 376 "../lib/DragDropAction.vala"
						_tmp100_ = self->priv->_hovered;
#line 376 "../lib/DragDropAction.vala"
						gala_drag_drop_action_emit_crossed (self, _tmp100_, FALSE);
#line 1427 "DragDropAction.c"
					}
#line 380 "../lib/DragDropAction.vala"
					_tmp101_ = actor;
#line 380 "../lib/DragDropAction.vala"
					gala_drag_drop_action_set_hovered (self, _tmp101_);
#line 381 "../lib/DragDropAction.vala"
					_tmp102_ = self->priv->_hovered;
#line 381 "../lib/DragDropAction.vala"
					gala_drag_drop_action_emit_crossed (self, _tmp102_, TRUE);
#line 383 "../lib/DragDropAction.vala"
					result = CLUTTER_EVENT_STOP;
#line 383 "../lib/DragDropAction.vala"
					_g_object_unref0 (action);
#line 383 "../lib/DragDropAction.vala"
					_g_object_unref0 (actor);
#line 383 "../lib/DragDropAction.vala"
					_g_object_unref0 (stage);
#line 383 "../lib/DragDropAction.vala"
					_g_object_unref0 (device);
#line 383 "../lib/DragDropAction.vala"
					return result;
#line 1449 "DragDropAction.c"
				}
			}
#line 386 "../lib/DragDropAction.vala"
			break;
#line 1454 "DragDropAction.c"
		}
		default:
		{
#line 388 "../lib/DragDropAction.vala"
			break;
#line 1460 "DragDropAction.c"
		}
	}
#line 391 "../lib/DragDropAction.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 391 "../lib/DragDropAction.vala"
	_g_object_unref0 (device);
#line 391 "../lib/DragDropAction.vala"
	return result;
#line 1469 "DragDropAction.c"
}

/**
         * Looks for a DragDropAction instance if this actor has one or NULL.
         * It also checks if it is a DESTINATION and if the id matches
         *
         * @return the DragDropAction instance on this actor or NULL
         */
static GalaDragDropAction*
gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                            ClutterActor* actor)
{
	GalaDragDropAction* drop_action = NULL;
	GList* _tmp0_;
	GalaDragDropAction* result;
#line 400 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 400 "../lib/DragDropAction.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 401 "../lib/DragDropAction.vala"
	drop_action = NULL;
#line 403 "../lib/DragDropAction.vala"
	_tmp0_ = clutter_actor_get_actions (actor);
#line 1493 "DragDropAction.c"
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
#line 403 "../lib/DragDropAction.vala"
		action_collection = _tmp0_;
#line 403 "../lib/DragDropAction.vala"
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1501 "DragDropAction.c"
			ClutterAction* action = NULL;
#line 403 "../lib/DragDropAction.vala"
			action = (ClutterAction*) action_it->data;
#line 1505 "DragDropAction.c"
			{
				ClutterAction* _tmp1_;
				GalaDragDropAction* _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				GalaDragDropAction* _tmp5_;
#line 404 "../lib/DragDropAction.vala"
				_tmp1_ = action;
#line 404 "../lib/DragDropAction.vala"
				_tmp2_ = _g_object_ref0 (GALA_IS_DRAG_DROP_ACTION (_tmp1_) ? ((GalaDragDropAction*) _tmp1_) : NULL);
#line 404 "../lib/DragDropAction.vala"
				_g_object_unref0 (drop_action);
#line 404 "../lib/DragDropAction.vala"
				drop_action = _tmp2_;
#line 405 "../lib/DragDropAction.vala"
				_tmp5_ = drop_action;
#line 405 "../lib/DragDropAction.vala"
				if (_tmp5_ == NULL) {
#line 405 "../lib/DragDropAction.vala"
					_tmp4_ = TRUE;
#line 1526 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp6_;
					GalaDragDropActionType _tmp7_;
#line 406 "../lib/DragDropAction.vala"
					_tmp6_ = drop_action;
#line 406 "../lib/DragDropAction.vala"
					_tmp7_ = _tmp6_->priv->_drag_type;
#line 406 "../lib/DragDropAction.vala"
					_tmp4_ = !((_tmp7_ & GALA_DRAG_DROP_ACTION_TYPE_DESTINATION) == GALA_DRAG_DROP_ACTION_TYPE_DESTINATION);
#line 1536 "DragDropAction.c"
				}
#line 405 "../lib/DragDropAction.vala"
				if (_tmp4_) {
#line 405 "../lib/DragDropAction.vala"
					_tmp3_ = TRUE;
#line 1542 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
#line 407 "../lib/DragDropAction.vala"
					_tmp8_ = drop_action;
#line 407 "../lib/DragDropAction.vala"
					_tmp9_ = _tmp8_->priv->_drag_id;
#line 407 "../lib/DragDropAction.vala"
					_tmp10_ = self->priv->_drag_id;
#line 407 "../lib/DragDropAction.vala"
					_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
#line 1555 "DragDropAction.c"
				}
#line 405 "../lib/DragDropAction.vala"
				if (_tmp3_) {
#line 408 "../lib/DragDropAction.vala"
					continue;
#line 1561 "DragDropAction.c"
				}
#line 410 "../lib/DragDropAction.vala"
				result = drop_action;
#line 410 "../lib/DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 410 "../lib/DragDropAction.vala"
				return result;
#line 1569 "DragDropAction.c"
			}
		}
#line 403 "../lib/DragDropAction.vala"
		(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 1574 "DragDropAction.c"
	}
#line 413 "../lib/DragDropAction.vala"
	result = NULL;
#line 413 "../lib/DragDropAction.vala"
	_g_object_unref0 (drop_action);
#line 413 "../lib/DragDropAction.vala"
	return result;
#line 1582 "DragDropAction.c"
}

/**
         * Abort the drag
         */
void
gala_drag_drop_action_cancel (GalaDragDropAction* self)
{
#line 419 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 420 "../lib/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 422 "../lib/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
#line 1597 "DragDropAction.c"
}

/**
         * Allows you to abort all drags currently running for a given drag-id
         */
void
gala_drag_drop_action_cancel_all_by_id (const gchar* id)
{
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeLinkedList* _tmp2_;
#line 428 "../lib/DragDropAction.vala"
	g_return_if_fail (id != NULL);
#line 429 "../lib/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 429 "../lib/DragDropAction.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
#line 429 "../lib/DragDropAction.vala"
	actors = (GeeLinkedList*) _tmp1_;
#line 430 "../lib/DragDropAction.vala"
	_tmp2_ = actors;
#line 430 "../lib/DragDropAction.vala"
	if (_tmp2_ == NULL) {
#line 431 "../lib/DragDropAction.vala"
		_g_object_unref0 (actors);
#line 431 "../lib/DragDropAction.vala"
		return;
#line 1626 "DragDropAction.c"
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp3_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _actor_index = 0;
#line 433 "../lib/DragDropAction.vala"
		_tmp3_ = actors;
#line 433 "../lib/DragDropAction.vala"
		_actor_list = _tmp3_;
#line 433 "../lib/DragDropAction.vala"
		_tmp4_ = _actor_list;
#line 433 "../lib/DragDropAction.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 433 "../lib/DragDropAction.vala"
		_tmp6_ = _tmp5_;
#line 433 "../lib/DragDropAction.vala"
		_actor_size = _tmp6_;
#line 433 "../lib/DragDropAction.vala"
		_actor_index = -1;
#line 433 "../lib/DragDropAction.vala"
		while (TRUE) {
#line 1652 "DragDropAction.c"
			gint _tmp7_;
			gint _tmp8_;
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp9_;
			gpointer _tmp10_;
			ClutterActor* _tmp11_;
			ClutterActor* _tmp12_;
			GList* _tmp13_;
#line 433 "../lib/DragDropAction.vala"
			_actor_index = _actor_index + 1;
#line 433 "../lib/DragDropAction.vala"
			_tmp7_ = _actor_index;
#line 433 "../lib/DragDropAction.vala"
			_tmp8_ = _actor_size;
#line 433 "../lib/DragDropAction.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 433 "../lib/DragDropAction.vala"
				break;
#line 1671 "DragDropAction.c"
			}
#line 433 "../lib/DragDropAction.vala"
			_tmp9_ = _actor_list;
#line 433 "../lib/DragDropAction.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _actor_index);
#line 433 "../lib/DragDropAction.vala"
			_tmp11_ = _g_object_ref0 ((ClutterActor*) _tmp10_);
#line 433 "../lib/DragDropAction.vala"
			actor = _tmp11_;
#line 434 "../lib/DragDropAction.vala"
			_tmp12_ = actor;
#line 434 "../lib/DragDropAction.vala"
			_tmp13_ = clutter_actor_get_actions (_tmp12_);
#line 1685 "DragDropAction.c"
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
#line 434 "../lib/DragDropAction.vala"
				action_collection = _tmp13_;
#line 434 "../lib/DragDropAction.vala"
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1693 "DragDropAction.c"
					ClutterAction* action = NULL;
#line 434 "../lib/DragDropAction.vala"
					action = (ClutterAction*) action_it->data;
#line 1697 "DragDropAction.c"
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp14_;
						GalaDragDropAction* _tmp15_;
						gboolean _tmp16_ = FALSE;
						GalaDragDropAction* _tmp17_;
#line 435 "../lib/DragDropAction.vala"
						_tmp14_ = action;
#line 435 "../lib/DragDropAction.vala"
						_tmp15_ = _g_object_ref0 (GALA_IS_DRAG_DROP_ACTION (_tmp14_) ? ((GalaDragDropAction*) _tmp14_) : NULL);
#line 435 "../lib/DragDropAction.vala"
						drag_action = _tmp15_;
#line 436 "../lib/DragDropAction.vala"
						_tmp17_ = drag_action;
#line 436 "../lib/DragDropAction.vala"
						if (_tmp17_ != NULL) {
#line 1714 "DragDropAction.c"
							GalaDragDropAction* _tmp18_;
							gboolean _tmp19_;
#line 436 "../lib/DragDropAction.vala"
							_tmp18_ = drag_action;
#line 436 "../lib/DragDropAction.vala"
							_tmp19_ = _tmp18_->priv->_dragging;
#line 436 "../lib/DragDropAction.vala"
							_tmp16_ = _tmp19_;
#line 1723 "DragDropAction.c"
						} else {
#line 436 "../lib/DragDropAction.vala"
							_tmp16_ = FALSE;
#line 1727 "DragDropAction.c"
						}
#line 436 "../lib/DragDropAction.vala"
						if (_tmp16_) {
#line 1731 "DragDropAction.c"
							GalaDragDropAction* _tmp20_;
#line 437 "../lib/DragDropAction.vala"
							_tmp20_ = drag_action;
#line 437 "../lib/DragDropAction.vala"
							gala_drag_drop_action_cancel (_tmp20_);
#line 438 "../lib/DragDropAction.vala"
							_g_object_unref0 (drag_action);
#line 438 "../lib/DragDropAction.vala"
							break;
#line 1741 "DragDropAction.c"
						}
#line 434 "../lib/DragDropAction.vala"
						_g_object_unref0 (drag_action);
#line 1745 "DragDropAction.c"
					}
				}
#line 434 "../lib/DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 1750 "DragDropAction.c"
			}
#line 433 "../lib/DragDropAction.vala"
			_g_object_unref0 (actor);
#line 1754 "DragDropAction.c"
		}
	}
#line 428 "../lib/DragDropAction.vala"
	_g_object_unref0 (actors);
#line 1759 "DragDropAction.c"
}

static void
gala_drag_drop_action_finish (GalaDragDropAction* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 444 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 446 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_hovered;
#line 446 "../lib/DragDropAction.vala"
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
#line 448 "../lib/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 450 "../lib/DragDropAction.vala"
	_tmp1_ = self->priv->_hovered;
#line 450 "../lib/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
#line 1779 "DragDropAction.c"
}

static void
gala_drag_drop_action_cleanup (GalaDragDropAction* self)
{
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp14_;
#line 453 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 454 "../lib/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 454 "../lib/DragDropAction.vala"
	_tmp1_ = self->priv->_drag_id;
#line 454 "../lib/DragDropAction.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 454 "../lib/DragDropAction.vala"
	source_list = (GeeLinkedList*) _tmp2_;
#line 455 "../lib/DragDropAction.vala"
	_tmp3_ = source_list;
#line 455 "../lib/DragDropAction.vala"
	if (_tmp3_ != NULL) {
#line 1805 "DragDropAction.c"
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _actor_index = 0;
#line 456 "../lib/DragDropAction.vala"
			_tmp4_ = source_list;
#line 456 "../lib/DragDropAction.vala"
			_actor_list = _tmp4_;
#line 456 "../lib/DragDropAction.vala"
			_tmp5_ = _actor_list;
#line 456 "../lib/DragDropAction.vala"
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 456 "../lib/DragDropAction.vala"
			_tmp7_ = _tmp6_;
#line 456 "../lib/DragDropAction.vala"
			_actor_size = _tmp7_;
#line 456 "../lib/DragDropAction.vala"
			_actor_index = -1;
#line 456 "../lib/DragDropAction.vala"
			while (TRUE) {
#line 1830 "DragDropAction.c"
				gint _tmp8_;
				gint _tmp9_;
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp10_;
				gpointer _tmp11_;
				ClutterActor* _tmp12_;
				ClutterActor* _tmp13_;
#line 456 "../lib/DragDropAction.vala"
				_actor_index = _actor_index + 1;
#line 456 "../lib/DragDropAction.vala"
				_tmp8_ = _actor_index;
#line 456 "../lib/DragDropAction.vala"
				_tmp9_ = _actor_size;
#line 456 "../lib/DragDropAction.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 456 "../lib/DragDropAction.vala"
					break;
#line 1848 "DragDropAction.c"
				}
#line 456 "../lib/DragDropAction.vala"
				_tmp10_ = _actor_list;
#line 456 "../lib/DragDropAction.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _actor_index);
#line 456 "../lib/DragDropAction.vala"
				_tmp12_ = _g_object_ref0 ((ClutterActor*) _tmp11_);
#line 456 "../lib/DragDropAction.vala"
				actor = _tmp12_;
#line 457 "../lib/DragDropAction.vala"
				_tmp13_ = actor;
#line 457 "../lib/DragDropAction.vala"
				clutter_actor_set_reactive (_tmp13_, TRUE);
#line 456 "../lib/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 1864 "DragDropAction.c"
			}
		}
	}
#line 461 "../lib/DragDropAction.vala"
	_tmp14_ = self->priv->_dragging;
#line 461 "../lib/DragDropAction.vala"
	if (_tmp14_) {
#line 462 "../lib/DragDropAction.vala"
		gala_drag_drop_action_ungrab_actor (self);
#line 1874 "DragDropAction.c"
	}
#line 465 "../lib/DragDropAction.vala"
	gala_drag_drop_action_set_dragging (self, FALSE);
#line 466 "../lib/DragDropAction.vala"
	gala_drag_drop_action_set_handle (self, NULL);
#line 453 "../lib/DragDropAction.vala"
	_g_object_unref0 (source_list);
#line 1882 "DragDropAction.c"
}

static gboolean
gala_drag_drop_action_is_valid_touch_event (GalaDragDropAction* self,
                                            ClutterEvent* event)
{
	ClutterEventType type = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 469 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 469 "../lib/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 470 "../lib/DragDropAction.vala"
	type = clutter_event_type (event);
#line 472 "../lib/DragDropAction.vala"
	if (meta_is_wayland_compositor ()) {
#line 473 "../lib/DragDropAction.vala"
		_tmp0_ = TRUE;
#line 1902 "DragDropAction.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 474 "../lib/DragDropAction.vala"
		if (type != CLUTTER_TOUCH_BEGIN) {
#line 475 "../lib/DragDropAction.vala"
			_tmp3_ = type != CLUTTER_TOUCH_CANCEL;
#line 1911 "DragDropAction.c"
		} else {
#line 474 "../lib/DragDropAction.vala"
			_tmp3_ = FALSE;
#line 1915 "DragDropAction.c"
		}
#line 474 "../lib/DragDropAction.vala"
		if (_tmp3_) {
#line 476 "../lib/DragDropAction.vala"
			_tmp2_ = type != CLUTTER_TOUCH_END;
#line 1921 "DragDropAction.c"
		} else {
#line 474 "../lib/DragDropAction.vala"
			_tmp2_ = FALSE;
#line 1925 "DragDropAction.c"
		}
#line 474 "../lib/DragDropAction.vala"
		if (_tmp2_) {
#line 477 "../lib/DragDropAction.vala"
			_tmp1_ = type != CLUTTER_TOUCH_UPDATE;
#line 1931 "DragDropAction.c"
		} else {
#line 474 "../lib/DragDropAction.vala"
			_tmp1_ = FALSE;
#line 1935 "DragDropAction.c"
		}
#line 474 "../lib/DragDropAction.vala"
		_tmp0_ = _tmp1_;
#line 1939 "DragDropAction.c"
	}
#line 472 "../lib/DragDropAction.vala"
	result = _tmp0_;
#line 472 "../lib/DragDropAction.vala"
	return result;
#line 1945 "DragDropAction.c"
}

GalaDragDropActionType
gala_drag_drop_action_get_drag_type (GalaDragDropAction* self)
{
	GalaDragDropActionType result;
#line 82 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 82 "../lib/DragDropAction.vala"
	result = self->priv->_drag_type;
#line 82 "../lib/DragDropAction.vala"
	return result;
#line 1958 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                     GalaDragDropActionType value)
{
	GalaDragDropActionType old_value;
#line 82 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 82 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_drag_type (self);
#line 82 "../lib/DragDropAction.vala"
	if (old_value != value) {
#line 82 "../lib/DragDropAction.vala"
		self->priv->_drag_type = value;
#line 82 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY]);
#line 1976 "DragDropAction.c"
	}
}

const gchar*
gala_drag_drop_action_get_drag_id (GalaDragDropAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 87 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_id;
#line 87 "../lib/DragDropAction.vala"
	result = _tmp0_;
#line 87 "../lib/DragDropAction.vala"
	return result;
#line 1993 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 87 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 87 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_drag_id (self);
#line 87 "../lib/DragDropAction.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2007 "DragDropAction.c"
		gchar* _tmp0_;
#line 87 "../lib/DragDropAction.vala"
		_tmp0_ = g_strdup (value);
#line 87 "../lib/DragDropAction.vala"
		_g_free0 (self->priv->_drag_id);
#line 87 "../lib/DragDropAction.vala"
		self->priv->_drag_id = _tmp0_;
#line 87 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY]);
#line 2017 "DragDropAction.c"
	}
}

ClutterActor*
gala_drag_drop_action_get_handle (GalaDragDropAction* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 89 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_handle;
#line 89 "../lib/DragDropAction.vala"
	result = _tmp0_;
#line 89 "../lib/DragDropAction.vala"
	return result;
#line 2034 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                  ClutterActor* value)
{
	ClutterActor* old_value;
#line 89 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 89 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_handle (self);
#line 89 "../lib/DragDropAction.vala"
	if (old_value != value) {
#line 2048 "DragDropAction.c"
		ClutterActor* _tmp0_;
#line 89 "../lib/DragDropAction.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 89 "../lib/DragDropAction.vala"
		_g_object_unref0 (self->priv->_handle);
#line 89 "../lib/DragDropAction.vala"
		self->priv->_handle = _tmp0_;
#line 89 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY]);
#line 2058 "DragDropAction.c"
	}
}

gboolean
gala_drag_drop_action_get_dragging (GalaDragDropAction* self)
{
	gboolean result;
#line 93 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../lib/DragDropAction.vala"
	result = self->priv->_dragging;
#line 93 "../lib/DragDropAction.vala"
	return result;
#line 2072 "DragDropAction.c"
}

static void
gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                    gboolean value)
{
	gboolean old_value;
#line 93 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 93 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_dragging (self);
#line 93 "../lib/DragDropAction.vala"
	if (old_value != value) {
#line 93 "../lib/DragDropAction.vala"
		self->priv->_dragging = value;
#line 93 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY]);
#line 2090 "DragDropAction.c"
	}
}

gboolean
gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self)
{
	gboolean result;
#line 99 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../lib/DragDropAction.vala"
	result = self->priv->_allow_bubbling;
#line 99 "../lib/DragDropAction.vala"
	return result;
#line 2104 "DragDropAction.c"
}

void
gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                          gboolean value)
{
	gboolean old_value;
#line 99 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 99 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_allow_bubbling (self);
#line 99 "../lib/DragDropAction.vala"
	if (old_value != value) {
#line 99 "../lib/DragDropAction.vala"
		self->priv->_allow_bubbling = value;
#line 99 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY]);
#line 2122 "DragDropAction.c"
	}
}

static ClutterActor*
gala_drag_drop_action_get_hovered (GalaDragDropAction* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 101 "../lib/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../lib/DragDropAction.vala"
	_tmp0_ = self->priv->_hovered;
#line 101 "../lib/DragDropAction.vala"
	result = _tmp0_;
#line 101 "../lib/DragDropAction.vala"
	return result;
#line 2139 "DragDropAction.c"
}

void
gala_drag_drop_action_set_hovered (GalaDragDropAction* self,
                                   ClutterActor* value)
{
	ClutterActor* old_value;
#line 101 "../lib/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 101 "../lib/DragDropAction.vala"
	old_value = gala_drag_drop_action_get_hovered (self);
#line 101 "../lib/DragDropAction.vala"
	if (old_value != value) {
#line 2153 "DragDropAction.c"
		ClutterActor* _tmp0_;
#line 101 "../lib/DragDropAction.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 101 "../lib/DragDropAction.vala"
		_g_object_unref0 (self->priv->_hovered);
#line 101 "../lib/DragDropAction.vala"
		self->priv->_hovered = _tmp0_;
#line 101 "../lib/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY]);
#line 2163 "DragDropAction.c"
	}
}

static void
g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
#line 27 "../lib/DragDropAction.vala"
	g_return_if_fail (return_value != NULL);
#line 27 "../lib/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "../lib/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../lib/DragDropAction.vala"
		data1 = closure->data;
#line 27 "../lib/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2192 "DragDropAction.c"
	} else {
#line 27 "../lib/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../lib/DragDropAction.vala"
		data2 = closure->data;
#line 2198 "DragDropAction.c"
	}
#line 27 "../lib/DragDropAction.vala"
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 27 "../lib/DragDropAction.vala"
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 27 "../lib/DragDropAction.vala"
	g_value_take_object (return_value, v_return);
#line 2206 "DragDropAction.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "../lib/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "../lib/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../lib/DragDropAction.vala"
		data1 = closure->data;
#line 27 "../lib/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2231 "DragDropAction.c"
	} else {
#line 27 "../lib/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../lib/DragDropAction.vala"
		data2 = closure->data;
#line 2237 "DragDropAction.c"
	}
#line 27 "../lib/DragDropAction.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 27 "../lib/DragDropAction.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 2243 "DragDropAction.c"
}

static void
gala_drag_drop_action_class_init (GalaDragDropActionClass * klass,
                                  gpointer klass_data)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
#line 27 "../lib/DragDropAction.vala"
	g_type_class_adjust_private_offset (klass, &GalaDragDropAction_private_offset);
#line 27 "../lib/DragDropAction.vala"
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta*, ClutterActor*)) gala_drag_drop_action_real_set_actor;
#line 27 "../lib/DragDropAction.vala"
	((ClutterActionClass *) klass)->handle_event = (gboolean (*) (ClutterAction*, ClutterEvent*)) gala_drag_drop_action_real_handle_event;
#line 27 "../lib/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
#line 27 "../lib/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
#line 27 "../lib/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
#line 2266 "DragDropAction.c"
	/**
	         * The type of the action
	         */
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY] = g_param_spec_flags ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2272 "DragDropAction.c"
	/**
	         * The unique id given to this drag-drop-group
	         */
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2280 "DragDropAction.c"
	/**
	         * Indicates whether a drag action is currently active
	         */
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2286 "DragDropAction.c"
	/**
	         * Allow checking the parents of reactive children if they are valid destinations
	         * if the child is none
	         */
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../lib/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY] = g_param_spec_object ("hovered", "hovered", "hovered", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 2295 "DragDropAction.c"
	/**
	         * A drag has been started. You have to connect to this signal and
	         * return an actor that is transformed during the drag operation.
	         *
	         * @param x The global x coordinate where the action was activated
	         * @param y The global y coordinate where the action was activated
	         * @return  A ClutterActor that serves as handle
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 2306 "DragDropAction.c"
	/**
	         * A drag has been canceled. You may want to consider cleaning up
	         * your handle.
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2313 "DragDropAction.c"
	/**
	         * A drag action has successfully been finished.
	         *
	         * @param actor The actor on which the drag finished
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
#line 2321 "DragDropAction.c"
	/**
	         * The destination has been crossed
	         *
	         * @param target the target actor that is crossing the destination
	         * @param hovered indicates whether the actor is now hovered or not
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
#line 2330 "DragDropAction.c"
	/**
	         * Emitted on the source when a destination is crossed.
	         *
	         * @param destination The destination actor that has been crossed
	         * @param hovered     Whether the actor is now hovered or has just been left
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
#line 2339 "DragDropAction.c"
	/**
	         * The source has been clicked, but the movement was not larger than
	         * the drag threshold. Useful if the source is also activable.
	         *
	         * @param button The button which was pressed
	         */
#line 27 "../lib/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 113 "../lib/DragDropAction.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 113 "../lib/DragDropAction.vala"
	_g_object_unref0 (gala_drag_drop_action_sources);
#line 113 "../lib/DragDropAction.vala"
	gala_drag_drop_action_sources = _tmp0_;
#line 114 "../lib/DragDropAction.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 114 "../lib/DragDropAction.vala"
	_g_object_unref0 (gala_drag_drop_action_destinations);
#line 114 "../lib/DragDropAction.vala"
	gala_drag_drop_action_destinations = _tmp1_;
#line 2360 "DragDropAction.c"
}

static void
gala_drag_drop_action_instance_init (GalaDragDropAction * self,
                                     gpointer klass)
{
#line 27 "../lib/DragDropAction.vala"
	self->priv = gala_drag_drop_action_get_instance_private (self);
#line 93 "../lib/DragDropAction.vala"
	self->priv->_dragging = FALSE;
#line 99 "../lib/DragDropAction.vala"
	self->priv->_allow_bubbling = TRUE;
#line 101 "../lib/DragDropAction.vala"
	self->priv->_hovered = NULL;
#line 103 "../lib/DragDropAction.vala"
	self->priv->clicked = FALSE;
#line 107 "../lib/DragDropAction.vala"
	self->priv->grab = NULL;
#line 109 "../lib/DragDropAction.vala"
	self->priv->grabbed_device = NULL;
#line 110 "../lib/DragDropAction.vala"
	self->priv->on_event_id = (gulong) 0;
#line 2383 "DragDropAction.c"
}

static void
gala_drag_drop_action_finalize (GObject * obj)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 27 "../lib/DragDropAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 130 "../lib/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 130 "../lib/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 130 "../lib/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 2400 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 131 "../lib/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 131 "../lib/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 131 "../lib/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 2409 "DragDropAction.c"
	}
#line 87 "../lib/DragDropAction.vala"
	_g_free0 (self->priv->_drag_id);
#line 89 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->_handle);
#line 101 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->_hovered);
#line 107 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->grab);
#line 109 "../lib/DragDropAction.vala"
	_g_object_unref0 (self->priv->grabbed_device);
#line 27 "../lib/DragDropAction.vala"
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
#line 2423 "DragDropAction.c"
}

 G_GNUC_NO_INLINE static GType
gala_drag_drop_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
	GType gala_drag_drop_action_type_id;
	gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
	GalaDragDropAction_private_offset = g_type_add_instance_private (gala_drag_drop_action_type_id, sizeof (GalaDragDropActionPrivate));
	return gala_drag_drop_action_type_id;
}

GType
gala_drag_drop_action_get_type (void)
{
	static gsize gala_drag_drop_action_type_id__once = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__once)) {
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = gala_drag_drop_action_get_type_once ();
		g_once_init_leave (&gala_drag_drop_action_type_id__once, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__once;
}

static void
_vala_gala_drag_drop_action_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 27 "../lib/DragDropAction.vala"
	switch (property_id) {
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_flags (value, gala_drag_drop_action_get_drag_type (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		g_value_set_object (value, gala_drag_drop_action_get_hovered (self));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 2494 "DragDropAction.c"
		default:
#line 27 "../lib/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../lib/DragDropAction.vala"
		break;
#line 2500 "DragDropAction.c"
	}
}

static void
_vala_gala_drag_drop_action_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 27 "../lib/DragDropAction.vala"
	switch (property_id) {
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_drag_type (self, g_value_get_flags (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 27 "../lib/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HOVERED_PROPERTY:
#line 27 "../lib/DragDropAction.vala"
		gala_drag_drop_action_set_hovered (self, g_value_get_object (value));
#line 27 "../lib/DragDropAction.vala"
		break;
#line 2550 "DragDropAction.c"
		default:
#line 27 "../lib/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../lib/DragDropAction.vala"
		break;
#line 2556 "DragDropAction.c"
	}
}

