/* PopupWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PopupWindow.vala, do not modify */

/*
 * Copyright 2017 Adam Bieńkowski
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala-pip.h"
#include <glib.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <clutter/clutter.h>
#include "gala.h"
#include <float.h>
#include <math.h>
#include <meta/window.h>
#include <glib-object.h>
#include <graphene-gobject.h>
#include <meta/common.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <mtk/mtk.h>

#define GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT ((guint) 200)
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE 0.1f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE 1.0f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN 0
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT 0.5f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS 80
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_0_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS
};
static guint gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS] = {0};

struct _GalaPluginsPIPPopupWindowPrivate {
	gint button_size;
	gint container_margin;
	MetaDisplay* _display;
	MetaWindowActor* _window_actor;
	ClutterClone* clone;
	ClutterActor* clone_container;
	ClutterActor* container;
	GalaCloseButton* close_button;
	ClutterActor* resize_button;
	GalaDragDropAction* move_action;
	gfloat begin_resize_width;
	gfloat begin_resize_height;
	gfloat resize_start_x;
	gfloat resize_start_y;
	gboolean resizing;
	gboolean off_screen;
	ClutterGrab* grab;
};

struct _Block4Data {
	int _ref_count_;
	GalaPluginsPIPPopupWindow* self;
	gulong completed_id;
};

static gint GalaPluginsPIPPopupWindow_private_offset;
static gpointer gala_plugins_pip_popup_window_parent_class = NULL;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus = NULL;

static void gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                                    gfloat src_height,
                                                                    gfloat max_width,
                                                                    gfloat max_height,
                                                                    gfloat* width,
                                                                    gfloat* height);
static gboolean gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window);
static void gala_plugins_pip_popup_window_real_show (ClutterActor* base);
static void gala_plugins_pip_popup_window_real_hide (ClutterActor* base);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda4_ (Block4Data* _data4_);
static void ____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                       gpointer self);
static gboolean gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                         ClutterEvent* event);
static void gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self);
static ClutterActor* gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                               ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                                        ClutterEvent* event);
static gboolean _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                             ClutterEvent* event,
                                                                             gpointer self);
static void gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self);
static gboolean __lambda5_ (GalaPluginsPIPPopupWindow* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                           gfloat* width,
                                                           gfloat* height);
static void gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                             MtkRectangle* rect);
static gboolean gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                                  gfloat coord,
                                                                  ClutterOrientation axis);
static void gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self);
static GObject * gala_plugins_pip_popup_window_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static ClutterActor* _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                                             gfloat x,
                                                                                             gfloat y,
                                                                                             gpointer self);
static void _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                     gpointer self);
static void _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                                  guint32 button,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                        guint32 timestamp,
                                                                                        gpointer self);
static gboolean _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                                 ClutterEvent* event,
                                                                                                 gpointer self);
static void _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                         gpointer self);
static void gala_plugins_pip_popup_window_finalize (GObject * obj);
static GType gala_plugins_pip_popup_window_get_type_once (void);
static void _vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
gala_plugins_pip_popup_window_get_instance_private (GalaPluginsPIPPopupWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginsPIPPopupWindow_private_offset);
}

static void
gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                               gfloat src_height,
                                                               gfloat max_width,
                                                               gfloat max_height,
                                                               gfloat* width,
                                                               gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	gfloat ratio = 0.0F;
#line 43 "../plugins/pip/PopupWindow.vala"
	ratio = MIN (max_width / src_width, max_height / src_height);
#line 44 "../plugins/pip/PopupWindow.vala"
	_vala_width = src_width * ratio;
#line 45 "../plugins/pip/PopupWindow.vala"
	_vala_height = src_height * ratio;
#line 41 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 203 "PopupWindow.c"
	}
#line 41 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 209 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window)
{
	MetaWindowType window_type = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 48 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 49 "../plugins/pip/PopupWindow.vala"
	window_type = meta_window_get_window_type (window);
#line 50 "../plugins/pip/PopupWindow.vala"
	if (window_type == META_WINDOW_NORMAL) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = TRUE;
#line 228 "PopupWindow.c"
	} else {
#line 51 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = window_type == META_WINDOW_DIALOG;
#line 232 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	if (_tmp1_) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 238 "PopupWindow.c"
	} else {
#line 52 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = window_type == META_WINDOW_MODAL_DIALOG;
#line 242 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 50 "../plugins/pip/PopupWindow.vala"
	return result;
#line 248 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_construct (GType object_type,
                                         MetaDisplay* display,
                                         MetaWindowActor* window_actor)
{
	GalaPluginsPIPPopupWindow * self = NULL;
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window_actor != NULL, NULL);
#line 56 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) g_object_new (object_type, "display", display, "window-actor", window_actor, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	return self;
#line 265 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_new (MetaDisplay* display,
                                   MetaWindowActor* window_actor)
{
#line 55 "../plugins/pip/PopupWindow.vala"
	return gala_plugins_pip_popup_window_construct (GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, display, window_actor);
#line 274 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_show (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
#line 139 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 140 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 142 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 144 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 145 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, animations_settings_get_animation_duration ((guint) 200));
#line 146 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 147 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 295 "PopupWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 159 "../plugins/pip/PopupWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 159 "../plugins/pip/PopupWindow.vala"
	return _data4_;
#line 305 "PopupWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 159 "../plugins/pip/PopupWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 315 "PopupWindow.c"
		GalaPluginsPIPPopupWindow* self;
#line 159 "../plugins/pip/PopupWindow.vala"
		self = _data4_->self;
#line 159 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self);
#line 159 "../plugins/pip/PopupWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 323 "PopupWindow.c"
	}
}

static void
___lambda4_ (Block4Data* _data4_)
{
	GalaPluginsPIPPopupWindow* self;
#line 163 "../plugins/pip/PopupWindow.vala"
	self = _data4_->self;
#line 164 "../plugins/pip/PopupWindow.vala"
	g_signal_handler_disconnect ((GObject*) self, _data4_->completed_id);
#line 165 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 337 "PopupWindow.c"
}

static void
____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                  gpointer self)
{
#line 163 "../plugins/pip/PopupWindow.vala"
	___lambda4_ (self);
#line 346 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_hide (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
#line 150 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 151 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 153 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 200);
#line 154 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 155 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 156 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 157 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 159 "../plugins/pip/PopupWindow.vala"
	if (duration == ((guint) 0)) {
#line 160 "../plugins/pip/PopupWindow.vala"
		CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 372 "PopupWindow.c"
	} else {
		Block4Data* _data4_;
		gulong _tmp0_;
#line 159 "../plugins/pip/PopupWindow.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 159 "../plugins/pip/PopupWindow.vala"
		_data4_->_ref_count_ = 1;
#line 159 "../plugins/pip/PopupWindow.vala"
		_data4_->self = g_object_ref (self);
#line 162 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = (gulong) 0;
#line 163 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = g_signal_connect_data ((ClutterActor*) self, "transitions-completed", (GCallback) ____lambda4__clutter_actor_transitions_completed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 163 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = _tmp0_;
#line 159 "../plugins/pip/PopupWindow.vala"
		block4_data_unref (_data4_);
#line 159 "../plugins/pip/PopupWindow.vala"
		_data4_ = NULL;
#line 392 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
	GalaCloseButton* _tmp0_;
	GalaCloseButton* _tmp1_;
	GalaCloseButton* _tmp2_;
	GalaCloseButton* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	gboolean result;
#line 171 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 171 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 175 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 177 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->close_button;
#line 177 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp0_);
#line 178 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->close_button;
#line 178 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp1_, duration);
#line 179 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->close_button;
#line 179 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp2_, (guint) 255);
#line 180 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = self->priv->close_button;
#line 180 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp3_);
#line 182 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->resize_button;
#line 182 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp4_);
#line 183 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->resize_button;
#line 183 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp5_, duration);
#line 184 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->resize_button;
#line 184 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp6_, (guint) 255);
#line 185 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 185 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp7_);
#line 187 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 187 "../plugins/pip/PopupWindow.vala"
	return result;
#line 453 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	guint duration = 0U;
	GalaCloseButton* _tmp0_;
	GalaCloseButton* _tmp1_;
	GalaCloseButton* _tmp2_;
	GalaCloseButton* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	gboolean result;
#line 191 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 191 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 195 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 197 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->close_button;
#line 197 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp0_);
#line 198 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->close_button;
#line 198 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp1_, duration);
#line 199 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->close_button;
#line 199 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp2_, (guint) 0);
#line 200 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = self->priv->close_button;
#line 200 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp3_);
#line 202 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->resize_button;
#line 202 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp4_);
#line 203 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->resize_button;
#line 203 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp5_, duration);
#line 204 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->resize_button;
#line 204 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp6_, (guint) 0);
#line 205 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 205 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp7_);
#line 207 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 207 "../plugins/pip/PopupWindow.vala"
	return result;
#line 513 "PopupWindow.c"
}

void
gala_plugins_pip_popup_window_set_container_clip (GalaPluginsPIPPopupWindow* self,
                                                  graphene_rect_t* container_clip)
{
	ClutterActor* _tmp0_;
	graphene_rect_t _tmp1_;
#line 210 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 211 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 211 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = *container_clip;
#line 211 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp0_, "clip-rect", &_tmp1_, NULL);
#line 212 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 213 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed (self);
#line 534 "PopupWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 219 "../plugins/pip/PopupWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 542 "PopupWindow.c"
}

static ClutterActor*
gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* result;
#line 216 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 217 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp0_, META_CURSOR_DND_IN_DRAG);
#line 219 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = _g_object_ref0 ((ClutterActor*) self);
#line 219 "../plugins/pip/PopupWindow.vala"
	result = _tmp1_;
#line 219 "../plugins/pip/PopupWindow.vala"
	return result;
#line 563 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* _tmp0_;
#line 222 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 223 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 224 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 225 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 225 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp0_, META_CURSOR_DEFAULT);
#line 580 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                    ClutterEvent* event,
                                                                    gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_event ((GalaPluginsPIPPopupWindow*) self, event);
#line 245 "../plugins/pip/PopupWindow.vala"
	return result;
#line 592 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                      ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	ClutterActor* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterActor* _tmp11_;
	MetaDisplay* _tmp12_;
	gboolean result;
#line 229 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 233 "../plugins/pip/PopupWindow.vala"
	if (self->priv->resizing) {
#line 233 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 621 "PopupWindow.c"
	} else {
#line 233 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = clutter_event_get_button (event) != CLUTTER_BUTTON_PRIMARY;
#line 625 "PopupWindow.c"
	}
#line 233 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_) {
#line 234 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 234 "../plugins/pip/PopupWindow.vala"
		return result;
#line 633 "PopupWindow.c"
	}
#line 237 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = TRUE;
#line 239 "../plugins/pip/PopupWindow.vala"
	clutter_event_get_coords (event, &_tmp1_, &_tmp2_);
#line 239 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = _tmp1_;
#line 239 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = _tmp2_;
#line 241 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = clutter_actor_get_width ((ClutterActor*) self);
#line 241 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = _tmp3_;
#line 241 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = _tmp4_;
#line 242 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_height ((ClutterActor*) self);
#line 242 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 242 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = _tmp6_;
#line 244 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 244 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = clutter_actor_get_stage (_tmp7_);
#line 244 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 244 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = clutter_stage_grab (_tmp8_, _tmp9_);
#line 244 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 244 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = _tmp10_;
#line 245 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 245 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp11_, "event", (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self, 0);
#line 247 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->_display;
#line 247 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp12_, META_CURSOR_SE_RESIZE);
#line 249 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 249 "../plugins/pip/PopupWindow.vala"
	return result;
#line 679 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                               ClutterEvent* event)
{
	gboolean result;
#line 252 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 252 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 253 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 254 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 254 "../plugins/pip/PopupWindow.vala"
		return result;
#line 697 "PopupWindow.c"
	}
#line 257 "../plugins/pip/PopupWindow.vala"
	switch (clutter_event_type (event)) {
#line 257 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_MOTION:
#line 703 "PopupWindow.c"
		{
			ClutterModifierType mods = 0U;
			gfloat event_x = 0.0F;
			gfloat event_y = 0.0F;
			gfloat _tmp0_ = 0.0F;
			gfloat _tmp1_ = 0.0F;
			gfloat diff_x = 0.0F;
			gfloat diff_y = 0.0F;
#line 259 "../plugins/pip/PopupWindow.vala"
			mods = clutter_event_get_state (event);
#line 260 "../plugins/pip/PopupWindow.vala"
			if (!((mods & CLUTTER_BUTTON1_MASK) == CLUTTER_BUTTON1_MASK)) {
#line 261 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 262 "../plugins/pip/PopupWindow.vala"
				break;
#line 720 "PopupWindow.c"
			}
#line 266 "../plugins/pip/PopupWindow.vala"
			clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 266 "../plugins/pip/PopupWindow.vala"
			event_x = _tmp0_;
#line 266 "../plugins/pip/PopupWindow.vala"
			event_y = _tmp1_;
#line 267 "../plugins/pip/PopupWindow.vala"
			diff_x = event_x - self->priv->resize_start_x;
#line 268 "../plugins/pip/PopupWindow.vala"
			diff_y = event_y - self->priv->resize_start_y;
#line 270 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_width ((ClutterActor*) self, self->priv->begin_resize_width + diff_x);
#line 271 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_height ((ClutterActor*) self, self->priv->begin_resize_height + diff_y);
#line 273 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 274 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_size (self);
#line 276 "../plugins/pip/PopupWindow.vala"
			break;
#line 742 "PopupWindow.c"
		}
#line 257 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 746 "PopupWindow.c"
		{
#line 278 "../plugins/pip/PopupWindow.vala"
			if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 279 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 752 "PopupWindow.c"
			}
#line 282 "../plugins/pip/PopupWindow.vala"
			break;
#line 756 "PopupWindow.c"
		}
#line 257 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_LEAVE:
#line 257 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_ENTER:
#line 762 "PopupWindow.c"
		{
#line 285 "../plugins/pip/PopupWindow.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 285 "../plugins/pip/PopupWindow.vala"
			return result;
#line 768 "PopupWindow.c"
		}
		default:
		{
#line 287 "../plugins/pip/PopupWindow.vala"
			break;
#line 774 "PopupWindow.c"
		}
	}
#line 290 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_STOP;
#line 290 "../plugins/pip/PopupWindow.vala"
	return result;
#line 781 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self)
{
	ClutterGrab* _tmp0_;
	MetaDisplay* _tmp4_;
#line 293 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 294 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 295 "../plugins/pip/PopupWindow.vala"
		return;
#line 795 "PopupWindow.c"
	}
#line 298 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->grab;
#line 298 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_ != NULL) {
#line 801 "PopupWindow.c"
		ClutterGrab* _tmp1_;
		ClutterActor* _tmp2_;
		guint _tmp3_;
#line 299 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = self->priv->grab;
#line 299 "../plugins/pip/PopupWindow.vala"
		clutter_grab_dismiss (_tmp1_);
#line 300 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = self->priv->resize_button;
#line 300 "../plugins/pip/PopupWindow.vala"
		g_signal_parse_name ("event", clutter_actor_get_type (), &_tmp3_, NULL, FALSE);
#line 300 "../plugins/pip/PopupWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self);
#line 301 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->grab);
#line 301 "../plugins/pip/PopupWindow.vala"
		self->priv->grab = NULL;
#line 819 "PopupWindow.c"
	}
#line 304 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 306 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 308 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_display;
#line 308 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp4_, META_CURSOR_DEFAULT);
#line 829 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self)
{
#line 311 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 312 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 313 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 841 "PopupWindow.c"
}

static gboolean
__lambda5_ (GalaPluginsPIPPopupWindow* self)
{
	gboolean result;
#line 325 "../plugins/pip/PopupWindow.vala"
	g_signal_emit (self, gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL], 0);
#line 326 "../plugins/pip/PopupWindow.vala"
	result = G_SOURCE_REMOVE;
#line 326 "../plugins/pip/PopupWindow.vala"
	return result;
#line 854 "PopupWindow.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((GalaPluginsPIPPopupWindow*) self);
#line 324 "../plugins/pip/PopupWindow.vala"
	return result;
#line 864 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self)
{
	guint duration = 0U;
#line 316 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 317 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration (GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT);
#line 319 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 320 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 321 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 322 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 324 "../plugins/pip/PopupWindow.vala"
	clutter_threads_add_timeout (duration, ___lambda5__gsource_func, self);
#line 885 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self)
{
	MetaWindow* focus_window = NULL;
	MetaDisplay* _tmp0_;
	MetaWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindow* _tmp4_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp10_;
	MetaWorkspaceManager* _tmp11_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp12_;
	MetaWorkspace* _tmp13_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp14_;
	MetaWindow* _tmp15_;
	gboolean _tmp16_ = FALSE;
	MetaWindow* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	MetaWindow* _tmp23_;
#line 330 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 331 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 331 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_display_get_focus_window (_tmp0_);
#line 331 "../plugins/pip/PopupWindow.vala"
	focus_window = _tmp1_;
#line 332 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = focus_window;
#line 332 "../plugins/pip/PopupWindow.vala"
	if (_tmp4_ != NULL) {
#line 923 "PopupWindow.c"
		MetaWindow* _tmp5_;
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp5_ = focus_window;
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp5_);
#line 929 "PopupWindow.c"
	} else {
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = FALSE;
#line 933 "PopupWindow.c"
	}
#line 332 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = TRUE;
#line 939 "PopupWindow.c"
	} else {
		gboolean _tmp6_ = FALSE;
		MetaWindow* _tmp7_;
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = gala_plugins_pip_popup_window_previous_focus;
#line 333 "../plugins/pip/PopupWindow.vala"
		if (_tmp7_ != NULL) {
#line 947 "PopupWindow.c"
			MetaWindow* _tmp8_;
#line 333 "../plugins/pip/PopupWindow.vala"
			_tmp8_ = gala_plugins_pip_popup_window_previous_focus;
#line 333 "../plugins/pip/PopupWindow.vala"
			_tmp6_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp8_);
#line 953 "PopupWindow.c"
		} else {
#line 333 "../plugins/pip/PopupWindow.vala"
			_tmp6_ = FALSE;
#line 957 "PopupWindow.c"
		}
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _tmp6_;
#line 961 "PopupWindow.c"
	}
#line 332 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 965 "PopupWindow.c"
		MetaWindow* _tmp9_;
#line 334 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = focus_window;
#line 334 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_previous_focus = _tmp9_;
#line 335 "../plugins/pip/PopupWindow.vala"
		return;
#line 973 "PopupWindow.c"
	}
#line 338 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->_display;
#line 338 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = meta_display_get_workspace_manager (_tmp10_);
#line 338 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp11_;
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = workspace_manager;
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 339 "../plugins/pip/PopupWindow.vala"
	active_workspace = _tmp13_;
#line 340 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->_window_actor;
#line 340 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = meta_window_actor_get_meta_window (_tmp14_);
#line 340 "../plugins/pip/PopupWindow.vala"
	window = _tmp15_;
#line 342 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = window;
#line 342 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp17_, "appears-focused", &_tmp18_, NULL);
#line 342 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = _tmp18_;
#line 342 "../plugins/pip/PopupWindow.vala"
	if (_tmp19_) {
#line 1001 "PopupWindow.c"
		MetaWindow* _tmp20_;
		MetaWorkspace* _tmp21_;
#line 342 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = window;
#line 342 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = active_workspace;
#line 342 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = meta_window_located_on_workspace (_tmp20_, _tmp21_);
#line 1010 "PopupWindow.c"
	} else {
#line 342 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = FALSE;
#line 1014 "PopupWindow.c"
	}
#line 342 "../plugins/pip/PopupWindow.vala"
	if (_tmp16_) {
#line 343 "../plugins/pip/PopupWindow.vala"
		clutter_actor_hide ((ClutterActor*) self);
#line 1020 "PopupWindow.c"
	} else {
		MetaWindowActor* _tmp22_;
#line 344 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = self->priv->_window_actor;
#line 344 "../plugins/pip/PopupWindow.vala"
		if (!meta_window_actor_is_destroyed (_tmp22_)) {
#line 345 "../plugins/pip/PopupWindow.vala"
			clutter_actor_show ((ClutterActor*) self);
#line 1029 "PopupWindow.c"
		}
	}
#line 348 "../plugins/pip/PopupWindow.vala"
	_tmp23_ = focus_window;
#line 348 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_previous_focus = _tmp23_;
#line 1036 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self)
{
	gint clone_container_width = 0;
	gint clone_container_height = 0;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClutterActor* _tmp24_;
	ClutterActor* _tmp25_;
#line 351 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 354 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 354 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 354 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 354 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1059 "PopupWindow.c"
		gfloat src_width = 0.0F;
		gfloat src_height = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		ClutterActor* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 355 "../plugins/pip/PopupWindow.vala"
		src_width = 0.0f;
#line 355 "../plugins/pip/PopupWindow.vala"
		src_height = 0.0f;
#line 356 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 356 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 356 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 356 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 357 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp6_, "scale-x", &_tmp7_, NULL);
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 357 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (src_width * _tmp8_);
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 358 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp9_, "scale-y", &_tmp10_, NULL);
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 358 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (src_height * _tmp11_);
#line 1099 "PopupWindow.c"
	} else {
		ClutterActor* _tmp12_;
		gfloat _tmp13_;
		gfloat _tmp14_;
		ClutterActor* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ClutterActor* _tmp18_;
		gfloat _tmp19_;
		gfloat _tmp20_;
		ClutterActor* _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
#line 360 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = self->priv->clone_container;
#line 360 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = clutter_actor_get_width (_tmp12_);
#line 360 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = _tmp13_;
#line 360 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = self->priv->clone_container;
#line 360 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp15_, "scale-x", &_tmp16_, NULL);
#line 360 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 360 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (_tmp14_ * _tmp17_);
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = self->priv->clone_container;
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp19_ = clutter_actor_get_height (_tmp18_);
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = _tmp19_;
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = self->priv->clone_container;
#line 361 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp21_, "scale-y", &_tmp22_, NULL);
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = _tmp22_;
#line 361 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (_tmp20_ * _tmp23_);
#line 1141 "PopupWindow.c"
	}
#line 364 "../plugins/pip/PopupWindow.vala"
	_tmp24_ = self->priv->container;
#line 364 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width (_tmp24_, (gfloat) clone_container_width);
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = self->priv->container;
#line 365 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height (_tmp25_, (gfloat) clone_container_height);
#line 367 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) (clone_container_width + self->priv->button_size));
#line 368 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) (clone_container_height + self->priv->button_size));
#line 1155 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle rect = {0};
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle _tmp2_ = {0};
	gfloat x_offset = 0.0F;
	MtkRectangle _tmp3_;
	MetaWindowActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat y_offset = 0.0F;
	MtkRectangle _tmp7_;
	MetaWindowActor* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	ClutterClone* _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	ClutterClone* _tmp14_;
	ClutterActor* _tmp15_;
	MtkRectangle _tmp16_;
	MtkRectangle _tmp17_;
#line 374 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 375 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 375 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 375 "../plugins/pip/PopupWindow.vala"
	meta_window_get_frame_rect (_tmp1_, &_tmp2_);
#line 375 "../plugins/pip/PopupWindow.vala"
	rect = _tmp2_;
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = rect;
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_x ((ClutterActor*) _tmp4_);
#line 377 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 377 "../plugins/pip/PopupWindow.vala"
	x_offset = _tmp3_.x - _tmp6_;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = rect;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->_window_actor;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_y ((ClutterActor*) _tmp8_);
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 378 "../plugins/pip/PopupWindow.vala"
	y_offset = _tmp7_.y - _tmp10_;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->clone;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = rect;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = rect;
#line 379 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_clip ((ClutterActor*) _tmp11_, x_offset, y_offset, (gfloat) _tmp12_.width, (gfloat) _tmp13_.height);
#line 380 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->clone;
#line 380 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) _tmp14_, -x_offset, -y_offset);
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->clone_container;
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = rect;
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = rect;
#line 382 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_size (_tmp15_, (gfloat) _tmp16_.width, (gfloat) _tmp17_.height);
#line 1232 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self)
{
	gfloat src_width = 0.0F;
	gfloat src_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gfloat max_width = 0.0F;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat max_height = 0.0F;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat new_width = 0.0F;
	gfloat new_height = 0.0F;
	gfloat _tmp16_ = 0.0F;
	gfloat _tmp17_ = 0.0F;
	gfloat window_width = 0.0F;
	gfloat window_height = 0.0F;
	gfloat _tmp18_ = 0.0F;
	gfloat _tmp19_ = 0.0F;
	gfloat new_scale_x = 0.0F;
	gfloat new_scale_y = 0.0F;
	ClutterActor* _tmp20_;
	ClutterActor* _tmp21_;
#line 385 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 386 "../plugins/pip/PopupWindow.vala"
	src_width = 1.0f;
#line 386 "../plugins/pip/PopupWindow.vala"
	src_height = 1.0f;
#line 387 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 387 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 387 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 387 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1275 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 388 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 388 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 388 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 388 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 1287 "PopupWindow.c"
	} else {
		ClutterActor* _tmp6_;
		gfloat _tmp7_;
		gfloat _tmp8_;
		ClutterActor* _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_;
#line 390 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 390 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 390 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 390 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp8_;
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 391 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp11_;
#line 1311 "PopupWindow.c"
	}
#line 394 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) self);
#line 394 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = _tmp12_;
#line 394 "../plugins/pip/PopupWindow.vala"
	max_width = _tmp13_ - self->priv->button_size;
#line 395 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = clutter_actor_get_height ((ClutterActor*) self);
#line 395 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = _tmp14_;
#line 395 "../plugins/pip/PopupWindow.vala"
	max_height = _tmp15_ - self->priv->button_size;
#line 398 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (src_width, src_height, max_width, max_height, &_tmp16_, &_tmp17_);
#line 398 "../plugins/pip/PopupWindow.vala"
	new_width = _tmp16_;
#line 398 "../plugins/pip/PopupWindow.vala"
	new_height = _tmp17_;
#line 404 "../plugins/pip/PopupWindow.vala"
	window_width = 1.0f;
#line 404 "../plugins/pip/PopupWindow.vala"
	window_height = 1.0f;
#line 405 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_target_window_size (self, &_tmp18_, &_tmp19_);
#line 405 "../plugins/pip/PopupWindow.vala"
	window_width = _tmp18_;
#line 405 "../plugins/pip/PopupWindow.vala"
	window_height = _tmp19_;
#line 407 "../plugins/pip/PopupWindow.vala"
	new_scale_x = new_width / window_width;
#line 408 "../plugins/pip/PopupWindow.vala"
	new_scale_y = new_height / window_height;
#line 410 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = self->priv->clone_container;
#line 410 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp20_, "scale-x", (gdouble) CLAMP (new_scale_x, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 411 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = self->priv->clone_container;
#line 411 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp21_, "scale-y", (gdouble) CLAMP (new_scale_y, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 413 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_position (self);
#line 1355 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 416 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 417 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 417 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 417 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 417 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1374 "PopupWindow.c"
		gfloat clip_x = 0.0F;
		gfloat clip_y = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		ClutterActor* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 418 "../plugins/pip/PopupWindow.vala"
		clip_x = 0.0f;
#line 418 "../plugins/pip/PopupWindow.vala"
		clip_y = 0.0f;
#line 419 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 419 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, &_tmp4_, &_tmp5_, NULL, NULL);
#line 419 "../plugins/pip/PopupWindow.vala"
		clip_x = _tmp4_;
#line 419 "../plugins/pip/PopupWindow.vala"
		clip_y = _tmp5_;
#line 420 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 420 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = self->priv->clone_container;
#line 420 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp7_, "scale-x", &_tmp8_, NULL);
#line 420 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = _tmp8_;
#line 420 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x (_tmp6_, (gfloat) ((-clip_x) * _tmp9_));
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = self->priv->clone_container;
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = self->priv->clone_container;
#line 421 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp11_, "scale-y", &_tmp12_, NULL);
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = _tmp12_;
#line 421 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y (_tmp10_, (gfloat) ((-clip_y) * _tmp13_));
#line 1420 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self)
{
#line 425 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 426 "../plugins/pip/PopupWindow.vala"
	if (!gala_plugins_pip_popup_window_place_window_off_screen (self)) {
#line 427 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 1433 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp0_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp1_;
	gint monitor_y = 0;
	MtkRectangle _tmp2_;
	gint monitor_width = 0;
	MtkRectangle _tmp3_;
	gint monitor_height = 0;
	MtkRectangle _tmp4_;
	gint screen_limit_start_x = 0;
	gfloat screen_limit_end_x = 0.0F;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gint screen_limit_start_y = 0;
	gfloat screen_limit_end_y = 0.0F;
	gfloat _tmp7_;
	gfloat _tmp8_;
	guint duration = 0U;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
#line 431 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 432 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 439 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp0_);
#line 439 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp0_;
#line 441 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = monitor_rect;
#line 441 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp1_.x;
#line 442 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = monitor_rect;
#line 442 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp2_.y;
#line 443 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = monitor_rect;
#line 443 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp3_.width;
#line 444 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = monitor_rect;
#line 444 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp4_.height;
#line 446 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_x = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_x;
#line 447 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_width ((ClutterActor*) self);
#line 447 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 447 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_x = ((monitor_width + monitor_x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp6_;
#line 448 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_y = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_y;
#line 449 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_height ((ClutterActor*) self);
#line 449 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 449 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_y = ((monitor_height + monitor_y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp8_;
#line 451 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 453 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 454 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 455 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 456 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_x ((ClutterActor*) self);
#line 456 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 456 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_x ((ClutterActor*) self, CLAMP (_tmp10_, (gfloat) screen_limit_start_x, screen_limit_end_x));
#line 457 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = clutter_actor_get_y ((ClutterActor*) self);
#line 457 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 457 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_y ((ClutterActor*) self, CLAMP (_tmp12_, (gfloat) screen_limit_start_y, screen_limit_end_y));
#line 458 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1525 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self)
{
	guint duration = 0U;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp0_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp1_;
	gint monitor_y = 0;
	MtkRectangle _tmp2_;
	gint monitor_width = 0;
	MtkRectangle _tmp3_;
	gint monitor_height = 0;
	MtkRectangle _tmp4_;
	gfloat off_screen_x_threshold = 0.0F;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gboolean off_screen_x = FALSE;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean off_screen_w = FALSE;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	gboolean _tmp18_ = FALSE;
	gfloat off_screen_y_threshold = 0.0F;
	gfloat _tmp23_;
	gfloat _tmp24_;
	gboolean off_screen_y = FALSE;
	gfloat _tmp25_;
	gfloat _tmp26_;
	gboolean _tmp27_ = FALSE;
	gboolean off_screen_h = FALSE;
	gfloat _tmp32_;
	gfloat _tmp33_;
	gfloat _tmp34_;
	gfloat _tmp35_;
	gboolean _tmp36_ = FALSE;
	gboolean result;
#line 461 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 462 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 464 "../plugins/pip/PopupWindow.vala"
	duration = animations_settings_get_animation_duration ((guint) 300);
#line 466 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 467 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 468 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 475 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp0_);
#line 475 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp0_;
#line 477 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = monitor_rect;
#line 477 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp1_.x;
#line 478 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = monitor_rect;
#line 478 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp2_.y;
#line 479 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = monitor_rect;
#line 479 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp3_.width;
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = monitor_rect;
#line 480 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp4_.height;
#line 483 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_width ((ClutterActor*) self);
#line 483 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 483 "../plugins/pip/PopupWindow.vala"
	off_screen_x_threshold = _tmp6_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 485 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_x ((ClutterActor*) self);
#line 485 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 485 "../plugins/pip/PopupWindow.vala"
	off_screen_x = (_tmp8_ - monitor_x) < (-off_screen_x_threshold);
#line 486 "../plugins/pip/PopupWindow.vala"
	if (off_screen_x) {
#line 1615 "PopupWindow.c"
		gfloat _tmp10_;
		gfloat _tmp11_;
#line 487 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = clutter_actor_get_x ((ClutterActor*) self);
#line 487 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 487 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp11_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1624 "PopupWindow.c"
	} else {
#line 486 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = FALSE;
#line 1628 "PopupWindow.c"
	}
#line 486 "../plugins/pip/PopupWindow.vala"
	if (_tmp9_) {
#line 1632 "PopupWindow.c"
		gfloat _tmp12_;
		gfloat _tmp13_;
#line 488 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 489 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = clutter_actor_get_width ((ClutterActor*) self);
#line 489 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = _tmp12_;
#line 489 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (monitor_x - _tmp13_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1643 "PopupWindow.c"
	}
#line 492 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = clutter_actor_get_x ((ClutterActor*) self);
#line 492 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = _tmp14_;
#line 492 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = clutter_actor_get_width ((ClutterActor*) self);
#line 492 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = _tmp16_;
#line 492 "../plugins/pip/PopupWindow.vala"
	off_screen_w = (_tmp15_ + _tmp17_) > ((monitor_x + monitor_width) + off_screen_x_threshold);
#line 493 "../plugins/pip/PopupWindow.vala"
	if (off_screen_w) {
#line 1657 "PopupWindow.c"
		gfloat _tmp19_;
		gfloat _tmp20_;
		gfloat _tmp21_;
		gfloat _tmp22_;
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp19_ = clutter_actor_get_x ((ClutterActor*) self);
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = _tmp19_;
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = clutter_actor_get_width ((ClutterActor*) self);
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = _tmp21_;
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp20_ + _tmp22_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1672 "PopupWindow.c"
	} else {
#line 493 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = FALSE;
#line 1676 "PopupWindow.c"
	}
#line 493 "../plugins/pip/PopupWindow.vala"
	if (_tmp18_) {
#line 495 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 496 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (gfloat) ((monitor_x + monitor_width) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1684 "PopupWindow.c"
	}
#line 500 "../plugins/pip/PopupWindow.vala"
	_tmp23_ = clutter_actor_get_height ((ClutterActor*) self);
#line 500 "../plugins/pip/PopupWindow.vala"
	_tmp24_ = _tmp23_;
#line 500 "../plugins/pip/PopupWindow.vala"
	off_screen_y_threshold = _tmp24_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 502 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = clutter_actor_get_y ((ClutterActor*) self);
#line 502 "../plugins/pip/PopupWindow.vala"
	_tmp26_ = _tmp25_;
#line 502 "../plugins/pip/PopupWindow.vala"
	off_screen_y = (_tmp26_ - monitor_y) < (-off_screen_y_threshold);
#line 503 "../plugins/pip/PopupWindow.vala"
	if (off_screen_y) {
#line 1700 "PopupWindow.c"
		gfloat _tmp28_;
		gfloat _tmp29_;
#line 504 "../plugins/pip/PopupWindow.vala"
		_tmp28_ = clutter_actor_get_y ((ClutterActor*) self);
#line 504 "../plugins/pip/PopupWindow.vala"
		_tmp29_ = _tmp28_;
#line 504 "../plugins/pip/PopupWindow.vala"
		_tmp27_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp29_, CLUTTER_ORIENTATION_VERTICAL);
#line 1709 "PopupWindow.c"
	} else {
#line 503 "../plugins/pip/PopupWindow.vala"
		_tmp27_ = FALSE;
#line 1713 "PopupWindow.c"
	}
#line 503 "../plugins/pip/PopupWindow.vala"
	if (_tmp27_) {
#line 1717 "PopupWindow.c"
		gfloat _tmp30_;
		gfloat _tmp31_;
#line 505 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 506 "../plugins/pip/PopupWindow.vala"
		_tmp30_ = clutter_actor_get_height ((ClutterActor*) self);
#line 506 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = _tmp30_;
#line 506 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (monitor_y - _tmp31_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1728 "PopupWindow.c"
	}
#line 509 "../plugins/pip/PopupWindow.vala"
	_tmp32_ = clutter_actor_get_y ((ClutterActor*) self);
#line 509 "../plugins/pip/PopupWindow.vala"
	_tmp33_ = _tmp32_;
#line 509 "../plugins/pip/PopupWindow.vala"
	_tmp34_ = clutter_actor_get_height ((ClutterActor*) self);
#line 509 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = _tmp34_;
#line 509 "../plugins/pip/PopupWindow.vala"
	off_screen_h = (_tmp33_ + _tmp35_) > ((monitor_y + monitor_height) + off_screen_y_threshold);
#line 510 "../plugins/pip/PopupWindow.vala"
	if (off_screen_h) {
#line 1742 "PopupWindow.c"
		gfloat _tmp37_;
		gfloat _tmp38_;
		gfloat _tmp39_;
		gfloat _tmp40_;
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp37_ = clutter_actor_get_y ((ClutterActor*) self);
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp38_ = _tmp37_;
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp39_ = clutter_actor_get_height ((ClutterActor*) self);
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = _tmp39_;
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp36_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp38_ + _tmp40_, CLUTTER_ORIENTATION_VERTICAL);
#line 1757 "PopupWindow.c"
	} else {
#line 510 "../plugins/pip/PopupWindow.vala"
		_tmp36_ = FALSE;
#line 1761 "PopupWindow.c"
	}
#line 510 "../plugins/pip/PopupWindow.vala"
	if (_tmp36_) {
#line 512 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 513 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (gfloat) ((monitor_y + monitor_height) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1769 "PopupWindow.c"
	}
#line 516 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 518 "../plugins/pip/PopupWindow.vala"
	result = self->priv->off_screen;
#line 518 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1777 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                         gfloat coord,
                                                         ClutterOrientation axis)
{
	gint n_monitors = 0;
	MetaDisplay* _tmp0_;
	gint current = 0;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 521 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 522 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 522 "../plugins/pip/PopupWindow.vala"
	n_monitors = meta_display_get_n_monitors (_tmp0_);
#line 524 "../plugins/pip/PopupWindow.vala"
	if (n_monitors == 1) {
#line 525 "../plugins/pip/PopupWindow.vala"
		result = FALSE;
#line 525 "../plugins/pip/PopupWindow.vala"
		return result;
#line 1802 "PopupWindow.c"
	}
#line 528 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 528 "../plugins/pip/PopupWindow.vala"
	current = meta_display_get_current_monitor (_tmp1_);
#line 1808 "PopupWindow.c"
	{
		gint i = 0;
#line 529 "../plugins/pip/PopupWindow.vala"
		i = 0;
#line 1813 "PopupWindow.c"
		{
			gboolean _tmp2_ = FALSE;
#line 529 "../plugins/pip/PopupWindow.vala"
			_tmp2_ = TRUE;
#line 529 "../plugins/pip/PopupWindow.vala"
			while (TRUE) {
#line 529 "../plugins/pip/PopupWindow.vala"
				if (!_tmp2_) {
#line 1822 "PopupWindow.c"
					gint _tmp3_;
#line 529 "../plugins/pip/PopupWindow.vala"
					_tmp3_ = i;
#line 529 "../plugins/pip/PopupWindow.vala"
					i = _tmp3_ + 1;
#line 1828 "PopupWindow.c"
				}
#line 529 "../plugins/pip/PopupWindow.vala"
				_tmp2_ = FALSE;
#line 529 "../plugins/pip/PopupWindow.vala"
				if (!(i < n_monitors)) {
#line 529 "../plugins/pip/PopupWindow.vala"
					break;
#line 1836 "PopupWindow.c"
				}
#line 530 "../plugins/pip/PopupWindow.vala"
				if (i != current) {
#line 1840 "PopupWindow.c"
					MtkRectangle monitor_rect = {0};
					MetaDisplay* _tmp4_;
					MtkRectangle _tmp5_ = {0};
					gboolean in_monitor = FALSE;
#line 531 "../plugins/pip/PopupWindow.vala"
					_tmp4_ = self->priv->_display;
#line 531 "../plugins/pip/PopupWindow.vala"
					meta_display_get_monitor_geometry (_tmp4_, i, &_tmp5_);
#line 531 "../plugins/pip/PopupWindow.vala"
					monitor_rect = _tmp5_;
#line 532 "../plugins/pip/PopupWindow.vala"
					in_monitor = FALSE;
#line 534 "../plugins/pip/PopupWindow.vala"
					if (axis == CLUTTER_ORIENTATION_HORIZONTAL) {
#line 1855 "PopupWindow.c"
						gboolean _tmp6_ = FALSE;
						MtkRectangle _tmp7_;
#line 535 "../plugins/pip/PopupWindow.vala"
						_tmp7_ = monitor_rect;
#line 535 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp7_.x)) {
#line 1862 "PopupWindow.c"
							MtkRectangle _tmp8_;
							MtkRectangle _tmp9_;
#line 535 "../plugins/pip/PopupWindow.vala"
							_tmp8_ = monitor_rect;
#line 535 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = monitor_rect;
#line 535 "../plugins/pip/PopupWindow.vala"
							_tmp6_ = coord <= ((gfloat) (_tmp8_.x + _tmp9_.width));
#line 1871 "PopupWindow.c"
						} else {
#line 535 "../plugins/pip/PopupWindow.vala"
							_tmp6_ = FALSE;
#line 1875 "PopupWindow.c"
						}
#line 535 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp6_;
#line 1879 "PopupWindow.c"
					} else {
						gboolean _tmp10_ = FALSE;
						MtkRectangle _tmp11_;
#line 537 "../plugins/pip/PopupWindow.vala"
						_tmp11_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp11_.y)) {
#line 1887 "PopupWindow.c"
							MtkRectangle _tmp12_;
							MtkRectangle _tmp13_;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp12_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp10_ = coord <= ((gfloat) (_tmp12_.y + _tmp13_.height));
#line 1896 "PopupWindow.c"
						} else {
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp10_ = FALSE;
#line 1900 "PopupWindow.c"
						}
#line 537 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp10_;
#line 1904 "PopupWindow.c"
					}
#line 540 "../plugins/pip/PopupWindow.vala"
					if (in_monitor) {
#line 541 "../plugins/pip/PopupWindow.vala"
						result = TRUE;
#line 541 "../plugins/pip/PopupWindow.vala"
						return result;
#line 1912 "PopupWindow.c"
					}
				}
			}
		}
	}
#line 546 "../plugins/pip/PopupWindow.vala"
	result = FALSE;
#line 546 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1922 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                        MtkRectangle* rect)
{
	MtkRectangle _vala_rect = {0};
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
	MtkRectangle _tmp2_ = {0};
#line 550 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 554 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 554 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 554 "../plugins/pip/PopupWindow.vala"
	meta_display_get_monitor_geometry (_tmp0_, meta_display_get_current_monitor (_tmp1_), &_tmp2_);
#line 554 "../plugins/pip/PopupWindow.vala"
	_vala_rect = _tmp2_;
#line 550 "../plugins/pip/PopupWindow.vala"
	if (rect) {
#line 550 "../plugins/pip/PopupWindow.vala"
		*rect = _vala_rect;
#line 1947 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                      gfloat* width,
                                                      gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 557 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 558 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 558 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 558 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 558 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1971 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 559 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 559 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 559 "../plugins/pip/PopupWindow.vala"
		_vala_width = _tmp4_;
#line 559 "../plugins/pip/PopupWindow.vala"
		_vala_height = _tmp5_;
#line 1983 "PopupWindow.c"
	} else {
		ClutterClone* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 560 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone;
#line 560 "../plugins/pip/PopupWindow.vala"
		g_object_get ((ClutterActor*) _tmp6_, "has-clip", &_tmp7_, NULL);
#line 560 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 560 "../plugins/pip/PopupWindow.vala"
		if (_tmp8_) {
#line 1996 "PopupWindow.c"
			ClutterClone* _tmp9_;
			gfloat _tmp10_ = 0.0F;
			gfloat _tmp11_ = 0.0F;
#line 561 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = self->priv->clone;
#line 561 "../plugins/pip/PopupWindow.vala"
			clutter_actor_get_clip ((ClutterActor*) _tmp9_, NULL, NULL, &_tmp10_, &_tmp11_);
#line 561 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp10_;
#line 561 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp11_;
#line 2008 "PopupWindow.c"
		} else {
			ClutterClone* _tmp12_;
			gfloat _tmp13_;
			gfloat _tmp14_;
			ClutterClone* _tmp15_;
			gfloat _tmp16_;
			gfloat _tmp17_;
#line 563 "../plugins/pip/PopupWindow.vala"
			_tmp12_ = self->priv->clone;
#line 563 "../plugins/pip/PopupWindow.vala"
			_tmp13_ = clutter_actor_get_width ((ClutterActor*) _tmp12_);
#line 563 "../plugins/pip/PopupWindow.vala"
			_tmp14_ = _tmp13_;
#line 563 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp14_;
#line 564 "../plugins/pip/PopupWindow.vala"
			_tmp15_ = self->priv->clone;
#line 564 "../plugins/pip/PopupWindow.vala"
			_tmp16_ = clutter_actor_get_height ((ClutterActor*) _tmp15_);
#line 564 "../plugins/pip/PopupWindow.vala"
			_tmp17_ = _tmp16_;
#line 564 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp17_;
#line 2032 "PopupWindow.c"
		}
	}
#line 557 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 557 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 2039 "PopupWindow.c"
	}
#line 557 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 557 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 2045 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self)
{
#line 568 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 569 "../plugins/pip/PopupWindow.vala"
	if (self->priv->off_screen) {
#line 570 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 2058 "PopupWindow.c"
	} else {
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp0_;
		MetaWindow* _tmp1_;
		MetaWindow* _tmp2_;
		MetaWindow* _tmp3_;
#line 572 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->_window_actor;
#line 572 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 572 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 572 "../plugins/pip/PopupWindow.vala"
		window = _tmp2_;
#line 573 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = window;
#line 573 "../plugins/pip/PopupWindow.vala"
		meta_window_activate (_tmp3_, clutter_get_current_event_time ());
#line 569 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (window);
#line 2079 "PopupWindow.c"
	}
}

MetaDisplay*
gala_plugins_pip_popup_window_get_display (GalaPluginsPIPPopupWindow* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 19 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2096 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_display (GalaPluginsPIPPopupWindow* self,
                                           MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_display (self);
#line 19 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2110 "PopupWindow.c"
		MetaDisplay* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_display);
#line 19 "../plugins/pip/PopupWindow.vala"
		self->priv->_display = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY]);
#line 2120 "PopupWindow.c"
	}
}

MetaWindowActor*
gala_plugins_pip_popup_window_get_window_actor (GalaPluginsPIPPopupWindow* self)
{
	MetaWindowActor* result;
	MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 20 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2137 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_window_actor (GalaPluginsPIPPopupWindow* self,
                                                MetaWindowActor* value)
{
	MetaWindowActor* old_value;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_window_actor (self);
#line 20 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2151 "PopupWindow.c"
		MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_window_actor);
#line 20 "../plugins/pip/PopupWindow.vala"
		self->priv->_window_actor = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY]);
#line 2161 "PopupWindow.c"
	}
}

static ClutterActor*
_gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                               gfloat x,
                                                                               gfloat y,
                                                                               gpointer self)
{
	ClutterActor* result;
	result = gala_plugins_pip_popup_window_on_move_begin ((GalaPluginsPIPPopupWindow*) self);
#line 72 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2175 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                gpointer self)
{
#line 73 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_move_end ((GalaPluginsPIPPopupWindow*) self);
#line 2184 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                             guint32 button,
                                                                             gpointer self)
{
#line 74 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_activate ((GalaPluginsPIPPopupWindow*) self);
#line 2194 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                   guint32 timestamp,
                                                                                   gpointer self)
{
#line 114 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2204 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                        ClutterEvent* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_button_press ((GalaPluginsPIPPopupWindow*) self, event);
#line 121 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2216 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self)
{
#line 127 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed ((GalaPluginsPIPPopupWindow*) self);
#line 2226 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                             gpointer self)
{
#line 132 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2235 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 133 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2245 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                    gpointer self)
{
#line 136 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2254 "PopupWindow.c"
}

static GObject *
gala_plugins_pip_popup_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPluginsPIPPopupWindow * self;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindowActor* _tmp2_;
	ClutterClone* _tmp3_;
	GalaDragDropAction* _tmp4_;
	GalaDragDropAction* _tmp5_;
	GalaDragDropAction* _tmp6_;
	GalaDragDropAction* _tmp7_;
	ClutterActor* _tmp8_ = NULL;
	ClutterActor* _tmp9_;
	ClutterClone* _tmp10_;
	ClutterActor* _tmp11_ = NULL;
	ClutterActor* _tmp12_;
	ClutterActor* _tmp13_;
	ClutterActor* _tmp14_;
	GalaShadowEffect* _tmp15_;
	GalaShadowEffect* _tmp16_;
	ClutterActor* _tmp17_;
	GalaDragDropAction* _tmp18_;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp19_ = {0};
	gfloat x_position = 0.0F;
	gfloat y_position = 0.0F;
	MtkRectangle _tmp25_;
	MtkRectangle _tmp26_;
	gfloat _tmp27_;
	gfloat _tmp28_;
	GalaCloseButton* _tmp29_ = NULL;
	GalaCloseButton* _tmp30_;
	ClutterAlignConstraint* _tmp31_;
	ClutterAlignConstraint* _tmp32_;
	GalaCloseButton* _tmp33_;
	ClutterAlignConstraint* _tmp34_;
	ClutterAlignConstraint* _tmp35_;
	GalaCloseButton* _tmp36_;
	ClutterActor* _tmp37_;
	ClutterActor* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterAlignConstraint* _tmp41_;
	ClutterAlignConstraint* _tmp42_;
	ClutterActor* _tmp43_;
	ClutterAlignConstraint* _tmp44_;
	ClutterAlignConstraint* _tmp45_;
	ClutterActor* _tmp46_;
	ClutterActor* _tmp47_;
	GalaCloseButton* _tmp48_;
	ClutterActor* _tmp49_;
	MetaWindowActor* _tmp50_;
	ClutterActor* _tmp51_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp52_;
	MetaWindow* _tmp53_;
	MetaWindow* _tmp54_;
	MetaWindow* _tmp55_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp56_;
	MetaWorkspaceManager* _tmp57_;
	MetaWorkspaceManager* _tmp58_;
#line 59 "../plugins/pip/PopupWindow.vala"
	parent_class = G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class);
#line 59 "../plugins/pip/PopupWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_display;
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_display;
#line 60 "../plugins/pip/PopupWindow.vala"
	scale = meta_display_get_monitor_scale (_tmp0_, meta_display_get_current_monitor (_tmp1_));
#line 62 "../plugins/pip/PopupWindow.vala"
	self->priv->button_size = gala_utils_scale_to_int (36, scale);
#line 63 "../plugins/pip/PopupWindow.vala"
	self->priv->container_margin = self->priv->button_size / 2;
#line 65 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 66 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) self, 0.5f, 0.5f);
#line 67 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_IN_QUAD);
#line 69 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = self->priv->_window_actor;
#line 69 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp2_);
#line 69 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 69 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 69 "../plugins/pip/PopupWindow.vala"
	self->priv->clone = _tmp3_;
#line 71 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = gala_drag_drop_action_new (GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "pip");
#line 71 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 71 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 71 "../plugins/pip/PopupWindow.vala"
	self->priv->move_action = _tmp4_;
#line 72 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->move_action;
#line 72 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp5_, "drag-begin", (GCallback) _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin, self, 0);
#line 73 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->move_action;
#line 73 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp6_, "drag-canceled", (GCallback) _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled, self, 0);
#line 74 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->move_action;
#line 74 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp7_, "actor-clicked", (GCallback) _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked, self, 0);
#line 76 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = clutter_actor_new ();
#line 76 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp8_, "scale-x", (gdouble) 0.35f, NULL);
#line 76 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp8_, "scale-y", (gdouble) 0.35f, NULL);
#line 76 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 76 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 76 "../plugins/pip/PopupWindow.vala"
	self->priv->clone_container = _tmp8_;
#line 80 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->clone_container;
#line 80 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->clone;
#line 80 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp9_, (ClutterActor*) _tmp10_);
#line 82 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = clutter_actor_new ();
#line 82 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp11_, TRUE);
#line 82 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 82 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 82 "../plugins/pip/PopupWindow.vala"
	self->priv->container = _tmp11_;
#line 85 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->container;
#line 85 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = self->priv->clone_container;
#line 85 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp12_, _tmp13_);
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->container;
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = gala_shadow_effect_new ("window");
#line 86 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = _tmp15_;
#line 86 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_effect (_tmp14_, (ClutterEffect*) _tmp16_);
#line 86 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp16_);
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = self->priv->container;
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = self->priv->move_action;
#line 87 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_action (_tmp17_, (ClutterAction*) _tmp18_);
#line 89 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 96 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp19_);
#line 96 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp19_;
#line 99 "../plugins/pip/PopupWindow.vala"
	if (clutter_get_default_text_direction () == CLUTTER_TEXT_DIRECTION_RTL) {
#line 2437 "PopupWindow.c"
		MtkRectangle _tmp20_;
#line 100 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = monitor_rect;
#line 100 "../plugins/pip/PopupWindow.vala"
		x_position = (gfloat) (GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + _tmp20_.x);
#line 2443 "PopupWindow.c"
	} else {
		MtkRectangle _tmp21_;
		MtkRectangle _tmp22_;
		gfloat _tmp23_;
		gfloat _tmp24_;
#line 102 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = monitor_rect;
#line 102 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = monitor_rect;
#line 102 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = clutter_actor_get_width ((ClutterActor*) self);
#line 102 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = _tmp23_;
#line 102 "../plugins/pip/PopupWindow.vala"
		x_position = ((_tmp21_.width + _tmp22_.x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp24_;
#line 2459 "PopupWindow.c"
	}
#line 104 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = monitor_rect;
#line 104 "../plugins/pip/PopupWindow.vala"
	_tmp26_ = monitor_rect;
#line 104 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = clutter_actor_get_height ((ClutterActor*) self);
#line 104 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = _tmp27_;
#line 104 "../plugins/pip/PopupWindow.vala"
	y_position = ((_tmp25_.height + _tmp26_.y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp28_;
#line 106 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) self, x_position, y_position);
#line 108 "../plugins/pip/PopupWindow.vala"
	_tmp29_ = gala_close_button_new (scale);
#line 108 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp29_, (guint) 0);
#line 108 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp29_);
#line 108 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 108 "../plugins/pip/PopupWindow.vala"
	self->priv->close_button = _tmp29_;
#line 112 "../plugins/pip/PopupWindow.vala"
	_tmp30_ = self->priv->close_button;
#line 112 "../plugins/pip/PopupWindow.vala"
	_tmp31_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 0.0f);
#line 112 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp31_);
#line 112 "../plugins/pip/PopupWindow.vala"
	_tmp32_ = _tmp31_;
#line 112 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp30_, (ClutterConstraint*) _tmp32_);
#line 112 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp32_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp33_ = self->priv->close_button;
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp34_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 0.0f);
#line 113 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp34_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = _tmp34_;
#line 113 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp33_, (ClutterConstraint*) _tmp35_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp35_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = self->priv->close_button;
#line 114 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp36_, "triggered", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered, self, 0);
#line 116 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = gala_utils_create_resize_button (scale);
#line 116 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 116 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_button = _tmp37_;
#line 117 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = self->priv->resize_button;
#line 117 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp38_, (guint) 0);
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = self->priv->resize_button;
#line 118 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp39_, TRUE);
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp40_ = self->priv->resize_button;
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp41_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 1.0f);
#line 119 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp41_);
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp42_ = _tmp41_;
#line 119 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp40_, (ClutterConstraint*) _tmp42_);
#line 119 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp42_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp43_ = self->priv->resize_button;
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp44_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 1.0f);
#line 120 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp44_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp45_ = _tmp44_;
#line 120 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp43_, (ClutterConstraint*) _tmp45_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp45_);
#line 121 "../plugins/pip/PopupWindow.vala"
	_tmp46_ = self->priv->resize_button;
#line 121 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp46_, "button-press-event", (GCallback) _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event, self, 0);
#line 123 "../plugins/pip/PopupWindow.vala"
	_tmp47_ = self->priv->container;
#line 123 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp47_);
#line 124 "../plugins/pip/PopupWindow.vala"
	_tmp48_ = self->priv->close_button;
#line 124 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp48_);
#line 125 "../plugins/pip/PopupWindow.vala"
	_tmp49_ = self->priv->resize_button;
#line 125 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp49_);
#line 127 "../plugins/pip/PopupWindow.vala"
	_tmp50_ = self->priv->_window_actor;
#line 127 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp50_, "notify::allocation", (GCallback) _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify, self, 0);
#line 128 "../plugins/pip/PopupWindow.vala"
	_tmp51_ = self->priv->container;
#line 128 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position (_tmp51_, (gfloat) self->priv->container_margin, (gfloat) self->priv->container_margin);
#line 129 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 131 "../plugins/pip/PopupWindow.vala"
	_tmp52_ = self->priv->_window_actor;
#line 131 "../plugins/pip/PopupWindow.vala"
	_tmp53_ = meta_window_actor_get_meta_window (_tmp52_);
#line 131 "../plugins/pip/PopupWindow.vala"
	window = _tmp53_;
#line 132 "../plugins/pip/PopupWindow.vala"
	_tmp54_ = window;
#line 132 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp54_, "unmanaged", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged, self, 0);
#line 133 "../plugins/pip/PopupWindow.vala"
	_tmp55_ = window;
#line 133 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp55_, "notify::appears-focused", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_g_object_notify, self, 0);
#line 135 "../plugins/pip/PopupWindow.vala"
	_tmp56_ = self->priv->_display;
#line 135 "../plugins/pip/PopupWindow.vala"
	_tmp57_ = meta_display_get_workspace_manager (_tmp56_);
#line 135 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp57_;
#line 136 "../plugins/pip/PopupWindow.vala"
	_tmp58_ = workspace_manager;
#line 136 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp58_, "active-workspace-changed", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed, self, 0);
#line 59 "../plugins/pip/PopupWindow.vala"
	return obj;
#line 2601 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_class_init (GalaPluginsPIPPopupWindowClass * klass,
                                          gpointer klass_data)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_parent_class = g_type_class_peek_parent (klass);
#line 7 "../plugins/pip/PopupWindow.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginsPIPPopupWindow_private_offset);
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->show = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_show;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->hide = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_hide;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->enter_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_enter_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->leave_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_leave_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugins_pip_popup_window_get_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugins_pip_popup_window_set_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_plugins_pip_popup_window_constructor;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugins_pip_popup_window_finalize;
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY] = g_param_spec_object ("window-actor", "window-actor", "window-actor", meta_window_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2634 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_instance_init (GalaPluginsPIPPopupWindow * self,
                                             gpointer klass)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	self->priv = gala_plugins_pip_popup_window_get_instance_private (self);
#line 29 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = 0.0f;
#line 30 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = 0.0f;
#line 31 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = 0.0f;
#line 32 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = 0.0f;
#line 34 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 35 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 36 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = NULL;
#line 2657 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_finalize (GObject * obj)
{
	GalaPluginsPIPPopupWindow * self;
#line 7 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 19 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_display);
#line 20 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_window_actor);
#line 22 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 23 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 24 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 25 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 26 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 27 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 36 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class)->finalize (obj);
#line 2686 "PopupWindow.c"
}

 G_GNUC_NO_INLINE static GType
gala_plugins_pip_popup_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginsPIPPopupWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugins_pip_popup_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginsPIPPopupWindow), 0, (GInstanceInitFunc) gala_plugins_pip_popup_window_instance_init, NULL };
	GType gala_plugins_pip_popup_window_type_id;
	gala_plugins_pip_popup_window_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPluginsPIPPopupWindow", &g_define_type_info, 0);
	GalaPluginsPIPPopupWindow_private_offset = g_type_add_instance_private (gala_plugins_pip_popup_window_type_id, sizeof (GalaPluginsPIPPopupWindowPrivate));
	return gala_plugins_pip_popup_window_type_id;
}

GType
gala_plugins_pip_popup_window_get_type (void)
{
	static gsize gala_plugins_pip_popup_window_type_id__once = 0;
	if (g_once_init_enter (&gala_plugins_pip_popup_window_type_id__once)) {
		GType gala_plugins_pip_popup_window_type_id;
		gala_plugins_pip_popup_window_type_id = gala_plugins_pip_popup_window_get_type_once ();
		g_once_init_leave (&gala_plugins_pip_popup_window_type_id__once, gala_plugins_pip_popup_window_type_id);
	}
	return gala_plugins_pip_popup_window_type_id__once;
}

static void
_vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_display (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_window_actor (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2733 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2739 "PopupWindow.c"
	}
}

static void
_vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_DISPLAY_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_display (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_window_actor (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2765 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2771 "PopupWindow.c"
	}
}

