/* NotificationStack.c generated by valac 0.56.17, the Vala compiler
 * generated from NotificationStack.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc (https://elementary.io)
 *           2014 Tom Beckmann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <meta/display.h>
#include <gee.h>
#include <meta/meta-window-actor.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#include <mtk/mtk.h>
#include "gala.h"
#include <float.h>
#include <math.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME "entry"
#define GALA_NOTIFICATION_STACK_TRANSITION_MOVE_STACK_ID "move-stack"
#define GALA_NOTIFICATION_STACK_TOP_OFFSET 2
#define GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN 12
#define GALA_NOTIFICATION_STACK_MARGIN 12
#define GALA_NOTIFICATION_STACK_WIDTH 300
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_NOTIFICATION_STACK (gala_notification_stack_get_type ())
#define GALA_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack))
#define GALA_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))
#define GALA_IS_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_IS_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_NOTIFICATION_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))

typedef struct _GalaNotificationStack GalaNotificationStack;
typedef struct _GalaNotificationStackClass GalaNotificationStackClass;
typedef struct _GalaNotificationStackPrivate GalaNotificationStackPrivate;
enum  {
	GALA_NOTIFICATION_STACK_0_PROPERTY,
	GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY,
	GALA_NOTIFICATION_STACK_NUM_PROPERTIES
};
static GParamSpec* gala_notification_stack_properties[GALA_NOTIFICATION_STACK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaNotificationStack {
	GObject parent_instance;
	GalaNotificationStackPrivate * priv;
};

struct _GalaNotificationStackClass {
	GObjectClass parent_class;
};

struct _GalaNotificationStackPrivate {
	gint stack_y;
	gint stack_width;
	MetaDisplay* _display;
	GeeArrayList* notifications;
};

struct _Block2Data {
	int _ref_count_;
	GalaNotificationStack* self;
	MetaWindowActor* notification;
};

static gint GalaNotificationStack_private_offset;
static gpointer gala_notification_stack_parent_class = NULL;

VALA_EXTERN GType gala_notification_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationStack, g_object_unref)
VALA_EXTERN GalaNotificationStack* gala_notification_stack_new (MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_construct (GType object_type,
                                                          MetaDisplay* display);
VALA_EXTERN void gala_notification_stack_show_notification (GalaNotificationStack* self,
                                                MetaWindowActor* notification);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
static void ___lambda66_ (Block2Data* _data2_);
static void ____lambda66__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                        gpointer self);
VALA_EXTERN MetaDisplay* gala_notification_stack_get_display (GalaNotificationStack* self);
static void gala_notification_stack_update_positions (GalaNotificationStack* self,
                                               gfloat scale,
                                               gfloat add_y);
static void gala_notification_stack_move_window (MetaWindowActor* actor,
                                          gint x,
                                          gint y);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_notification_stack_update_stack_allocation (GalaNotificationStack* self);
VALA_EXTERN void gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                                   MetaWindowActor* notification);
VALA_EXTERN gboolean gala_notification_stack_is_notification (MetaWindow* window);
static void gala_notification_stack_set_display (GalaNotificationStack* self,
                                          MetaDisplay* value);
static GObject * gala_notification_stack_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                      gpointer self);
static void _gala_notification_stack_update_stack_allocation_meta_display_workareas_changed (MetaDisplay* _sender,
                                                                                      gpointer self);
static void gala_notification_stack_finalize (GObject * obj);
static GType gala_notification_stack_get_type_once (void);
static void _vala_gala_notification_stack_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_gala_notification_stack_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
gala_notification_stack_get_instance_private (GalaNotificationStack* self)
{
	return G_STRUCT_MEMBER_P (self, GalaNotificationStack_private_offset);
}

GalaNotificationStack*
gala_notification_stack_construct (GType object_type,
                                   MetaDisplay* display)
{
	GalaNotificationStack * self = NULL;
#line 38 "../src/NotificationStack.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 39 "../src/NotificationStack.vala"
	self = (GalaNotificationStack*) g_object_new (object_type, "display", display, NULL);
#line 38 "../src/NotificationStack.vala"
	return self;
#line 178 "NotificationStack.c"
}

GalaNotificationStack*
gala_notification_stack_new (MetaDisplay* display)
{
#line 38 "../src/NotificationStack.vala"
	return gala_notification_stack_construct (GALA_TYPE_NOTIFICATION_STACK, display);
#line 186 "NotificationStack.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/NotificationStack.vala"
	return self ? g_object_ref (self) : NULL;
#line 194 "NotificationStack.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 51 "../src/NotificationStack.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 51 "../src/NotificationStack.vala"
	return _data2_;
#line 204 "NotificationStack.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 51 "../src/NotificationStack.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 214 "NotificationStack.c"
		GalaNotificationStack* self;
#line 51 "../src/NotificationStack.vala"
		self = _data2_->self;
#line 51 "../src/NotificationStack.vala"
		_g_object_unref0 (_data2_->notification);
#line 51 "../src/NotificationStack.vala"
		_g_object_unref0 (self);
#line 51 "../src/NotificationStack.vala"
		g_slice_free (Block2Data, _data2_);
#line 224 "NotificationStack.c"
	}
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 78 "../src/NotificationStack.vala"
	if (array != NULL) {
#line 234 "NotificationStack.c"
		gssize i;
#line 78 "../src/NotificationStack.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 78 "../src/NotificationStack.vala"
			g_value_unset (&array[i]);
#line 240 "NotificationStack.c"
		}
	}
#line 78 "../src/NotificationStack.vala"
	g_free (array);
#line 245 "NotificationStack.c"
}

static void
___lambda66_ (Block2Data* _data2_)
{
	GalaNotificationStack* self;
#line 86 "../src/NotificationStack.vala"
	self = _data2_->self;
#line 86 "../src/NotificationStack.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data2_->notification);
#line 256 "NotificationStack.c"
}

static void
____lambda66__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                   gpointer self)
{
#line 86 "../src/NotificationStack.vala"
	___lambda66_ (self);
#line 265 "NotificationStack.c"
}

void
gala_notification_stack_show_notification (GalaNotificationStack* self,
                                           MetaWindowActor* notification)
{
	GeeArrayList* _tmp0_;
	Block2Data* _data2_;
	MetaWindowActor* _tmp1_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MtkRectangle window_rect = {0};
	MetaWindow* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	MetaWindow* _tmp6_;
	gint primary = 0;
	MetaDisplay* _tmp30_;
	MtkRectangle area = {0};
	MetaDisplay* _tmp31_;
	MetaWorkspaceManager* _tmp32_;
	MetaWorkspace* _tmp33_;
	MtkRectangle _tmp34_ = {0};
	gfloat scale = 0.0F;
	MetaDisplay* _tmp35_;
	MtkRectangle _tmp36_;
	gint notification_x_pos = 0;
	MtkRectangle _tmp37_;
	MtkRectangle _tmp38_;
	MtkRectangle _tmp39_;
	GeeArrayList* _tmp40_;
#line 51 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/NotificationStack.vala"
	g_return_if_fail (notification != NULL);
#line 51 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->notifications;
#line 51 "../src/NotificationStack.vala"
	_vala_return_if_fail (((notification != NULL) && (!meta_window_actor_is_destroyed (notification))) && (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, notification)), "notification != null && !notification.is_destroyed () && !notifications.contains (notification)");
#line 51 "../src/NotificationStack.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 51 "../src/NotificationStack.vala"
	_data2_->_ref_count_ = 1;
#line 51 "../src/NotificationStack.vala"
	_data2_->self = g_object_ref (self);
#line 51 "../src/NotificationStack.vala"
	_tmp1_ = _g_object_ref0 (notification);
#line 51 "../src/NotificationStack.vala"
	_g_object_unref0 (_data2_->notification);
#line 51 "../src/NotificationStack.vala"
	_data2_->notification = _tmp1_;
#line 54 "../src/NotificationStack.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data2_->notification, 0.5f, 0.5f);
#line 56 "../src/NotificationStack.vala"
	_tmp2_ = meta_window_actor_get_meta_window (_data2_->notification);
#line 56 "../src/NotificationStack.vala"
	window = _tmp2_;
#line 57 "../src/NotificationStack.vala"
	_tmp3_ = window;
#line 57 "../src/NotificationStack.vala"
	if (_tmp3_ == NULL) {
#line 58 "../src/NotificationStack.vala"
		g_warning ("NotificationStack.vala:58: NotificationStack: Unable to show notificat" \
"ion, window is null");
#line 59 "../src/NotificationStack.vala"
		block2_data_unref (_data2_);
#line 59 "../src/NotificationStack.vala"
		_data2_ = NULL;
#line 59 "../src/NotificationStack.vala"
		return;
#line 335 "NotificationStack.c"
	}
#line 62 "../src/NotificationStack.vala"
	_tmp4_ = window;
#line 62 "../src/NotificationStack.vala"
	meta_window_get_frame_rect (_tmp4_, &_tmp5_);
#line 62 "../src/NotificationStack.vala"
	window_rect = _tmp5_;
#line 63 "../src/NotificationStack.vala"
	_tmp6_ = window;
#line 63 "../src/NotificationStack.vala"
	meta_window_stick (_tmp6_);
#line 65 "../src/NotificationStack.vala"
	if (animations_settings_get_enable_animations ()) {
#line 349 "NotificationStack.c"
		ClutterPropertyTransition* opacity_transition = NULL;
		ClutterPropertyTransition* _tmp7_;
		ClutterPropertyTransition* _tmp8_;
		GValue _tmp9_ = {0};
		ClutterPropertyTransition* _tmp10_;
		GValue _tmp11_ = {0};
		ClutterKeyframeTransition* flip_transition = NULL;
		ClutterKeyframeTransition* _tmp12_;
		ClutterKeyframeTransition* _tmp13_;
		GValue _tmp14_ = {0};
		ClutterKeyframeTransition* _tmp15_;
		GValue _tmp16_ = {0};
		ClutterKeyframeTransition* _tmp17_;
		gdouble* _tmp18_;
		gdouble* _tmp19_;
		gint _tmp19__length1;
		ClutterKeyframeTransition* _tmp20_;
		GValue _tmp21_ = {0};
		GValue* _tmp22_;
		GValue* _tmp23_;
		gint _tmp23__length1;
		ClutterTransitionGroup* entry = NULL;
		ClutterTransitionGroup* _tmp24_ = NULL;
		ClutterTransitionGroup* _tmp25_;
		ClutterPropertyTransition* _tmp26_;
		ClutterTransitionGroup* _tmp27_;
		ClutterKeyframeTransition* _tmp28_;
		ClutterTransitionGroup* _tmp29_;
#line 67 "../src/NotificationStack.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data2_->notification, (guint) 0);
#line 68 "../src/NotificationStack.vala"
		g_object_set ((ClutterActor*) _data2_->notification, "rotation-angle-x", (gdouble) 90, NULL);
#line 70 "../src/NotificationStack.vala"
		_tmp7_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 70 "../src/NotificationStack.vala"
		opacity_transition = _tmp7_;
#line 71 "../src/NotificationStack.vala"
		_tmp8_ = opacity_transition;
#line 71 "../src/NotificationStack.vala"
		g_value_init (&_tmp9_, G_TYPE_INT);
#line 71 "../src/NotificationStack.vala"
		g_value_set_int (&_tmp9_, 0);
#line 71 "../src/NotificationStack.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp8_, &_tmp9_);
#line 71 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 72 "../src/NotificationStack.vala"
		_tmp10_ = opacity_transition;
#line 72 "../src/NotificationStack.vala"
		g_value_init (&_tmp11_, G_TYPE_INT);
#line 72 "../src/NotificationStack.vala"
		g_value_set_int (&_tmp11_, 255);
#line 72 "../src/NotificationStack.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 72 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 74 "../src/NotificationStack.vala"
		_tmp12_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("rotation-angle-x");
#line 74 "../src/NotificationStack.vala"
		flip_transition = _tmp12_;
#line 75 "../src/NotificationStack.vala"
		_tmp13_ = flip_transition;
#line 75 "../src/NotificationStack.vala"
		g_value_init (&_tmp14_, G_TYPE_DOUBLE);
#line 75 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp14_, 90.0);
#line 75 "../src/NotificationStack.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp13_, &_tmp14_);
#line 75 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 76 "../src/NotificationStack.vala"
		_tmp15_ = flip_transition;
#line 76 "../src/NotificationStack.vala"
		g_value_init (&_tmp16_, G_TYPE_DOUBLE);
#line 76 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp16_, 0.0);
#line 76 "../src/NotificationStack.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp15_, &_tmp16_);
#line 76 "../src/NotificationStack.vala"
		G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
#line 77 "../src/NotificationStack.vala"
		_tmp17_ = flip_transition;
#line 77 "../src/NotificationStack.vala"
		_tmp18_ = g_new0 (gdouble, 1);
#line 77 "../src/NotificationStack.vala"
		_tmp18_[0] = 0.6;
#line 77 "../src/NotificationStack.vala"
		_tmp19_ = _tmp18_;
#line 77 "../src/NotificationStack.vala"
		_tmp19__length1 = 1;
#line 77 "../src/NotificationStack.vala"
		clutter_keyframe_transition_set_key_frames (_tmp17_, (guint) 1, _tmp19_);
#line 77 "../src/NotificationStack.vala"
		_tmp19_ = (g_free (_tmp19_), NULL);
#line 78 "../src/NotificationStack.vala"
		_tmp20_ = flip_transition;
#line 78 "../src/NotificationStack.vala"
		g_value_init (&_tmp21_, G_TYPE_DOUBLE);
#line 78 "../src/NotificationStack.vala"
		g_value_set_double (&_tmp21_, -10.0);
#line 78 "../src/NotificationStack.vala"
		_tmp22_ = g_new0 (GValue, 1);
#line 78 "../src/NotificationStack.vala"
		_tmp22_[0] = _tmp21_;
#line 78 "../src/NotificationStack.vala"
		_tmp23_ = _tmp22_;
#line 78 "../src/NotificationStack.vala"
		_tmp23__length1 = 1;
#line 78 "../src/NotificationStack.vala"
		clutter_keyframe_transition_set_values (_tmp20_, (guint) 1, _tmp23_);
#line 78 "../src/NotificationStack.vala"
		_tmp23_ = (_vala_GValue_array_free (_tmp23_, _tmp23__length1), NULL);
#line 80 "../src/NotificationStack.vala"
		_tmp24_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 80 "../src/NotificationStack.vala"
		clutter_timeline_set_duration ((ClutterTimeline*) _tmp24_, (guint) 400);
#line 80 "../src/NotificationStack.vala"
		entry = _tmp24_;
#line 83 "../src/NotificationStack.vala"
		_tmp25_ = entry;
#line 83 "../src/NotificationStack.vala"
		_tmp26_ = opacity_transition;
#line 83 "../src/NotificationStack.vala"
		clutter_transition_group_add_transition (_tmp25_, (ClutterTransition*) _tmp26_);
#line 84 "../src/NotificationStack.vala"
		_tmp27_ = entry;
#line 84 "../src/NotificationStack.vala"
		_tmp28_ = flip_transition;
#line 84 "../src/NotificationStack.vala"
		clutter_transition_group_add_transition (_tmp27_, (ClutterTransition*) _tmp28_);
#line 86 "../src/NotificationStack.vala"
		g_signal_connect_data ((ClutterActor*) _data2_->notification, "transitions-completed", (GCallback) ____lambda66__clutter_actor_transitions_completed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 87 "../src/NotificationStack.vala"
		_tmp29_ = entry;
#line 87 "../src/NotificationStack.vala"
		clutter_actor_add_transition ((ClutterActor*) _data2_->notification, GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME, (ClutterTransition*) _tmp29_);
#line 65 "../src/NotificationStack.vala"
		_g_object_unref0 (entry);
#line 65 "../src/NotificationStack.vala"
		_g_object_unref0 (flip_transition);
#line 65 "../src/NotificationStack.vala"
		_g_object_unref0 (opacity_transition);
#line 492 "NotificationStack.c"
	}
#line 90 "../src/NotificationStack.vala"
	_tmp30_ = self->priv->_display;
#line 90 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp30_);
#line 91 "../src/NotificationStack.vala"
	_tmp31_ = self->priv->_display;
#line 91 "../src/NotificationStack.vala"
	_tmp32_ = meta_display_get_workspace_manager (_tmp31_);
#line 91 "../src/NotificationStack.vala"
	_tmp33_ = meta_workspace_manager_get_active_workspace (_tmp32_);
#line 91 "../src/NotificationStack.vala"
	meta_workspace_get_work_area_for_monitor (_tmp33_, primary, &_tmp34_);
#line 91 "../src/NotificationStack.vala"
	area = _tmp34_;
#line 92 "../src/NotificationStack.vala"
	_tmp35_ = self->priv->_display;
#line 92 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp35_, primary);
#line 99 "../src/NotificationStack.vala"
	_tmp36_ = window_rect;
#line 99 "../src/NotificationStack.vala"
	gala_notification_stack_update_positions (self, scale, (gfloat) _tmp36_.height);
#line 101 "../src/NotificationStack.vala"
	_tmp37_ = area;
#line 101 "../src/NotificationStack.vala"
	_tmp38_ = area;
#line 101 "../src/NotificationStack.vala"
	_tmp39_ = window_rect;
#line 101 "../src/NotificationStack.vala"
	notification_x_pos = (_tmp37_.x + _tmp38_.width) - _tmp39_.width;
#line 102 "../src/NotificationStack.vala"
	if (clutter_get_default_text_direction () == CLUTTER_TEXT_DIRECTION_RTL) {
#line 103 "../src/NotificationStack.vala"
		notification_x_pos = 0;
#line 528 "NotificationStack.c"
	}
#line 106 "../src/NotificationStack.vala"
	gala_notification_stack_move_window (_data2_->notification, notification_x_pos, (self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN, scale));
#line 107 "../src/NotificationStack.vala"
	_tmp40_ = self->priv->notifications;
#line 107 "../src/NotificationStack.vala"
	gee_abstract_list_insert ((GeeAbstractList*) _tmp40_, 0, _data2_->notification);
#line 51 "../src/NotificationStack.vala"
	block2_data_unref (_data2_);
#line 51 "../src/NotificationStack.vala"
	_data2_ = NULL;
#line 540 "NotificationStack.c"
}

static void
gala_notification_stack_update_stack_allocation (GalaNotificationStack* self)
{
	gint primary = 0;
	MetaDisplay* _tmp0_;
	MtkRectangle area = {0};
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MtkRectangle _tmp4_ = {0};
	gfloat scale = 0.0F;
	MetaDisplay* _tmp5_;
	MtkRectangle _tmp6_;
#line 110 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->_display;
#line 111 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp0_);
#line 112 "../src/NotificationStack.vala"
	_tmp1_ = self->priv->_display;
#line 112 "../src/NotificationStack.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 112 "../src/NotificationStack.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 112 "../src/NotificationStack.vala"
	meta_workspace_get_work_area_for_monitor (_tmp3_, primary, &_tmp4_);
#line 112 "../src/NotificationStack.vala"
	area = _tmp4_;
#line 114 "../src/NotificationStack.vala"
	_tmp5_ = self->priv->_display;
#line 114 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp5_, primary);
#line 115 "../src/NotificationStack.vala"
	self->priv->stack_width = gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_WIDTH + GALA_NOTIFICATION_STACK_MARGIN, scale);
#line 117 "../src/NotificationStack.vala"
	_tmp6_ = area;
#line 117 "../src/NotificationStack.vala"
	self->priv->stack_y = _tmp6_.y;
#line 582 "NotificationStack.c"
}

static void
gala_notification_stack_update_positions (GalaNotificationStack* self,
                                          gfloat scale,
                                          gfloat add_y)
{
	gfloat y = 0.0F;
	gint i = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gint delay_step = 0;
	gint iterator = 0;
#line 120 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/NotificationStack.vala"
	y = ((self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + add_y) + gala_internal_utils_scale_to_int (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN, scale);
#line 122 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->notifications;
#line 122 "../src/NotificationStack.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 122 "../src/NotificationStack.vala"
	_tmp2_ = _tmp1_;
#line 122 "../src/NotificationStack.vala"
	i = _tmp2_;
#line 123 "../src/NotificationStack.vala"
	if (i > 0) {
#line 123 "../src/NotificationStack.vala"
		_tmp3_ = 150 / i;
#line 614 "NotificationStack.c"
	} else {
#line 123 "../src/NotificationStack.vala"
		_tmp3_ = 0;
#line 618 "NotificationStack.c"
	}
#line 123 "../src/NotificationStack.vala"
	delay_step = _tmp3_;
#line 124 "../src/NotificationStack.vala"
	iterator = 0;
#line 126 "../src/NotificationStack.vala"
	while (TRUE) {
#line 626 "NotificationStack.c"
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		MetaWindowActor* actor = NULL;
		GeeArrayList* _tmp7_;
		gpointer _tmp8_;
		gint _tmp9_;
		gboolean _tmp10_ = FALSE;
		MetaWindowActor* _tmp11_;
		MetaWindowActor* _tmp19_;
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp21_;
		MetaWindow* _tmp22_;
		MetaWindow* _tmp23_;
		MetaWindow* _tmp26_;
		MtkRectangle _tmp27_ = {0};
#line 126 "../src/NotificationStack.vala"
		_tmp4_ = self->priv->notifications;
#line 126 "../src/NotificationStack.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 126 "../src/NotificationStack.vala"
		_tmp6_ = _tmp5_;
#line 126 "../src/NotificationStack.vala"
		if (!(_tmp6_ > iterator)) {
#line 126 "../src/NotificationStack.vala"
			break;
#line 653 "NotificationStack.c"
		}
#line 127 "../src/NotificationStack.vala"
		_tmp7_ = self->priv->notifications;
#line 127 "../src/NotificationStack.vala"
		_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, iterator);
#line 127 "../src/NotificationStack.vala"
		actor = (MetaWindowActor*) _tmp8_;
#line 128 "../src/NotificationStack.vala"
		_tmp9_ = iterator;
#line 128 "../src/NotificationStack.vala"
		iterator = _tmp9_ + 1;
#line 129 "../src/NotificationStack.vala"
		_tmp11_ = actor;
#line 129 "../src/NotificationStack.vala"
		if (_tmp11_ == NULL) {
#line 129 "../src/NotificationStack.vala"
			_tmp10_ = TRUE;
#line 671 "NotificationStack.c"
		} else {
			MetaWindowActor* _tmp12_;
#line 129 "../src/NotificationStack.vala"
			_tmp12_ = actor;
#line 129 "../src/NotificationStack.vala"
			_tmp10_ = meta_window_actor_is_destroyed (_tmp12_);
#line 678 "NotificationStack.c"
		}
#line 129 "../src/NotificationStack.vala"
		if (_tmp10_) {
#line 130 "../src/NotificationStack.vala"
			g_warning ("NotificationStack.vala:130: NotificationStack: Notification actor was " \
"null or destroyed");
#line 131 "../src/NotificationStack.vala"
			continue;
#line 686 "NotificationStack.c"
		}
#line 134 "../src/NotificationStack.vala"
		if (animations_settings_get_enable_animations ()) {
#line 690 "NotificationStack.c"
			MetaWindowActor* _tmp13_;
			MetaWindowActor* _tmp14_;
			MetaWindowActor* _tmp15_;
			MetaWindowActor* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 135 "../src/NotificationStack.vala"
			_tmp13_ = actor;
#line 135 "../src/NotificationStack.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _tmp13_);
#line 136 "../src/NotificationStack.vala"
			_tmp14_ = actor;
#line 136 "../src/NotificationStack.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _tmp14_, CLUTTER_EASE_OUT_BACK);
#line 137 "../src/NotificationStack.vala"
			_tmp15_ = actor;
#line 137 "../src/NotificationStack.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _tmp15_, (guint) 200);
#line 138 "../src/NotificationStack.vala"
			_tmp16_ = actor;
#line 138 "../src/NotificationStack.vala"
			_tmp17_ = i;
#line 138 "../src/NotificationStack.vala"
			i = _tmp17_ - 1;
#line 138 "../src/NotificationStack.vala"
			_tmp18_ = delay_step;
#line 138 "../src/NotificationStack.vala"
			clutter_actor_set_easing_delay ((ClutterActor*) _tmp16_, (guint) (_tmp17_ * _tmp18_));
#line 719 "NotificationStack.c"
		}
#line 141 "../src/NotificationStack.vala"
		_tmp19_ = actor;
#line 141 "../src/NotificationStack.vala"
		gala_notification_stack_move_window (_tmp19_, -1, (gint) y);
#line 143 "../src/NotificationStack.vala"
		if (animations_settings_get_enable_animations ()) {
#line 727 "NotificationStack.c"
			MetaWindowActor* _tmp20_;
#line 144 "../src/NotificationStack.vala"
			_tmp20_ = actor;
#line 144 "../src/NotificationStack.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _tmp20_);
#line 733 "NotificationStack.c"
		}
#line 147 "../src/NotificationStack.vala"
		_tmp21_ = actor;
#line 147 "../src/NotificationStack.vala"
		_tmp22_ = meta_window_actor_get_meta_window (_tmp21_);
#line 147 "../src/NotificationStack.vala"
		window = _tmp22_;
#line 148 "../src/NotificationStack.vala"
		_tmp23_ = window;
#line 148 "../src/NotificationStack.vala"
		if (_tmp23_ == NULL) {
#line 745 "NotificationStack.c"
			GeeArrayList* _tmp24_;
			MetaWindowActor* _tmp25_;
#line 154 "../src/NotificationStack.vala"
			_tmp24_ = self->priv->notifications;
#line 154 "../src/NotificationStack.vala"
			_tmp25_ = actor;
#line 154 "../src/NotificationStack.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 155 "../src/NotificationStack.vala"
			g_warning ("NotificationStack.vala:155: NotificationStack: Notification window was" \
" null (probably removed during workspace transition?)");
#line 156 "../src/NotificationStack.vala"
			continue;
#line 758 "NotificationStack.c"
		}
#line 159 "../src/NotificationStack.vala"
		_tmp26_ = window;
#line 159 "../src/NotificationStack.vala"
		meta_window_get_frame_rect (_tmp26_, &_tmp27_);
#line 159 "../src/NotificationStack.vala"
		y += (gfloat) _tmp27_.height;
#line 766 "NotificationStack.c"
	}
}

void
gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                              MetaWindowActor* notification)
{
	gint primary = 0;
	MetaDisplay* _tmp4_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp5_;
	GeeArrayList* _tmp6_;
#line 163 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/NotificationStack.vala"
	g_return_if_fail (notification != NULL);
#line 164 "../src/NotificationStack.vala"
	if (animations_settings_get_enable_animations ()) {
#line 785 "NotificationStack.c"
		gfloat _tmp0_;
		gfloat _tmp1_;
#line 165 "../src/NotificationStack.vala"
		clutter_actor_save_easing_state ((ClutterActor*) notification);
#line 166 "../src/NotificationStack.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) notification, (guint) 100);
#line 167 "../src/NotificationStack.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) notification, CLUTTER_EASE_IN_QUAD);
#line 168 "../src/NotificationStack.vala"
		clutter_actor_set_opacity ((ClutterActor*) notification, (guint) 0);
#line 170 "../src/NotificationStack.vala"
		_tmp0_ = clutter_actor_get_x ((ClutterActor*) notification);
#line 170 "../src/NotificationStack.vala"
		_tmp1_ = _tmp0_;
#line 170 "../src/NotificationStack.vala"
		clutter_actor_set_x ((ClutterActor*) notification, _tmp1_ + self->priv->stack_width);
#line 171 "../src/NotificationStack.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) notification);
#line 804 "NotificationStack.c"
	} else {
		gfloat _tmp2_;
		gfloat _tmp3_;
#line 173 "../src/NotificationStack.vala"
		clutter_actor_set_opacity ((ClutterActor*) notification, (guint) 0);
#line 174 "../src/NotificationStack.vala"
		_tmp2_ = clutter_actor_get_x ((ClutterActor*) notification);
#line 174 "../src/NotificationStack.vala"
		_tmp3_ = _tmp2_;
#line 174 "../src/NotificationStack.vala"
		clutter_actor_set_x ((ClutterActor*) notification, _tmp3_ + self->priv->stack_width);
#line 816 "NotificationStack.c"
	}
#line 177 "../src/NotificationStack.vala"
	_tmp4_ = self->priv->_display;
#line 177 "../src/NotificationStack.vala"
	primary = meta_display_get_primary_monitor (_tmp4_);
#line 178 "../src/NotificationStack.vala"
	_tmp5_ = self->priv->_display;
#line 178 "../src/NotificationStack.vala"
	scale = meta_display_get_monitor_scale (_tmp5_, primary);
#line 180 "../src/NotificationStack.vala"
	_tmp6_ = self->priv->notifications;
#line 180 "../src/NotificationStack.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, notification);
#line 181 "../src/NotificationStack.vala"
	gala_notification_stack_update_positions (self, scale, 0.0f);
#line 832 "NotificationStack.c"
}

/**
     * This function takes care of properly updating both the actor
     * position and the actual window position.
     *
     * To enable animations for a window we first need to move it's frame
     * in the compositor and then calculate & apply the coordinates for the window
     * actor.
     */
static void
gala_notification_stack_move_window (MetaWindowActor* actor,
                                     gint x,
                                     gint y)
{
	MetaWindow* window = NULL;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle rect = {0};
	MetaWindow* _tmp2_;
	MtkRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	gint _tmp6_ = 0;
	MetaWindow* _tmp8_;
	MetaWindow* _tmp9_;
	MtkRectangle _tmp10_ = {0};
	MtkRectangle _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	MtkRectangle _tmp14_;
	MtkRectangle _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	MtkRectangle _tmp18_;
#line 192 "../src/NotificationStack.vala"
	g_return_if_fail (actor != NULL);
#line 192 "../src/NotificationStack.vala"
	_vala_return_if_fail ((actor != NULL) && (!meta_window_actor_is_destroyed (actor)), "actor != null && !actor.is_destroyed ()");
#line 193 "../src/NotificationStack.vala"
	_tmp0_ = meta_window_actor_get_meta_window (actor);
#line 193 "../src/NotificationStack.vala"
	window = _tmp0_;
#line 194 "../src/NotificationStack.vala"
	_tmp1_ = window;
#line 194 "../src/NotificationStack.vala"
	if (_tmp1_ == NULL) {
#line 195 "../src/NotificationStack.vala"
		g_warning ("NotificationStack.vala:195: NotificationStack: Unable to move the wind" \
"ow, window is null");
#line 196 "../src/NotificationStack.vala"
		return;
#line 883 "NotificationStack.c"
	}
#line 199 "../src/NotificationStack.vala"
	_tmp2_ = window;
#line 199 "../src/NotificationStack.vala"
	meta_window_get_frame_rect (_tmp2_, &_tmp3_);
#line 199 "../src/NotificationStack.vala"
	rect = _tmp3_;
#line 201 "../src/NotificationStack.vala"
	if (x != -1) {
#line 201 "../src/NotificationStack.vala"
		_tmp4_ = x;
#line 895 "NotificationStack.c"
	} else {
		MtkRectangle _tmp5_;
#line 201 "../src/NotificationStack.vala"
		_tmp5_ = rect;
#line 201 "../src/NotificationStack.vala"
		_tmp4_ = _tmp5_.x;
#line 902 "NotificationStack.c"
	}
#line 201 "../src/NotificationStack.vala"
	if (y != -1) {
#line 201 "../src/NotificationStack.vala"
		_tmp6_ = y;
#line 908 "NotificationStack.c"
	} else {
		MtkRectangle _tmp7_;
#line 201 "../src/NotificationStack.vala"
		_tmp7_ = rect;
#line 201 "../src/NotificationStack.vala"
		_tmp6_ = _tmp7_.y;
#line 915 "NotificationStack.c"
	}
#line 201 "../src/NotificationStack.vala"
	_tmp8_ = window;
#line 201 "../src/NotificationStack.vala"
	meta_window_move_frame (_tmp8_, FALSE, _tmp4_, _tmp6_);
#line 207 "../src/NotificationStack.vala"
	_tmp9_ = window;
#line 207 "../src/NotificationStack.vala"
	meta_window_get_buffer_rect (_tmp9_, &_tmp10_);
#line 207 "../src/NotificationStack.vala"
	rect = _tmp10_;
#line 208 "../src/NotificationStack.vala"
	_tmp11_ = rect;
#line 208 "../src/NotificationStack.vala"
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) actor);
#line 208 "../src/NotificationStack.vala"
	_tmp13_ = _tmp12_;
#line 208 "../src/NotificationStack.vala"
	_tmp14_ = rect;
#line 208 "../src/NotificationStack.vala"
	_tmp15_ = rect;
#line 208 "../src/NotificationStack.vala"
	_tmp16_ = clutter_actor_get_height ((ClutterActor*) actor);
#line 208 "../src/NotificationStack.vala"
	_tmp17_ = _tmp16_;
#line 208 "../src/NotificationStack.vala"
	_tmp18_ = rect;
#line 208 "../src/NotificationStack.vala"
	clutter_actor_set_position ((ClutterActor*) actor, _tmp11_.x - ((_tmp13_ - _tmp14_.width) / 2), _tmp15_.y - ((_tmp17_ - _tmp18_.height) / 2));
#line 945 "NotificationStack.c"
}

gboolean
gala_notification_stack_is_notification (MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	MetaWindowType _tmp1_;
	MetaWindowType _tmp2_;
	gboolean result;
#line 211 "../src/NotificationStack.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 212 "../src/NotificationStack.vala"
	_tmp1_ = meta_window_get_window_type (window);
#line 212 "../src/NotificationStack.vala"
	_tmp2_ = _tmp1_;
#line 212 "../src/NotificationStack.vala"
	if (_tmp2_ == META_WINDOW_NOTIFICATION) {
#line 212 "../src/NotificationStack.vala"
		_tmp0_ = TRUE;
#line 965 "NotificationStack.c"
	} else {
		gconstpointer _tmp3_;
#line 212 "../src/NotificationStack.vala"
		_tmp3_ = g_object_get_data ((GObject*) window, GALA_NOTIFICATION_DATA_KEY);
#line 212 "../src/NotificationStack.vala"
		_tmp0_ = (gboolean) ((gintptr) _tmp3_);
#line 972 "NotificationStack.c"
	}
#line 212 "../src/NotificationStack.vala"
	result = _tmp0_;
#line 212 "../src/NotificationStack.vala"
	return result;
#line 978 "NotificationStack.c"
}

MetaDisplay*
gala_notification_stack_get_display (GalaNotificationStack* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 34 "../src/NotificationStack.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/NotificationStack.vala"
	_tmp0_ = self->priv->_display;
#line 34 "../src/NotificationStack.vala"
	result = _tmp0_;
#line 34 "../src/NotificationStack.vala"
	return result;
#line 994 "NotificationStack.c"
}

static void
gala_notification_stack_set_display (GalaNotificationStack* self,
                                     MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 34 "../src/NotificationStack.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/NotificationStack.vala"
	old_value = gala_notification_stack_get_display (self);
#line 34 "../src/NotificationStack.vala"
	if (old_value != value) {
#line 1008 "NotificationStack.c"
		MetaDisplay* _tmp0_;
#line 34 "../src/NotificationStack.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/NotificationStack.vala"
		_g_object_unref0 (self->priv->_display);
#line 34 "../src/NotificationStack.vala"
		self->priv->_display = _tmp0_;
#line 34 "../src/NotificationStack.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY]);
#line 1018 "NotificationStack.c"
	}
}

static void
_gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                 gpointer self)
{
#line 46 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
#line 1028 "NotificationStack.c"
}

static void
_gala_notification_stack_update_stack_allocation_meta_display_workareas_changed (MetaDisplay* _sender,
                                                                                 gpointer self)
{
#line 47 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
#line 1037 "NotificationStack.c"
}

static GObject *
gala_notification_stack_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaNotificationStack * self;
	GeeArrayList* _tmp0_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp1_;
	MetaContext* _tmp2_;
	MetaBackend* _tmp3_;
	MetaMonitorManager* _tmp4_;
	MetaMonitorManager* _tmp5_;
	MetaDisplay* _tmp6_;
#line 42 "../src/NotificationStack.vala"
	parent_class = G_OBJECT_CLASS (gala_notification_stack_parent_class);
#line 42 "../src/NotificationStack.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../src/NotificationStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 43 "../src/NotificationStack.vala"
	_tmp0_ = gee_array_list_new (meta_window_actor_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 43 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->notifications);
#line 43 "../src/NotificationStack.vala"
	self->priv->notifications = _tmp0_;
#line 45 "../src/NotificationStack.vala"
	_tmp1_ = self->priv->_display;
#line 45 "../src/NotificationStack.vala"
	_tmp2_ = meta_display_get_context (_tmp1_);
#line 45 "../src/NotificationStack.vala"
	_tmp3_ = meta_context_get_backend (_tmp2_);
#line 45 "../src/NotificationStack.vala"
	_tmp4_ = meta_backend_get_monitor_manager (_tmp3_);
#line 45 "../src/NotificationStack.vala"
	monitor_manager = _tmp4_;
#line 46 "../src/NotificationStack.vala"
	_tmp5_ = monitor_manager;
#line 46 "../src/NotificationStack.vala"
	g_signal_connect_object (_tmp5_, "monitors-changed-internal", (GCallback) _gala_notification_stack_update_stack_allocation_meta_monitor_manager_monitors_changed_internal, self, 0);
#line 47 "../src/NotificationStack.vala"
	_tmp6_ = self->priv->_display;
#line 47 "../src/NotificationStack.vala"
	g_signal_connect_object (_tmp6_, "workareas-changed", (GCallback) _gala_notification_stack_update_stack_allocation_meta_display_workareas_changed, self, 0);
#line 48 "../src/NotificationStack.vala"
	gala_notification_stack_update_stack_allocation (self);
#line 42 "../src/NotificationStack.vala"
	return obj;
#line 1090 "NotificationStack.c"
}

static void
gala_notification_stack_class_init (GalaNotificationStackClass * klass,
                                    gpointer klass_data)
{
#line 19 "../src/NotificationStack.vala"
	gala_notification_stack_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/NotificationStack.vala"
	g_type_class_adjust_private_offset (klass, &GalaNotificationStack_private_offset);
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_notification_stack_get_property;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_notification_stack_set_property;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_notification_stack_constructor;
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_notification_stack_finalize;
#line 19 "../src/NotificationStack.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1111 "NotificationStack.c"
}

static void
gala_notification_stack_instance_init (GalaNotificationStack * self,
                                       gpointer klass)
{
#line 19 "../src/NotificationStack.vala"
	self->priv = gala_notification_stack_get_instance_private (self);
#line 1120 "NotificationStack.c"
}

static void
gala_notification_stack_finalize (GObject * obj)
{
	GalaNotificationStack * self;
#line 19 "../src/NotificationStack.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 34 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->_display);
#line 36 "../src/NotificationStack.vala"
	_g_object_unref0 (self->priv->notifications);
#line 19 "../src/NotificationStack.vala"
	G_OBJECT_CLASS (gala_notification_stack_parent_class)->finalize (obj);
#line 1135 "NotificationStack.c"
}

 G_GNUC_NO_INLINE static GType
gala_notification_stack_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaNotificationStackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_notification_stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaNotificationStack), 0, (GInstanceInitFunc) gala_notification_stack_instance_init, NULL };
	GType gala_notification_stack_type_id;
	gala_notification_stack_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaNotificationStack", &g_define_type_info, 0);
	GalaNotificationStack_private_offset = g_type_add_instance_private (gala_notification_stack_type_id, sizeof (GalaNotificationStackPrivate));
	return gala_notification_stack_type_id;
}

GType
gala_notification_stack_get_type (void)
{
	static gsize gala_notification_stack_type_id__once = 0;
	if (g_once_init_enter (&gala_notification_stack_type_id__once)) {
		GType gala_notification_stack_type_id;
		gala_notification_stack_type_id = gala_notification_stack_get_type_once ();
		g_once_init_leave (&gala_notification_stack_type_id__once, gala_notification_stack_type_id);
	}
	return gala_notification_stack_type_id__once;
}

static void
_vala_gala_notification_stack_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 19 "../src/NotificationStack.vala"
	switch (property_id) {
#line 19 "../src/NotificationStack.vala"
		case GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY:
#line 19 "../src/NotificationStack.vala"
		g_value_set_object (value, gala_notification_stack_get_display (self));
#line 19 "../src/NotificationStack.vala"
		break;
#line 1176 "NotificationStack.c"
		default:
#line 19 "../src/NotificationStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/NotificationStack.vala"
		break;
#line 1182 "NotificationStack.c"
	}
}

static void
_vala_gala_notification_stack_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
#line 19 "../src/NotificationStack.vala"
	switch (property_id) {
#line 19 "../src/NotificationStack.vala"
		case GALA_NOTIFICATION_STACK_DISPLAY_PROPERTY:
#line 19 "../src/NotificationStack.vala"
		gala_notification_stack_set_display (self, g_value_get_object (value));
#line 19 "../src/NotificationStack.vala"
		break;
#line 1202 "NotificationStack.c"
		default:
#line 19 "../src/NotificationStack.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/NotificationStack.vala"
		break;
#line 1208 "NotificationStack.c"
	}
}

