/* WindowPositioner.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowPositioner.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/display.h>
#include <meta/window.h>
#include <glib.h>
#include <mtk/mtk.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_POSITIONER (gala_window_positioner_get_type ())
#define GALA_WINDOW_POSITIONER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner))
#define GALA_WINDOW_POSITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositionerClass))
#define GALA_IS_WINDOW_POSITIONER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_POSITIONER))
#define GALA_IS_WINDOW_POSITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_POSITIONER))
#define GALA_WINDOW_POSITIONER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositionerClass))

typedef struct _GalaWindowPositioner GalaWindowPositioner;
typedef struct _GalaWindowPositionerClass GalaWindowPositionerClass;
typedef struct _GalaWindowPositionerPrivate GalaWindowPositionerPrivate;
typedef enum  {
	GALA_WINDOW_POSITIONER_POSITION_CENTER
} GalaWindowPositionerPosition;

#define GALA_WINDOW_POSITIONER_TYPE_POSITION (gala_window_positioner_position_get_type ())
enum  {
	GALA_WINDOW_POSITIONER_0_PROPERTY,
	GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY,
	GALA_WINDOW_POSITIONER_WINDOW_PROPERTY,
	GALA_WINDOW_POSITIONER_POSITION_PROPERTY,
	GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY,
	GALA_WINDOW_POSITIONER_NUM_PROPERTIES
};
static GParamSpec* gala_window_positioner_properties[GALA_WINDOW_POSITIONER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GalaWindowPositioner {
	GObject parent_instance;
	GalaWindowPositionerPrivate * priv;
};

struct _GalaWindowPositionerClass {
	GObjectClass parent_class;
};

struct _GalaWindowPositionerPrivate {
	MetaDisplay* _display;
	MetaWindow* _window;
	GalaWindowPositionerPosition _position;
	GVariant* _position_data;
};

static gint GalaWindowPositioner_private_offset;
static gpointer gala_window_positioner_parent_class = NULL;

VALA_EXTERN GType gala_window_positioner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowPositioner, g_object_unref)
VALA_EXTERN GType gala_window_positioner_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GalaWindowPositioner* gala_window_positioner_new (MetaDisplay* display,
                                                  MetaWindow* window,
                                                  GalaWindowPositionerPosition position,
                                                  GVariant* position_data);
VALA_EXTERN GalaWindowPositioner* gala_window_positioner_construct (GType object_type,
                                                        MetaDisplay* display,
                                                        MetaWindow* window,
                                                        GalaWindowPositionerPosition position,
                                                        GVariant* position_data);
VALA_EXTERN void gala_window_positioner_update_position (GalaWindowPositioner* self,
                                             GalaWindowPositionerPosition new_position,
                                             GVariant* new_position_data);
static void gala_window_positioner_set_position (GalaWindowPositioner* self,
                                          GalaWindowPositionerPosition value);
static void gala_window_positioner_set_position_data (GalaWindowPositioner* self,
                                               GVariant* value);
static void gala_window_positioner_position_window (GalaWindowPositioner* self);
VALA_EXTERN GalaWindowPositionerPosition gala_window_positioner_get_position (GalaWindowPositioner* self);
VALA_EXTERN MetaDisplay* gala_window_positioner_get_display (GalaWindowPositioner* self);
VALA_EXTERN MetaWindow* gala_window_positioner_get_window (GalaWindowPositioner* self);
static void gala_window_positioner_set_display (GalaWindowPositioner* self,
                                         MetaDisplay* value);
static void gala_window_positioner_set_window (GalaWindowPositioner* self,
                                        MetaWindow* value);
VALA_EXTERN GVariant* gala_window_positioner_get_position_data (GalaWindowPositioner* self);
static GObject * gala_window_positioner_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _gala_window_positioner_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                       gpointer self);
static void _gala_window_positioner_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                           gpointer self);
static void _gala_window_positioner_position_window_meta_window_shown (MetaWindow* _sender,
                                                                gpointer self);
static void _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                    gpointer self);
static void _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                             gpointer self);
static void gala_window_positioner_finalize (GObject * obj);
static GType gala_window_positioner_get_type_once (void);
static void _vala_gala_window_positioner_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_window_positioner_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_window_positioner_get_instance_private (GalaWindowPositioner* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowPositioner_private_offset);
}

 G_GNUC_NO_INLINE static GType
gala_window_positioner_position_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_WINDOW_POSITIONER_POSITION_CENTER, "GALA_WINDOW_POSITIONER_POSITION_CENTER", "center"}, {0, NULL, NULL}};
	GType gala_window_positioner_position_type_id;
	gala_window_positioner_position_type_id = g_enum_register_static ("GalaWindowPositionerPosition", values);
	return gala_window_positioner_position_type_id;
}

GType
gala_window_positioner_position_get_type (void)
{
	static gsize gala_window_positioner_position_type_id__once = 0;
	if (g_once_init_enter (&gala_window_positioner_position_type_id__once)) {
		GType gala_window_positioner_position_type_id;
		gala_window_positioner_position_type_id = gala_window_positioner_position_get_type_once ();
		g_once_init_leave (&gala_window_positioner_position_type_id__once, gala_window_positioner_position_type_id);
	}
	return gala_window_positioner_position_type_id__once;
}

GalaWindowPositioner*
gala_window_positioner_construct (GType object_type,
                                  MetaDisplay* display,
                                  MetaWindow* window,
                                  GalaWindowPositionerPosition position,
                                  GVariant* position_data)
{
	GalaWindowPositioner * self = NULL;
#line 18 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 18 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 19 "../src/ShellClients/WindowPositioner.vala"
	self = (GalaWindowPositioner*) g_object_new (object_type, "display", display, "window", window, "position", position, "position-data", position_data, NULL);
#line 18 "../src/ShellClients/WindowPositioner.vala"
	return self;
#line 180 "WindowPositioner.c"
}

GalaWindowPositioner*
gala_window_positioner_new (MetaDisplay* display,
                            MetaWindow* window,
                            GalaWindowPositionerPosition position,
                            GVariant* position_data)
{
#line 18 "../src/ShellClients/WindowPositioner.vala"
	return gala_window_positioner_construct (GALA_TYPE_WINDOW_POSITIONER, display, window, position, position_data);
#line 191 "WindowPositioner.c"
}

/**
     * This may only be called after the window was shown.
     */
void
gala_window_positioner_update_position (GalaWindowPositioner* self,
                                        GalaWindowPositionerPosition new_position,
                                        GVariant* new_position_data)
{
#line 37 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_set_position (self, new_position);
#line 39 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_set_position_data (self, new_position_data);
#line 41 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window (self);
#line 210 "WindowPositioner.c"
}

static void
gala_window_positioner_position_window (GalaWindowPositioner* self)
{
	gint x = 0;
	gint y = 0;
	GalaWindowPositionerPosition _tmp0_;
	MetaWindow* _tmp12_;
#line 44 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/ShellClients/WindowPositioner.vala"
	x = 0;
#line 45 "../src/ShellClients/WindowPositioner.vala"
	y = 0;
#line 47 "../src/ShellClients/WindowPositioner.vala"
	_tmp0_ = self->priv->_position;
#line 47 "../src/ShellClients/WindowPositioner.vala"
	switch (_tmp0_) {
#line 47 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_POSITION_CENTER:
#line 232 "WindowPositioner.c"
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp1_;
			MetaDisplay* _tmp2_;
			MtkRectangle _tmp3_ = {0};
			MtkRectangle window_rect = {0};
			MetaWindow* _tmp4_;
			MtkRectangle _tmp5_ = {0};
			MtkRectangle _tmp6_;
			MtkRectangle _tmp7_;
			MtkRectangle _tmp8_;
			MtkRectangle _tmp9_;
			MtkRectangle _tmp10_;
			MtkRectangle _tmp11_;
#line 49 "../src/ShellClients/WindowPositioner.vala"
			_tmp1_ = self->priv->_display;
#line 49 "../src/ShellClients/WindowPositioner.vala"
			_tmp2_ = self->priv->_display;
#line 49 "../src/ShellClients/WindowPositioner.vala"
			meta_display_get_monitor_geometry (_tmp1_, meta_display_get_primary_monitor (_tmp2_), &_tmp3_);
#line 49 "../src/ShellClients/WindowPositioner.vala"
			monitor_geom = _tmp3_;
#line 50 "../src/ShellClients/WindowPositioner.vala"
			_tmp4_ = self->priv->_window;
#line 50 "../src/ShellClients/WindowPositioner.vala"
			meta_window_get_frame_rect (_tmp4_, &_tmp5_);
#line 50 "../src/ShellClients/WindowPositioner.vala"
			window_rect = _tmp5_;
#line 52 "../src/ShellClients/WindowPositioner.vala"
			_tmp6_ = monitor_geom;
#line 52 "../src/ShellClients/WindowPositioner.vala"
			_tmp7_ = monitor_geom;
#line 52 "../src/ShellClients/WindowPositioner.vala"
			_tmp8_ = window_rect;
#line 52 "../src/ShellClients/WindowPositioner.vala"
			x = _tmp6_.x + ((_tmp7_.width - _tmp8_.width) / 2);
#line 53 "../src/ShellClients/WindowPositioner.vala"
			_tmp9_ = monitor_geom;
#line 53 "../src/ShellClients/WindowPositioner.vala"
			_tmp10_ = monitor_geom;
#line 53 "../src/ShellClients/WindowPositioner.vala"
			_tmp11_ = window_rect;
#line 53 "../src/ShellClients/WindowPositioner.vala"
			y = _tmp9_.y + ((_tmp10_.height - _tmp11_.height) / 2);
#line 54 "../src/ShellClients/WindowPositioner.vala"
			break;
#line 279 "WindowPositioner.c"
		}
		default:
#line 47 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 284 "WindowPositioner.c"
	}
#line 57 "../src/ShellClients/WindowPositioner.vala"
	_tmp12_ = self->priv->_window;
#line 57 "../src/ShellClients/WindowPositioner.vala"
	meta_window_move_frame (_tmp12_, FALSE, x, y);
#line 290 "WindowPositioner.c"
}

MetaDisplay*
gala_window_positioner_get_display (GalaWindowPositioner* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 13 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/ShellClients/WindowPositioner.vala"
	_tmp0_ = self->priv->_display;
#line 13 "../src/ShellClients/WindowPositioner.vala"
	result = _tmp0_;
#line 13 "../src/ShellClients/WindowPositioner.vala"
	return result;
#line 306 "WindowPositioner.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 13 "../src/ShellClients/WindowPositioner.vala"
	return self ? g_object_ref (self) : NULL;
#line 314 "WindowPositioner.c"
}

static void
gala_window_positioner_set_display (GalaWindowPositioner* self,
                                    MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 13 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/ShellClients/WindowPositioner.vala"
	old_value = gala_window_positioner_get_display (self);
#line 13 "../src/ShellClients/WindowPositioner.vala"
	if (old_value != value) {
#line 328 "WindowPositioner.c"
		MetaDisplay* _tmp0_;
#line 13 "../src/ShellClients/WindowPositioner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/ShellClients/WindowPositioner.vala"
		_g_object_unref0 (self->priv->_display);
#line 13 "../src/ShellClients/WindowPositioner.vala"
		self->priv->_display = _tmp0_;
#line 13 "../src/ShellClients/WindowPositioner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY]);
#line 338 "WindowPositioner.c"
	}
}

MetaWindow*
gala_window_positioner_get_window (GalaWindowPositioner* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
#line 14 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/ShellClients/WindowPositioner.vala"
	_tmp0_ = self->priv->_window;
#line 14 "../src/ShellClients/WindowPositioner.vala"
	result = _tmp0_;
#line 14 "../src/ShellClients/WindowPositioner.vala"
	return result;
#line 355 "WindowPositioner.c"
}

static void
gala_window_positioner_set_window (GalaWindowPositioner* self,
                                   MetaWindow* value)
{
	MetaWindow* old_value;
#line 14 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/ShellClients/WindowPositioner.vala"
	old_value = gala_window_positioner_get_window (self);
#line 14 "../src/ShellClients/WindowPositioner.vala"
	if (old_value != value) {
#line 369 "WindowPositioner.c"
		MetaWindow* _tmp0_;
#line 14 "../src/ShellClients/WindowPositioner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/ShellClients/WindowPositioner.vala"
		_g_object_unref0 (self->priv->_window);
#line 14 "../src/ShellClients/WindowPositioner.vala"
		self->priv->_window = _tmp0_;
#line 14 "../src/ShellClients/WindowPositioner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_WINDOW_PROPERTY]);
#line 379 "WindowPositioner.c"
	}
}

GalaWindowPositionerPosition
gala_window_positioner_get_position (GalaWindowPositioner* self)
{
	GalaWindowPositionerPosition result;
#line 15 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15 "../src/ShellClients/WindowPositioner.vala"
	result = self->priv->_position;
#line 15 "../src/ShellClients/WindowPositioner.vala"
	return result;
#line 393 "WindowPositioner.c"
}

static void
gala_window_positioner_set_position (GalaWindowPositioner* self,
                                     GalaWindowPositionerPosition value)
{
	GalaWindowPositionerPosition old_value;
#line 15 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/ShellClients/WindowPositioner.vala"
	old_value = gala_window_positioner_get_position (self);
#line 15 "../src/ShellClients/WindowPositioner.vala"
	if (old_value != value) {
#line 15 "../src/ShellClients/WindowPositioner.vala"
		self->priv->_position = value;
#line 15 "../src/ShellClients/WindowPositioner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_PROPERTY]);
#line 411 "WindowPositioner.c"
	}
}

GVariant*
gala_window_positioner_get_position_data (GalaWindowPositioner* self)
{
	GVariant* result;
	GVariant* _tmp0_;
#line 16 "../src/ShellClients/WindowPositioner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/ShellClients/WindowPositioner.vala"
	_tmp0_ = self->priv->_position_data;
#line 16 "../src/ShellClients/WindowPositioner.vala"
	result = _tmp0_;
#line 16 "../src/ShellClients/WindowPositioner.vala"
	return result;
#line 428 "WindowPositioner.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 16 "../src/ShellClients/WindowPositioner.vala"
	return self ? g_variant_ref (self) : NULL;
#line 436 "WindowPositioner.c"
}

static void
gala_window_positioner_set_position_data (GalaWindowPositioner* self,
                                          GVariant* value)
{
	GVariant* old_value;
#line 16 "../src/ShellClients/WindowPositioner.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/ShellClients/WindowPositioner.vala"
	old_value = gala_window_positioner_get_position_data (self);
#line 16 "../src/ShellClients/WindowPositioner.vala"
	if (old_value != value) {
#line 450 "WindowPositioner.c"
		GVariant* _tmp0_;
#line 16 "../src/ShellClients/WindowPositioner.vala"
		_tmp0_ = _g_variant_ref0 (value);
#line 16 "../src/ShellClients/WindowPositioner.vala"
		_g_variant_unref0 (self->priv->_position_data);
#line 16 "../src/ShellClients/WindowPositioner.vala"
		self->priv->_position_data = _tmp0_;
#line 16 "../src/ShellClients/WindowPositioner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY]);
#line 460 "WindowPositioner.c"
	}
}

static void
_gala_window_positioner_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                  gpointer self)
{
#line 25 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
#line 470 "WindowPositioner.c"
}

static void
_gala_window_positioner_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                      gpointer self)
{
#line 26 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
#line 479 "WindowPositioner.c"
}

static void
_gala_window_positioner_position_window_meta_window_shown (MetaWindow* _sender,
                                                           gpointer self)
{
#line 27 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
#line 488 "WindowPositioner.c"
}

static void
_gala_window_positioner_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                               gpointer self)
{
#line 30 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
#line 497 "WindowPositioner.c"
}

static void
_gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                        gpointer self)
{
#line 31 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
#line 506 "WindowPositioner.c"
}

static GObject *
gala_window_positioner_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowPositioner * self;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp4_;
	MetaContext* _tmp5_;
	MetaBackend* _tmp6_;
	MetaMonitorManager* _tmp7_;
	MetaMonitorManager* _tmp8_;
	MetaMonitorManager* _tmp9_;
#line 22 "../src/ShellClients/WindowPositioner.vala"
	parent_class = G_OBJECT_CLASS (gala_window_positioner_parent_class);
#line 22 "../src/ShellClients/WindowPositioner.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 22 "../src/ShellClients/WindowPositioner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
#line 23 "../src/ShellClients/WindowPositioner.vala"
	_tmp0_ = self->priv->_window;
#line 23 "../src/ShellClients/WindowPositioner.vala"
	meta_window_stick (_tmp0_);
#line 25 "../src/ShellClients/WindowPositioner.vala"
	_tmp1_ = self->priv->_window;
#line 25 "../src/ShellClients/WindowPositioner.vala"
	g_signal_connect_object (_tmp1_, "size-changed", (GCallback) _gala_window_positioner_position_window_meta_window_size_changed, self, 0);
#line 26 "../src/ShellClients/WindowPositioner.vala"
	_tmp2_ = self->priv->_window;
#line 26 "../src/ShellClients/WindowPositioner.vala"
	g_signal_connect_object (_tmp2_, "position-changed", (GCallback) _gala_window_positioner_position_window_meta_window_position_changed, self, 0);
#line 27 "../src/ShellClients/WindowPositioner.vala"
	_tmp3_ = self->priv->_window;
#line 27 "../src/ShellClients/WindowPositioner.vala"
	g_signal_connect_object (_tmp3_, "shown", (GCallback) _gala_window_positioner_position_window_meta_window_shown, self, 0);
#line 29 "../src/ShellClients/WindowPositioner.vala"
	_tmp4_ = self->priv->_display;
#line 29 "../src/ShellClients/WindowPositioner.vala"
	_tmp5_ = meta_display_get_context (_tmp4_);
#line 29 "../src/ShellClients/WindowPositioner.vala"
	_tmp6_ = meta_context_get_backend (_tmp5_);
#line 29 "../src/ShellClients/WindowPositioner.vala"
	_tmp7_ = meta_backend_get_monitor_manager (_tmp6_);
#line 29 "../src/ShellClients/WindowPositioner.vala"
	monitor_manager = _tmp7_;
#line 30 "../src/ShellClients/WindowPositioner.vala"
	_tmp8_ = monitor_manager;
#line 30 "../src/ShellClients/WindowPositioner.vala"
	g_signal_connect_object (_tmp8_, "monitors-changed", (GCallback) _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed, self, 0);
#line 31 "../src/ShellClients/WindowPositioner.vala"
	_tmp9_ = monitor_manager;
#line 31 "../src/ShellClients/WindowPositioner.vala"
	g_signal_connect_object (_tmp9_, "monitors-changed-internal", (GCallback) _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal, self, 0);
#line 22 "../src/ShellClients/WindowPositioner.vala"
	return obj;
#line 570 "WindowPositioner.c"
}

static void
gala_window_positioner_class_init (GalaWindowPositionerClass * klass,
                                   gpointer klass_data)
{
#line 8 "../src/ShellClients/WindowPositioner.vala"
	gala_window_positioner_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/ShellClients/WindowPositioner.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowPositioner_private_offset);
#line 8 "../src/ShellClients/WindowPositioner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_positioner_get_property;
#line 8 "../src/ShellClients/WindowPositioner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_positioner_set_property;
#line 8 "../src/ShellClients/WindowPositioner.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_positioner_constructor;
#line 8 "../src/ShellClients/WindowPositioner.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_positioner_finalize;
#line 8 "../src/ShellClients/WindowPositioner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/ShellClients/WindowPositioner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_WINDOW_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/ShellClients/WindowPositioner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_POSITION_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", GALA_WINDOW_POSITIONER_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/ShellClients/WindowPositioner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY] = g_param_spec_variant ("position-data", "position-data", "position-data", G_VARIANT_TYPE_ANY, NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 597 "WindowPositioner.c"
}

static void
gala_window_positioner_instance_init (GalaWindowPositioner * self,
                                      gpointer klass)
{
#line 8 "../src/ShellClients/WindowPositioner.vala"
	self->priv = gala_window_positioner_get_instance_private (self);
#line 606 "WindowPositioner.c"
}

static void
gala_window_positioner_finalize (GObject * obj)
{
	GalaWindowPositioner * self;
#line 8 "../src/ShellClients/WindowPositioner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
#line 13 "../src/ShellClients/WindowPositioner.vala"
	_g_object_unref0 (self->priv->_display);
#line 14 "../src/ShellClients/WindowPositioner.vala"
	_g_object_unref0 (self->priv->_window);
#line 16 "../src/ShellClients/WindowPositioner.vala"
	_g_variant_unref0 (self->priv->_position_data);
#line 8 "../src/ShellClients/WindowPositioner.vala"
	G_OBJECT_CLASS (gala_window_positioner_parent_class)->finalize (obj);
#line 623 "WindowPositioner.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_positioner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowPositionerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_positioner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowPositioner), 0, (GInstanceInitFunc) gala_window_positioner_instance_init, NULL };
	GType gala_window_positioner_type_id;
	gala_window_positioner_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWindowPositioner", &g_define_type_info, 0);
	GalaWindowPositioner_private_offset = g_type_add_instance_private (gala_window_positioner_type_id, sizeof (GalaWindowPositionerPrivate));
	return gala_window_positioner_type_id;
}

GType
gala_window_positioner_get_type (void)
{
	static gsize gala_window_positioner_type_id__once = 0;
	if (g_once_init_enter (&gala_window_positioner_type_id__once)) {
		GType gala_window_positioner_type_id;
		gala_window_positioner_type_id = gala_window_positioner_get_type_once ();
		g_once_init_leave (&gala_window_positioner_type_id__once, gala_window_positioner_type_id);
	}
	return gala_window_positioner_type_id__once;
}

static void
_vala_gala_window_positioner_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWindowPositioner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
#line 8 "../src/ShellClients/WindowPositioner.vala"
	switch (property_id) {
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		g_value_set_object (value, gala_window_positioner_get_display (self));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_WINDOW_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		g_value_set_object (value, gala_window_positioner_get_window (self));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_POSITION_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		g_value_set_enum (value, gala_window_positioner_get_position (self));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		g_value_set_variant (value, gala_window_positioner_get_position_data (self));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 682 "WindowPositioner.c"
		default:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 688 "WindowPositioner.c"
	}
}

static void
_vala_gala_window_positioner_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWindowPositioner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
#line 8 "../src/ShellClients/WindowPositioner.vala"
	switch (property_id) {
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		gala_window_positioner_set_display (self, g_value_get_object (value));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_WINDOW_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		gala_window_positioner_set_window (self, g_value_get_object (value));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_POSITION_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		gala_window_positioner_set_position (self, g_value_get_enum (value));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 8 "../src/ShellClients/WindowPositioner.vala"
		case GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		gala_window_positioner_set_position_data (self, g_value_get_variant (value));
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 726 "WindowPositioner.c"
		default:
#line 8 "../src/ShellClients/WindowPositioner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/ShellClients/WindowPositioner.vala"
		break;
#line 732 "WindowPositioner.c"
	}
}

