/* WindowOverview.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowOverview.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann
 * Copyright 2012 Rico Tzschichholz
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/keybindings.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>

#define GALA_WINDOW_OVERVIEW_BORDER 10
#define GALA_WINDOW_OVERVIEW_TOP_GAP 30
#define GALA_WINDOW_OVERVIEW_BOTTOM_GAP 100
#define GALA_MULTITASKING_VIEW_ANIMATION_DURATION 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;
typedef struct _GalaWindowOverviewPrivate GalaWindowOverviewPrivate;

#define GALA_TYPE_WINDOW_CLONE_CONTAINER (gala_window_clone_container_get_type ())
#define GALA_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer))
#define GALA_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))
#define GALA_IS_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_IS_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_WINDOW_CLONE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))

typedef struct _GalaWindowCloneContainer GalaWindowCloneContainer;
typedef struct _GalaWindowCloneContainerClass GalaWindowCloneContainerClass;
enum  {
	GALA_WINDOW_OVERVIEW_0_PROPERTY,
	GALA_WINDOW_OVERVIEW_WM_PROPERTY,
	GALA_WINDOW_OVERVIEW_NUM_PROPERTIES
};
static GParamSpec* gala_window_overview_properties[GALA_WINDOW_OVERVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
typedef struct _Block74Data Block74Data;

struct _GalaWindowOverview {
	ClutterActor parent_instance;
	GalaWindowOverviewPrivate * priv;
};

struct _GalaWindowOverviewClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowOverviewPrivate {
	GalaWindowManager* _wm;
	GalaModalProxy* modal_proxy;
	GList* workspaces;
	GalaWindowCloneContainer* window_clone_container;
};

struct _Block74Data {
	int _ref_count_;
	GalaWindowOverview* self;
	MetaWindow* window;
};

static gint GalaWindowOverview_private_offset;
static gpointer gala_window_overview_parent_class = NULL;
static GalaActivatableComponentIface * gala_window_overview_gala_activatable_component_parent_iface = NULL;

VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
VALA_EXTERN GType gala_window_clone_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowCloneContainer, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
static gboolean gala_window_overview_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static gboolean gala_window_overview_real_button_release_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_window_overview_real_is_opened (GalaActivatableComponent* base);
static void gala_window_overview_real_open (GalaActivatableComponent* base,
                                     GHashTable* hints);
VALA_EXTERN GalaWindowManager* gala_window_overview_get_wm (GalaWindowOverview* self);
static guint64* _variant_get1 (GVariant* value,
                        gint* result_length1);
VALA_EXTERN gboolean gala_notification_stack_is_notification (MetaWindow* window);
static gboolean _vala_uint64_array_contains (guint64 * stack,
                                      gssize stack_length,
                                      const guint64 needle);
static void gala_window_overview_add_window (GalaWindowOverview* self,
                                      MetaWindow* window);
static void _gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void gala_window_overview_remove_window (GalaWindowOverview* self,
                                         MetaWindow* window);
static void _gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                        MetaWindow* object,
                                                                        gpointer self);
static void gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                               gint num,
                                               MetaWindow* window);
static void _gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                 gint object,
                                                                                 MetaWindow* p0,
                                                                                 gpointer self);
static gboolean gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                                 MetaKeyBinding* binding);
static gboolean _gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                         gpointer self);
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_new (MetaDisplay* display,
                                                           GalaGestureTracker* gesture_tracker,
                                                           gfloat scale,
                                                           gboolean overview_mode);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_construct (GType object_type,
                                                                 MetaDisplay* display,
                                                                 GalaGestureTracker* gesture_tracker,
                                                                 gfloat scale,
                                                                 gboolean overview_mode);
VALA_EXTERN void gala_window_clone_container_set_padding_top (GalaWindowCloneContainer* self,
                                                  gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_left (GalaWindowCloneContainer* self,
                                                   gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_right (GalaWindowCloneContainer* self,
                                                    gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_bottom (GalaWindowCloneContainer* self,
                                                     gint value);
static void gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                          MetaWindow* window);
static void _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                       MetaWindow* window,
                                                                                       gpointer self);
static void _____lambda178_ (GalaWindowOverview* self);
static void ______lambda178__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                                   gpointer self);
VALA_EXTERN void gala_window_clone_container_add_window (GalaWindowCloneContainer* self,
                                             MetaWindow* window);
VALA_EXTERN void gala_window_clone_container_open (GalaWindowCloneContainer* self,
                                       MetaWindow* selected_window,
                                       gboolean with_gesture,
                                       gboolean is_cancel_animation);
static void gala_window_overview_restack_windows (GalaWindowOverview* self);
VALA_EXTERN void gala_window_clone_container_restack_windows (GalaWindowCloneContainer* self);
VALA_EXTERN void gala_window_clone_container_remove_window (GalaWindowCloneContainer* self,
                                                MetaWindow* window);
static Block74Data* block74_data_ref (Block74Data* _data74_);
static void block74_data_unref (void * _userdata_);
static gboolean ___lambda177_ (Block74Data* _data74_);
static gboolean ____lambda177__gsource_func (gpointer self);
static void gala_window_overview_real_close (GalaActivatableComponent* base,
                                      GHashTable* hints);
VALA_EXTERN void gala_window_clone_container_close (GalaWindowCloneContainer* self,
                                        gboolean with_gesture,
                                        gboolean is_cancel_animation);
static gboolean __lambda176_ (GalaWindowOverview* self);
static void gala_window_overview_cleanup (GalaWindowOverview* self);
static gboolean ___lambda176__gsource_func (gpointer self);
static void gala_window_overview_set_wm (GalaWindowOverview* self,
                                  GalaWindowManager* value);
static GObject * gala_window_overview_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_window_overview_finalize (GObject * obj);
static GType gala_window_overview_get_type_once (void);
static void _vala_gala_window_overview_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_overview_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_overview_get_instance_private (GalaWindowOverview* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowOverview_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 17 "../src/Widgets/WindowOverview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 237 "WindowOverview.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 17 "../src/Widgets/WindowOverview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 245 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowOverview * self = NULL;
#line 20 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 21 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) g_object_new (object_type, "wm", wm, NULL);
#line 20 "../src/Widgets/WindowOverview.vala"
	return self;
#line 259 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_new (GalaWindowManager* wm)
{
#line 20 "../src/Widgets/WindowOverview.vala"
	return gala_window_overview_construct (GALA_TYPE_WINDOW_OVERVIEW, wm);
#line 267 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowOverview * self;
	GalaWindowCloneContainer* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 31 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 31 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 35 "../src/Widgets/WindowOverview.vala"
	if (!gala_activatable_component_is_opened ((GalaActivatableComponent*) self)) {
#line 36 "../src/Widgets/WindowOverview.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 36 "../src/Widgets/WindowOverview.vala"
		return result;
#line 288 "WindowOverview.c"
	}
#line 39 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->window_clone_container;
#line 39 "../src/Widgets/WindowOverview.vala"
	g_signal_emit_by_name ((ClutterActor*) _tmp0_, "key-press-event", event, &_tmp1_);
#line 39 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 39 "../src/Widgets/WindowOverview.vala"
	return result;
#line 298 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_button_release_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 43 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 43 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 47 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 48 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 315 "WindowOverview.c"
	}
#line 51 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_STOP;
#line 51 "../src/Widgets/WindowOverview.vala"
	return result;
#line 321 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
gala_window_overview_real_is_opened (GalaActivatableComponent* base)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 57 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 58 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 58 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 58 "../src/Widgets/WindowOverview.vala"
	return result;
#line 344 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../src/Widgets/WindowOverview.vala"
	return self ? g_object_ref (self) : NULL;
#line 355 "WindowOverview.c"
}

static guint64*
_variant_get1 (GVariant* value,
               gint* result_length1)
{
	guint64* _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (guint64, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 73 "../src/Widgets/WindowOverview.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 73 "../src/Widgets/WindowOverview.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 73 "../src/Widgets/WindowOverview.vala"
		if (_tmp0__size == _tmp0__length) {
#line 73 "../src/Widgets/WindowOverview.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 73 "../src/Widgets/WindowOverview.vala"
			_tmp0_ = g_renew (guint64, _tmp0_, _tmp0__size + 1);
#line 382 "WindowOverview.c"
		}
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp0_[_tmp0__length++] = g_variant_get_uint64 (_tmp2_);
#line 73 "../src/Widgets/WindowOverview.vala"
		g_variant_unref (_tmp2_);
#line 388 "WindowOverview.c"
	}
#line 73 "../src/Widgets/WindowOverview.vala"
	*result_length1 = _tmp0__length1;
#line 73 "../src/Widgets/WindowOverview.vala"
	return _tmp0_;
#line 394 "WindowOverview.c"
}

static gboolean
_vala_uint64_array_contains (guint64 * stack,
                             gssize stack_length,
                             const guint64 needle)
{
	gssize i;
#line 86 "../src/Widgets/WindowOverview.vala"
	for (i = 0; i < stack_length; i++) {
#line 86 "../src/Widgets/WindowOverview.vala"
		if (needle == stack[i]) {
#line 86 "../src/Widgets/WindowOverview.vala"
			return TRUE;
#line 409 "WindowOverview.c"
		}
	}
#line 86 "../src/Widgets/WindowOverview.vala"
	return FALSE;
#line 414 "WindowOverview.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5297 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5297 "glib-2.0.vapi"
	return result;
#line 425 "WindowOverview.c"
}

static void
_gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 109 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_add_window ((GalaWindowOverview*) self, object);
#line 435 "WindowOverview.c"
}

static void
_gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self)
{
#line 110 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_remove_window ((GalaWindowOverview*) self, object);
#line 445 "WindowOverview.c"
}

static void
_gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                            gint object,
                                                                            MetaWindow* p0,
                                                                            gpointer self)
{
#line 113 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_window_left_monitor ((GalaWindowOverview*) self, object, p0);
#line 456 "WindowOverview.c"
}

static gboolean
_gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_overview_keybinding_filter ((GalaWindowOverview*) self, binding);
#line 118 "../src/Widgets/WindowOverview.vala"
	return result;
#line 467 "WindowOverview.c"
}

static void
_gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                  MetaWindow* window,
                                                                                  gpointer self)
{
#line 136 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_thumb_selected ((GalaWindowOverview*) self, window);
#line 477 "WindowOverview.c"
}

static void
_____lambda178_ (GalaWindowOverview* self)
{
#line 137 "../src/Widgets/WindowOverview.vala"
	gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 485 "WindowOverview.c"
}

static void
______lambda178__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                              gpointer self)
{
#line 137 "../src/Widgets/WindowOverview.vala"
	_____lambda178_ ((GalaWindowOverview*) self);
#line 494 "WindowOverview.c"
}

static void
gala_window_overview_real_open (GalaActivatableComponent* base,
                                GHashTable* hints)
{
	GalaWindowOverview * self;
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* _tmp4_;
	guint64* window_ids = NULL;
	gint window_ids_length1;
	gint _window_ids_size_;
	gboolean _tmp7_ = FALSE;
	GList* windows = NULL;
	GList* _tmp10_;
	GList* _tmp45_;
	GList* _tmp46_;
	GalaWindowManager* _tmp50_;
	MetaDisplay* _tmp51_;
	GalaWindowManager* _tmp52_;
	GalaModalProxy* _tmp53_;
	GalaModalProxy* _tmp54_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp55_;
	MetaDisplay* _tmp56_;
	GList* _tmp72_;
#line 64 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 65 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 65 "../src/Widgets/WindowOverview.vala"
	self->priv->workspaces = NULL;
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 66 "../src/Widgets/WindowOverview.vala"
	manager = _tmp2_;
#line 67 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = manager;
#line 67 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_workspace_manager_get_workspaces (_tmp3_);
#line 543 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 67 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp4_;
#line 67 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 551 "WindowOverview.c"
			MetaWorkspace* workspace = NULL;
#line 67 "../src/Widgets/WindowOverview.vala"
			workspace = (MetaWorkspace*) workspace_it->data;
#line 555 "WindowOverview.c"
			{
				MetaWorkspace* _tmp5_;
				MetaWorkspace* _tmp6_;
#line 68 "../src/Widgets/WindowOverview.vala"
				_tmp5_ = workspace;
#line 68 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 68 "../src/Widgets/WindowOverview.vala"
				self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp6_);
#line 565 "WindowOverview.c"
			}
		}
	}
#line 71 "../src/Widgets/WindowOverview.vala"
	window_ids = NULL;
#line 71 "../src/Widgets/WindowOverview.vala"
	window_ids_length1 = 0;
#line 71 "../src/Widgets/WindowOverview.vala"
	_window_ids_size_ = window_ids_length1;
#line 72 "../src/Widgets/WindowOverview.vala"
	if (hints != NULL) {
#line 72 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = g_hash_table_contains (hints, "windows");
#line 579 "WindowOverview.c"
	} else {
#line 72 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = FALSE;
#line 583 "WindowOverview.c"
	}
#line 72 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 587 "WindowOverview.c"
		gconstpointer _tmp8_;
		guint64* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = g_hash_table_lookup (hints, "windows");
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = _variant_get1 ((GVariant*) _tmp8_, &_tmp9__length1);
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids = _tmp9_;
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids_length1 = _tmp9__length1;
#line 73 "../src/Widgets/WindowOverview.vala"
		_window_ids_size_ = window_ids_length1;
#line 603 "WindowOverview.c"
	}
#line 76 "../src/Widgets/WindowOverview.vala"
	windows = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = self->priv->workspaces;
#line 609 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp10_;
#line 77 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 617 "WindowOverview.c"
			MetaWorkspace* _tmp11_;
			MetaWorkspace* workspace = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
			_tmp11_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 77 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp11_;
#line 624 "WindowOverview.c"
			{
				MetaWorkspace* _tmp12_;
				GList* _tmp13_;
#line 78 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = workspace;
#line 78 "../src/Widgets/WindowOverview.vala"
				_tmp13_ = meta_workspace_list_windows (_tmp12_);
#line 632 "WindowOverview.c"
				{
					GList* window_collection = NULL;
					GList* window_it = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
					window_collection = _tmp13_;
#line 78 "../src/Widgets/WindowOverview.vala"
					for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 640 "WindowOverview.c"
						MetaWindow* window = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
						window = (MetaWindow*) window_it->data;
#line 644 "WindowOverview.c"
						{
							gboolean _tmp14_ = FALSE;
							MetaWindow* _tmp15_;
							MetaWindowType _tmp16_;
							MetaWindowType _tmp17_;
							gboolean _tmp19_ = FALSE;
							gboolean _tmp20_ = FALSE;
							gboolean _tmp21_ = FALSE;
							MetaWindow* _tmp22_;
							MetaWindowType _tmp23_;
							MetaWindowType _tmp24_;
							gboolean _tmp36_ = FALSE;
							MetaWindow* _tmp37_;
							gboolean _tmp38_;
							gboolean _tmp39_;
							MetaWindow* _tmp43_;
							MetaWindow* _tmp44_;
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp15_ = window;
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp16_ = meta_window_get_window_type (_tmp15_);
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp17_ = _tmp16_;
#line 79 "../src/Widgets/WindowOverview.vala"
							if (_tmp17_ == META_WINDOW_DOCK) {
#line 79 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = TRUE;
#line 672 "WindowOverview.c"
							} else {
								MetaWindow* _tmp18_;
#line 79 "../src/Widgets/WindowOverview.vala"
								_tmp18_ = window;
#line 79 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = gala_notification_stack_is_notification (_tmp18_);
#line 679 "WindowOverview.c"
							}
#line 79 "../src/Widgets/WindowOverview.vala"
							if (_tmp14_) {
#line 80 "../src/Widgets/WindowOverview.vala"
								continue;
#line 685 "WindowOverview.c"
							}
#line 83 "../src/Widgets/WindowOverview.vala"
							_tmp22_ = window;
#line 83 "../src/Widgets/WindowOverview.vala"
							_tmp23_ = meta_window_get_window_type (_tmp22_);
#line 83 "../src/Widgets/WindowOverview.vala"
							_tmp24_ = _tmp23_;
#line 83 "../src/Widgets/WindowOverview.vala"
							if (_tmp24_ != META_WINDOW_NORMAL) {
#line 695 "WindowOverview.c"
								MetaWindow* _tmp25_;
								MetaWindowType _tmp26_;
								MetaWindowType _tmp27_;
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp25_ = window;
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp26_ = meta_window_get_window_type (_tmp25_);
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp27_ = _tmp26_;
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = _tmp27_ != META_WINDOW_DIALOG;
#line 707 "WindowOverview.c"
							} else {
#line 83 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = FALSE;
#line 711 "WindowOverview.c"
							}
#line 83 "../src/Widgets/WindowOverview.vala"
							if (_tmp21_) {
#line 83 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = TRUE;
#line 717 "WindowOverview.c"
							} else {
								MetaWindow* _tmp28_;
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp28_ = window;
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = meta_window_is_attached_dialog (_tmp28_);
#line 724 "WindowOverview.c"
							}
#line 83 "../src/Widgets/WindowOverview.vala"
							if (_tmp20_) {
#line 83 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = TRUE;
#line 730 "WindowOverview.c"
							} else {
								gboolean _tmp29_ = FALSE;
								guint64* _tmp30_;
								gint _tmp30__length1;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = window_ids;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp30__length1 = window_ids_length1;
#line 86 "../src/Widgets/WindowOverview.vala"
								if (_tmp30_ != NULL) {
#line 741 "WindowOverview.c"
									MetaWindow* _tmp31_;
									guint64* _tmp32_;
									gint _tmp32__length1;
#line 86 "../src/Widgets/WindowOverview.vala"
									_tmp31_ = window;
#line 86 "../src/Widgets/WindowOverview.vala"
									_tmp32_ = window_ids;
#line 86 "../src/Widgets/WindowOverview.vala"
									_tmp32__length1 = window_ids_length1;
#line 86 "../src/Widgets/WindowOverview.vala"
									_tmp29_ = !_vala_uint64_array_contains (_tmp32_, _tmp32__length1, meta_window_get_id (_tmp31_));
#line 753 "WindowOverview.c"
								} else {
#line 86 "../src/Widgets/WindowOverview.vala"
									_tmp29_ = FALSE;
#line 757 "WindowOverview.c"
								}
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = _tmp29_;
#line 761 "WindowOverview.c"
							}
#line 83 "../src/Widgets/WindowOverview.vala"
							if (_tmp19_) {
#line 765 "WindowOverview.c"
								MetaWindowActor* actor = NULL;
								MetaWindow* _tmp33_;
								GObject* _tmp34_;
								MetaWindowActor* _tmp35_;
#line 88 "../src/Widgets/WindowOverview.vala"
								_tmp33_ = window;
#line 88 "../src/Widgets/WindowOverview.vala"
								_tmp34_ = meta_window_get_compositor_private (_tmp33_);
#line 88 "../src/Widgets/WindowOverview.vala"
								actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, meta_window_actor_get_type (), MetaWindowActor);
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp35_ = actor;
#line 89 "../src/Widgets/WindowOverview.vala"
								clutter_actor_hide ((ClutterActor*) _tmp35_);
#line 91 "../src/Widgets/WindowOverview.vala"
								continue;
#line 782 "WindowOverview.c"
							}
#line 96 "../src/Widgets/WindowOverview.vala"
							_tmp37_ = window;
#line 96 "../src/Widgets/WindowOverview.vala"
							g_object_get (_tmp37_, "on-all-workspaces", &_tmp38_, NULL);
#line 96 "../src/Widgets/WindowOverview.vala"
							_tmp39_ = _tmp38_;
#line 96 "../src/Widgets/WindowOverview.vala"
							if (_tmp39_) {
#line 792 "WindowOverview.c"
								MetaWindow* _tmp40_;
								MetaWorkspace* _tmp41_;
								MetaWorkspace* _tmp42_;
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp40_ = window;
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp41_ = meta_window_get_workspace (_tmp40_);
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp42_ = workspace;
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = _tmp41_ != _tmp42_;
#line 804 "WindowOverview.c"
							} else {
#line 96 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = FALSE;
#line 808 "WindowOverview.c"
							}
#line 96 "../src/Widgets/WindowOverview.vala"
							if (_tmp36_) {
#line 97 "../src/Widgets/WindowOverview.vala"
								continue;
#line 814 "WindowOverview.c"
							}
#line 100 "../src/Widgets/WindowOverview.vala"
							_tmp43_ = window;
#line 100 "../src/Widgets/WindowOverview.vala"
							_tmp44_ = _g_object_ref0 (_tmp43_);
#line 100 "../src/Widgets/WindowOverview.vala"
							windows = g_list_append (windows, _tmp44_);
#line 822 "WindowOverview.c"
						}
					}
#line 78 "../src/Widgets/WindowOverview.vala"
					(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 827 "WindowOverview.c"
				}
#line 77 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 831 "WindowOverview.c"
			}
		}
	}
#line 104 "../src/Widgets/WindowOverview.vala"
	_tmp45_ = windows;
#line 104 "../src/Widgets/WindowOverview.vala"
	if (vala_g_list_is_empty (_tmp45_)) {
#line 105 "../src/Widgets/WindowOverview.vala"
		(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 105 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 105 "../src/Widgets/WindowOverview.vala"
		return;
#line 845 "WindowOverview.c"
	}
#line 108 "../src/Widgets/WindowOverview.vala"
	_tmp46_ = self->priv->workspaces;
#line 849 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 108 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp46_;
#line 108 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 857 "WindowOverview.c"
			MetaWorkspace* _tmp47_;
			MetaWorkspace* workspace = NULL;
#line 108 "../src/Widgets/WindowOverview.vala"
			_tmp47_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 108 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp47_;
#line 864 "WindowOverview.c"
			{
				MetaWorkspace* _tmp48_;
				MetaWorkspace* _tmp49_;
#line 109 "../src/Widgets/WindowOverview.vala"
				_tmp48_ = workspace;
#line 109 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp48_, "window-added", (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self, 0);
#line 110 "../src/Widgets/WindowOverview.vala"
				_tmp49_ = workspace;
#line 110 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp49_, "window-removed", (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self, 0);
#line 108 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 878 "WindowOverview.c"
			}
		}
	}
#line 113 "../src/Widgets/WindowOverview.vala"
	_tmp50_ = self->priv->_wm;
#line 113 "../src/Widgets/WindowOverview.vala"
	_tmp51_ = meta_plugin_get_display ((MetaPlugin*) _tmp50_);
#line 113 "../src/Widgets/WindowOverview.vala"
	g_signal_connect_object (_tmp51_, "window-left-monitor", (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 115 "../src/Widgets/WindowOverview.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp52_ = self->priv->_wm;
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp53_ = gala_window_manager_push_modal (_tmp52_, (ClutterActor*) self);
#line 117 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 117 "../src/Widgets/WindowOverview.vala"
	self->priv->modal_proxy = _tmp53_;
#line 118 "../src/Widgets/WindowOverview.vala"
	_tmp54_ = self->priv->modal_proxy;
#line 118 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp54_, _gala_window_overview_keybinding_filter_gala_keybinding_filter, self);
#line 120 "../src/Widgets/WindowOverview.vala"
	_tmp55_ = self->priv->_wm;
#line 120 "../src/Widgets/WindowOverview.vala"
	_tmp56_ = meta_plugin_get_display ((MetaPlugin*) _tmp55_);
#line 120 "../src/Widgets/WindowOverview.vala"
	display = _tmp56_;
#line 908 "WindowOverview.c"
	{
		gint i = 0;
#line 122 "../src/Widgets/WindowOverview.vala"
		i = 0;
#line 913 "WindowOverview.c"
		{
			gboolean _tmp57_ = FALSE;
#line 122 "../src/Widgets/WindowOverview.vala"
			_tmp57_ = TRUE;
#line 122 "../src/Widgets/WindowOverview.vala"
			while (TRUE) {
#line 920 "WindowOverview.c"
				MetaDisplay* _tmp59_;
				MtkRectangle geometry = {0};
				MetaDisplay* _tmp60_;
				MtkRectangle _tmp61_ = {0};
				gfloat scale = 0.0F;
				MetaDisplay* _tmp62_;
				MetaDisplay* _tmp63_;
				MtkRectangle _tmp64_;
				MtkRectangle _tmp65_;
				MtkRectangle _tmp66_;
				MtkRectangle _tmp67_;
				GalaWindowCloneContainer* _tmp68_ = NULL;
				GalaWindowCloneContainer* _tmp69_;
				GalaWindowCloneContainer* _tmp70_;
				GalaWindowCloneContainer* _tmp71_;
#line 122 "../src/Widgets/WindowOverview.vala"
				if (!_tmp57_) {
#line 938 "WindowOverview.c"
					gint _tmp58_;
#line 122 "../src/Widgets/WindowOverview.vala"
					_tmp58_ = i;
#line 122 "../src/Widgets/WindowOverview.vala"
					i = _tmp58_ + 1;
#line 944 "WindowOverview.c"
				}
#line 122 "../src/Widgets/WindowOverview.vala"
				_tmp57_ = FALSE;
#line 122 "../src/Widgets/WindowOverview.vala"
				_tmp59_ = display;
#line 122 "../src/Widgets/WindowOverview.vala"
				if (!(i < meta_display_get_n_monitors (_tmp59_))) {
#line 122 "../src/Widgets/WindowOverview.vala"
					break;
#line 954 "WindowOverview.c"
				}
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp60_ = display;
#line 123 "../src/Widgets/WindowOverview.vala"
				meta_display_get_monitor_geometry (_tmp60_, i, &_tmp61_);
#line 123 "../src/Widgets/WindowOverview.vala"
				geometry = _tmp61_;
#line 124 "../src/Widgets/WindowOverview.vala"
				_tmp62_ = display;
#line 124 "../src/Widgets/WindowOverview.vala"
				scale = meta_display_get_monitor_scale (_tmp62_, i);
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp63_ = display;
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp64_ = geometry;
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp65_ = geometry;
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp66_ = geometry;
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp67_ = geometry;
#line 126 "../src/Widgets/WindowOverview.vala"
				_tmp68_ = gala_window_clone_container_new (_tmp63_, NULL, scale, TRUE);
#line 126 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_top (_tmp68_, GALA_WINDOW_OVERVIEW_TOP_GAP);
#line 126 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_left (_tmp68_, GALA_WINDOW_OVERVIEW_BORDER);
#line 126 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_right (_tmp68_, GALA_WINDOW_OVERVIEW_BORDER);
#line 126 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_bottom (_tmp68_, GALA_WINDOW_OVERVIEW_BOTTOM_GAP);
#line 126 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_width ((ClutterActor*) _tmp68_, (gfloat) _tmp64_.width);
#line 126 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_height ((ClutterActor*) _tmp68_, (gfloat) _tmp65_.height);
#line 126 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_x ((ClutterActor*) _tmp68_, (gfloat) _tmp66_.x);
#line 126 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_y ((ClutterActor*) _tmp68_, (gfloat) _tmp67_.y);
#line 126 "../src/Widgets/WindowOverview.vala"
				g_object_ref_sink (_tmp68_);
#line 126 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (self->priv->window_clone_container);
#line 126 "../src/Widgets/WindowOverview.vala"
				self->priv->window_clone_container = _tmp68_;
#line 136 "../src/Widgets/WindowOverview.vala"
				_tmp69_ = self->priv->window_clone_container;
#line 136 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp69_, "window-selected", (GCallback) _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected, self, 0);
#line 137 "../src/Widgets/WindowOverview.vala"
				_tmp70_ = self->priv->window_clone_container;
#line 137 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp70_, "requested-close", (GCallback) ______lambda178__gala_window_clone_container_requested_close, self, 0);
#line 139 "../src/Widgets/WindowOverview.vala"
				_tmp71_ = self->priv->window_clone_container;
#line 139 "../src/Widgets/WindowOverview.vala"
				clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp71_);
#line 1012 "WindowOverview.c"
			}
		}
	}
#line 142 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 144 "../src/Widgets/WindowOverview.vala"
	_tmp72_ = windows;
#line 1020 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 144 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp72_;
#line 144 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1028 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 144 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1032 "WindowOverview.c"
			{
				MetaWindowActor* actor = NULL;
				MetaWindow* _tmp73_;
				GObject* _tmp74_;
				MetaWindowActor* _tmp75_;
				GalaWindowCloneContainer* container = NULL;
				MetaWindow* _tmp76_;
				ClutterActor* _tmp77_;
				GalaWindowCloneContainer* _tmp78_;
				GalaWindowCloneContainer* _tmp79_;
				MetaWindow* _tmp80_;
				GalaWindowCloneContainer* _tmp81_;
				MetaDisplay* _tmp82_;
				MetaWindow* _tmp83_;
#line 145 "../src/Widgets/WindowOverview.vala"
				_tmp73_ = window;
#line 145 "../src/Widgets/WindowOverview.vala"
				_tmp74_ = meta_window_get_compositor_private (_tmp73_);
#line 145 "../src/Widgets/WindowOverview.vala"
				actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, meta_window_actor_get_type (), MetaWindowActor);
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp75_ = actor;
#line 146 "../src/Widgets/WindowOverview.vala"
				clutter_actor_hide ((ClutterActor*) _tmp75_);
#line 148 "../src/Widgets/WindowOverview.vala"
				_tmp76_ = window;
#line 148 "../src/Widgets/WindowOverview.vala"
				_tmp77_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (_tmp76_));
#line 148 "../src/Widgets/WindowOverview.vala"
				container = G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 149 "../src/Widgets/WindowOverview.vala"
				_tmp78_ = container;
#line 149 "../src/Widgets/WindowOverview.vala"
				if (_tmp78_ == NULL) {
#line 150 "../src/Widgets/WindowOverview.vala"
					continue;
#line 1069 "WindowOverview.c"
				}
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp79_ = container;
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp80_ = window;
#line 153 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_add_window (_tmp79_, _tmp80_);
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp81_ = container;
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp82_ = display;
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp83_ = meta_display_get_focus_window (_tmp82_);
#line 154 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_open (_tmp81_, _tmp83_, FALSE, FALSE);
#line 1085 "WindowOverview.c"
			}
		}
	}
#line 64 "../src/Widgets/WindowOverview.vala"
	(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 64 "../src/Widgets/WindowOverview.vala"
	window_ids = (g_free (window_ids), NULL);
#line 1093 "WindowOverview.c"
}

static gboolean
gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                        MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 169 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label0 = 0;
#line 169 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label1 = 0;
#line 169 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label2 = 0;
#line 1111 "WindowOverview.c"
	gboolean result;
#line 158 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 159 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 159 "../src/Widgets/WindowOverview.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 161 "../src/Widgets/WindowOverview.vala"
	switch (action) {
#line 161 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 161 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 1127 "WindowOverview.c"
		{
#line 164 "../src/Widgets/WindowOverview.vala"
			result = FALSE;
#line 164 "../src/Widgets/WindowOverview.vala"
			return result;
#line 1133 "WindowOverview.c"
		}
		default:
		{
#line 166 "../src/Widgets/WindowOverview.vala"
			break;
#line 1139 "WindowOverview.c"
		}
	}
#line 169 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 169 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 169 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 169 "../src/Widgets/WindowOverview.vala"
	if (((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("expose-all-windows")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("zoom-in"))))) || (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("zoom-out"))))) {
#line 169 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1152 "WindowOverview.c"
			default:
			{
#line 173 "../src/Widgets/WindowOverview.vala"
				result = FALSE;
#line 173 "../src/Widgets/WindowOverview.vala"
				return result;
#line 1159 "WindowOverview.c"
			}
		}
	} else {
#line 169 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1165 "WindowOverview.c"
			default:
			{
#line 175 "../src/Widgets/WindowOverview.vala"
				break;
#line 1170 "WindowOverview.c"
			}
		}
	}
#line 178 "../src/Widgets/WindowOverview.vala"
	result = TRUE;
#line 178 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1178 "WindowOverview.c"
}

static void
gala_window_overview_restack_windows (GalaWindowOverview* self)
{
	GList* _tmp0_;
#line 181 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1189 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 182 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp0_;
#line 182 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1197 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 182 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1201 "WindowOverview.c"
			{
				ClutterActor* _tmp1_;
#line 183 "../src/Widgets/WindowOverview.vala"
				_tmp1_ = child;
#line 183 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_restack_windows (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer));
#line 1208 "WindowOverview.c"
			}
		}
#line 182 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1213 "WindowOverview.c"
	}
}

static void
gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                          gint num,
                                          MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GList* _tmp2_;
#line 187 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 188 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, num);
#line 188 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 189 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 189 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 190 "../src/Widgets/WindowOverview.vala"
		return;
#line 1240 "WindowOverview.c"
	}
#line 194 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1244 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 194 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 194 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1252 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 194 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 194 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1259 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
#line 195 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 195 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp4_)) {
#line 1266 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp5_;
#line 196 "../src/Widgets/WindowOverview.vala"
					_tmp5_ = container;
#line 196 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_remove_window (_tmp5_, window);
#line 197 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 197 "../src/Widgets/WindowOverview.vala"
					break;
#line 1276 "WindowOverview.c"
				}
#line 194 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1280 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_add_window (GalaWindowOverview* self,
                                 MetaWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MetaWindowType _tmp7_;
	MetaWindowType _tmp8_;
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp13_;
	GalaWindowCloneContainer* _tmp14_;
	GList* _tmp15_;
#line 202 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 203 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 203 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 203 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 204 "../src/Widgets/WindowOverview.vala"
		return;
#line 1315 "WindowOverview.c"
	}
#line 206 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_window_get_window_type (window);
#line 206 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = _tmp3_;
#line 206 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == META_WINDOW_DOCK) {
#line 206 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = TRUE;
#line 1325 "WindowOverview.c"
	} else {
#line 206 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = gala_notification_stack_is_notification (window);
#line 1329 "WindowOverview.c"
	}
#line 206 "../src/Widgets/WindowOverview.vala"
	if (_tmp2_) {
#line 207 "../src/Widgets/WindowOverview.vala"
		return;
#line 1335 "WindowOverview.c"
	}
#line 209 "../src/Widgets/WindowOverview.vala"
	_tmp7_ = meta_window_get_window_type (window);
#line 209 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = _tmp7_;
#line 209 "../src/Widgets/WindowOverview.vala"
	if (_tmp8_ != META_WINDOW_NORMAL) {
#line 1343 "WindowOverview.c"
		MetaWindowType _tmp9_;
		MetaWindowType _tmp10_;
#line 210 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = meta_window_get_window_type (window);
#line 210 "../src/Widgets/WindowOverview.vala"
		_tmp10_ = _tmp9_;
#line 210 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = _tmp10_ != META_WINDOW_DIALOG;
#line 1352 "WindowOverview.c"
	} else {
#line 209 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = FALSE;
#line 1356 "WindowOverview.c"
	}
#line 209 "../src/Widgets/WindowOverview.vala"
	if (_tmp6_) {
#line 209 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = TRUE;
#line 1362 "WindowOverview.c"
	} else {
#line 211 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_window_is_attached_dialog (window);
#line 1366 "WindowOverview.c"
	}
#line 209 "../src/Widgets/WindowOverview.vala"
	if (_tmp5_) {
#line 1370 "WindowOverview.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp11_;
		MetaWindowActor* _tmp12_;
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp11_ = meta_window_get_compositor_private (window);
#line 212 "../src/Widgets/WindowOverview.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, meta_window_actor_get_type (), MetaWindowActor);
#line 213 "../src/Widgets/WindowOverview.vala"
		_tmp12_ = actor;
#line 213 "../src/Widgets/WindowOverview.vala"
		clutter_actor_hide ((ClutterActor*) _tmp12_);
#line 215 "../src/Widgets/WindowOverview.vala"
		return;
#line 1384 "WindowOverview.c"
	}
#line 218 "../src/Widgets/WindowOverview.vala"
	_tmp13_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 218 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 219 "../src/Widgets/WindowOverview.vala"
	_tmp14_ = container;
#line 219 "../src/Widgets/WindowOverview.vala"
	if (_tmp14_ == NULL) {
#line 220 "../src/Widgets/WindowOverview.vala"
		return;
#line 1396 "WindowOverview.c"
	}
#line 224 "../src/Widgets/WindowOverview.vala"
	_tmp15_ = self->priv->workspaces;
#line 1400 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 224 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp15_;
#line 224 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1408 "WindowOverview.c"
			MetaWorkspace* _tmp16_;
			MetaWorkspace* workspace = NULL;
#line 224 "../src/Widgets/WindowOverview.vala"
			_tmp16_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 224 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp16_;
#line 1415 "WindowOverview.c"
			{
				MetaWorkspace* _tmp17_;
#line 225 "../src/Widgets/WindowOverview.vala"
				_tmp17_ = workspace;
#line 225 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp17_)) {
#line 1422 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp18_;
#line 226 "../src/Widgets/WindowOverview.vala"
					_tmp18_ = container;
#line 226 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_add_window (_tmp18_, window);
#line 227 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 227 "../src/Widgets/WindowOverview.vala"
					break;
#line 1432 "WindowOverview.c"
				}
#line 224 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1436 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_remove_window (GalaWindowOverview* self,
                                    MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GalaWindowCloneContainer* _tmp2_;
#line 232 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 233 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 233 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 234 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 234 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 235 "../src/Widgets/WindowOverview.vala"
		return;
#line 1464 "WindowOverview.c"
	}
#line 238 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = container;
#line 238 "../src/Widgets/WindowOverview.vala"
	gala_window_clone_container_remove_window (_tmp2_, window);
#line 1470 "WindowOverview.c"
}

static Block74Data*
block74_data_ref (Block74Data* _data74_)
{
#line 241 "../src/Widgets/WindowOverview.vala"
	g_atomic_int_inc (&_data74_->_ref_count_);
#line 241 "../src/Widgets/WindowOverview.vala"
	return _data74_;
#line 1480 "WindowOverview.c"
}

static void
block74_data_unref (void * _userdata_)
{
	Block74Data* _data74_;
	_data74_ = (Block74Data*) _userdata_;
#line 241 "../src/Widgets/WindowOverview.vala"
	if (g_atomic_int_dec_and_test (&_data74_->_ref_count_)) {
#line 1490 "WindowOverview.c"
		GalaWindowOverview* self;
#line 241 "../src/Widgets/WindowOverview.vala"
		self = _data74_->self;
#line 241 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (_data74_->window);
#line 241 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self);
#line 241 "../src/Widgets/WindowOverview.vala"
		g_slice_free (Block74Data, _data74_);
#line 1500 "WindowOverview.c"
	}
}

static gboolean
___lambda177_ (Block74Data* _data74_)
{
	GalaWindowOverview* self;
	MetaWorkspace* _tmp0_;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 249 "../src/Widgets/WindowOverview.vala"
	self = _data74_->self;
#line 250 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_window_get_workspace (_data74_->window);
#line 250 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_display (_data74_->window);
#line 250 "../src/Widgets/WindowOverview.vala"
	meta_workspace_activate_with_focus (_tmp0_, _data74_->window, meta_display_get_current_time (_tmp1_));
#line 251 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 251 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1523 "WindowOverview.c"
}

static gboolean
____lambda177__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda177_ (self);
#line 249 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1533 "WindowOverview.c"
}

static void
gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                     MetaWindow* window)
{
	Block74Data* _data74_;
	MetaWindow* _tmp0_;
	MetaWorkspace* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
#line 241 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 241 "../src/Widgets/WindowOverview.vala"
	_data74_ = g_slice_new0 (Block74Data);
#line 241 "../src/Widgets/WindowOverview.vala"
	_data74_->_ref_count_ = 1;
#line 241 "../src/Widgets/WindowOverview.vala"
	_data74_->self = g_object_ref (self);
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 241 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (_data74_->window);
#line 241 "../src/Widgets/WindowOverview.vala"
	_data74_->window = _tmp0_;
#line 242 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_workspace (_data74_->window);
#line 242 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 242 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 242 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 242 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 242 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == _tmp5_) {
#line 1575 "WindowOverview.c"
		MetaDisplay* _tmp6_;
#line 243 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = meta_window_get_display (_data74_->window);
#line 243 "../src/Widgets/WindowOverview.vala"
		meta_window_activate (_data74_->window, meta_display_get_current_time (_tmp6_));
#line 244 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 1583 "WindowOverview.c"
	} else {
#line 246 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 249 "../src/Widgets/WindowOverview.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ____lambda177__gsource_func, block74_data_ref (_data74_), block74_data_unref);
#line 1589 "WindowOverview.c"
	}
#line 241 "../src/Widgets/WindowOverview.vala"
	block74_data_unref (_data74_);
#line 241 "../src/Widgets/WindowOverview.vala"
	_data74_ = NULL;
#line 1595 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
__lambda176_ (GalaWindowOverview* self)
{
	gboolean result;
#line 277 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_cleanup (self);
#line 279 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 279 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1611 "WindowOverview.c"
}

static gboolean
___lambda176__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda176_ ((GalaWindowOverview*) self);
#line 276 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1621 "WindowOverview.c"
}

static void
gala_window_overview_real_close (GalaActivatableComponent* base,
                                 GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GList* _tmp2_;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	guint _tmp10_;
	GList* _tmp11_;
#line 259 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 260 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 260 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 260 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 261 "../src/Widgets/WindowOverview.vala"
		return;
#line 1646 "WindowOverview.c"
	}
#line 264 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_restack_windows (self);
#line 266 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1652 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 266 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 266 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1660 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 266 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 266 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1667 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
				guint _tmp5_;
				MetaWorkspace* _tmp6_;
				guint _tmp7_;
#line 267 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 267 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp5_, NULL, FALSE);
#line 267 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self);
#line 268 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = workspace;
#line 268 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 268 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self);
#line 266 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1687 "WindowOverview.c"
			}
		}
	}
#line 270 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = self->priv->_wm;
#line 270 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 270 "../src/Widgets/WindowOverview.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp10_, NULL, FALSE);
#line 270 "../src/Widgets/WindowOverview.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self);
#line 272 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1701 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 272 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp11_;
#line 272 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1709 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 272 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1713 "WindowOverview.c"
			{
				ClutterActor* _tmp12_;
#line 273 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = child;
#line 273 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_close (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer), FALSE, FALSE);
#line 1720 "WindowOverview.c"
			}
		}
#line 272 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1725 "WindowOverview.c"
	}
#line 276 "../src/Widgets/WindowOverview.vala"
	clutter_threads_add_timeout ((guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ___lambda176__gsource_func, self);
#line 1729 "WindowOverview.c"
}

static void
gala_window_overview_cleanup (GalaWindowOverview* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	GList* _tmp6_;
#line 283 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 286 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 286 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->modal_proxy;
#line 286 "../src/Widgets/WindowOverview.vala"
	gala_window_manager_pop_modal (_tmp0_, _tmp1_);
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp6_ = meta_workspace_list_windows (_tmp5_);
#line 1762 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 288 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp6_;
#line 288 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1770 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 288 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1774 "WindowOverview.c"
			{
				MetaWindow* _tmp7_;
#line 289 "../src/Widgets/WindowOverview.vala"
				_tmp7_ = window;
#line 289 "../src/Widgets/WindowOverview.vala"
				if (meta_window_showing_on_its_workspace (_tmp7_)) {
#line 1781 "WindowOverview.c"
					MetaWindow* _tmp8_;
					GObject* _tmp9_;
#line 290 "../src/Widgets/WindowOverview.vala"
					_tmp8_ = window;
#line 290 "../src/Widgets/WindowOverview.vala"
					_tmp9_ = meta_window_get_compositor_private (_tmp8_);
#line 290 "../src/Widgets/WindowOverview.vala"
					clutter_actor_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_actor_get_type (), ClutterActor));
#line 1790 "WindowOverview.c"
				}
			}
		}
#line 288 "../src/Widgets/WindowOverview.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1796 "WindowOverview.c"
	}
#line 294 "../src/Widgets/WindowOverview.vala"
	clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 1800 "WindowOverview.c"
}

GalaWindowManager*
gala_window_overview_get_wm (GalaWindowOverview* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 13 "../src/Widgets/WindowOverview.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1816 "WindowOverview.c"
}

static void
gala_window_overview_set_wm (GalaWindowOverview* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	old_value = gala_window_overview_get_wm (self);
#line 13 "../src/Widgets/WindowOverview.vala"
	if (old_value != value) {
#line 1830 "WindowOverview.c"
		GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self->priv->_wm);
#line 13 "../src/Widgets/WindowOverview.vala"
		self->priv->_wm = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY]);
#line 1840 "WindowOverview.c"
	}
}

static GObject *
gala_window_overview_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowOverview * self;
#line 24 "../src/Widgets/WindowOverview.vala"
	parent_class = G_OBJECT_CLASS (gala_window_overview_parent_class);
#line 24 "../src/Widgets/WindowOverview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 25 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 26 "../src/Widgets/WindowOverview.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 24 "../src/Widgets/WindowOverview.vala"
	return obj;
#line 1864 "WindowOverview.c"
}

static void
gala_window_overview_class_init (GalaWindowOverviewClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/WindowOverview.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowOverview_private_offset);
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_key_press_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_button_release_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_overview_get_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_overview_set_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_overview_constructor;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_overview_finalize;
#line 8 "../src/Widgets/WindowOverview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_OVERVIEW_WM_PROPERTY, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1889 "WindowOverview.c"
}

static void
gala_window_overview_gala_activatable_component_interface_init (GalaActivatableComponentIface * iface,
                                                                gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_activatable_component_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->is_opened = (gboolean (*) (GalaActivatableComponent*)) gala_window_overview_real_is_opened;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->open = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_open;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->close = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_close;
#line 1904 "WindowOverview.c"
}

static void
gala_window_overview_instance_init (GalaWindowOverview * self,
                                    gpointer klass)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	self->priv = gala_window_overview_get_instance_private (self);
#line 1913 "WindowOverview.c"
}

static void
gala_window_overview_finalize (GObject * obj)
{
	GalaWindowOverview * self;
#line 8 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 13 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->_wm);
#line 15 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 17 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 18 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->window_clone_container);
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (gala_window_overview_parent_class)->finalize (obj);
#line 1932 "WindowOverview.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_overview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowOverviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_overview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowOverview), 0, (GInstanceInitFunc) gala_window_overview_instance_init, NULL };
	static const GInterfaceInfo gala_activatable_component_info = { (GInterfaceInitFunc) gala_window_overview_gala_activatable_component_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_overview_type_id;
	gala_window_overview_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowOverview", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ACTIVATABLE_COMPONENT, &gala_activatable_component_info);
	GalaWindowOverview_private_offset = g_type_add_instance_private (gala_window_overview_type_id, sizeof (GalaWindowOverviewPrivate));
	return gala_window_overview_type_id;
}

GType
gala_window_overview_get_type (void)
{
	static gsize gala_window_overview_type_id__once = 0;
	if (g_once_init_enter (&gala_window_overview_type_id__once)) {
		GType gala_window_overview_type_id;
		gala_window_overview_type_id = gala_window_overview_get_type_once ();
		g_once_init_leave (&gala_window_overview_type_id__once, gala_window_overview_type_id);
	}
	return gala_window_overview_type_id__once;
}

static void
_vala_gala_window_overview_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		g_value_set_object (value, gala_window_overview_get_wm (self));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1975 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1981 "WindowOverview.c"
	}
}

static void
_vala_gala_window_overview_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		gala_window_overview_set_wm (self, g_value_get_object (value));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2001 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2007 "WindowOverview.c"
	}
}

